CSUBNIJX2 === file NIJX2.FOR = Part 2 of the NIJX subr. Updt: 30 Jan. 97
* Note: NIJX = NIJX1 + NIJX2              NIJX2 is computer independent.
* Note: for NIJX1 various versions are supplied: IBM, VAX/VMS, unix etc.
*-----------------------------------------------------------------------
* NIJX: REPROGRAMMED BY S.G.G. 1986, FORTRAN77 BY W.B. AND C.J. 1987
* BASED ON THE DIRDIF 1981 KERN SUBROUTINES 
*-----------------------------------------------------------------------
C List of subroutines and functions given in this FORTRAN deck. 
C Kern subroutines:  KEDATE, KETIME,
C    KERNAB, KERNAI, KERNZA, KERNZI, KERNZ1, KERNZ6, KEREQ1, KEREQ6,
C    KERC2I, KERI2C, KERI2F, KERF2I, KERC2U,
C    KEPROG, KEPROX, KERNER, KERROR,
C    KERINA, KERINB, KERINC, KERINF, KERIFF, KETERM, SHOUT, SHOUT2  
C File handling     : FILINQ, FILCLO
C    RDCRY SUBR.: RDCRYS, RDCRYB, RDCRYX, RCELLR, CELLRR, CELZAT
C    BINXX SUBR.: BINOX,  BINIX,  BINOFF, BINIFF
C    ATOMS SUBR.: ATOMIZ, ATOMCH, ATOMIN, ATOMIA, ATOMPR, ATOMWR,   
C         ATOMWA, ATOMWB, ATOMST, ATOMOC, ATBEQ,  ATBETA, CELZIN
C Control data I/O  : RDCOND, LOGWR,  LOGRD,  COPY80
C Various           : VALDIS, LINPRI, XHELP 
C Reflections   
C    ISELFD DISTSQ SYMOP1 SYMOP2 ISELFDX LOCKIN 
C    HKLSTL HKLEXS HKLEXT HKLEX1 HKLEX2 HKLEX3 HKLAXT   
C    HKLC1  (+ entry HKLC1U) HKLC2 (+ entries HKLC2I, HKLC2U)   
C    HKLC3  (+ entries: nog niet klaar / t.b.v. DIFTAN) 
C    FCALCI FCALC1 FCALC2 SICOT 
C maths routines:   
C    MACOL MATINV VMULT ERFU
C    MATC2F MATF2C VECAXB MATAXB MATAXI MAT6XV MATXV3 VXMATI VMATV1 
C PHASEX routines (also used in DDMAIN): IPHFIX, E2EXP, SIMW
C-----------------------------------------------------------------------
C PROGRAMMING CONVENTIONS and  GENERAL CONSIDERATIONS   
C - FORTRAN77   
C - IMPLICIT 'INTEGER' and 'REAL' conventions are used  
C - The name of a PROGRAM is defined as CHARACTER*8 
C - The name of a SUBROUTINE is defined as CHARACTER*6  
C - Note on lable conventions:  
C   1   -  99 reserved and used only in special cases   
C   100 - 999 on columns 3,4,5: normal use, in increasing order 
C - The first card of a SUBROUTINE or a FUNCTION subprogram is: 
C      CSUBROUTINE subprogname   ('CSUB'  on columns 1-4)   
C - GENERAL ORDER OF STATEMENTS IN SUBROUTINES: 
C      CSUBROUTINE ABCDX (IFX, KEY, A, N, ...., KEND)   
C      C--------------------------------------------------------------- 
C      CDefinitions of arguments  (Usual order: 
C      C   IFX  = Input/output file unit (if needed)
C      C   KEY  = Argument or input-option: variable or number  
C      C   A    = Array 
C      C   N    = Dimension of array A (if needed)  
C      C   KEND = Return key (variable !), may be   
C      C          used for data and error returns.  
C      CFurther comments, instructions for use, limitations, ...
C      CCalls: list of subroutines called by this routine   
C      C+---------------------------------------------------------------
C            SUBROUTINE ABCDX (...) 
C            DECLARATIONS   
C            RETURN 
C      C        END OF SUBROUTINE ABCDX 
C            END
C+----------------------------------------------------------------------
CSUBROUTINE KEDATE  
C-----------------------------------------------------------------------
C Subroutine to call the date                           example:
C Output:   /SYSTA/  storage:  ITIME(1) = YEAR       ))    1992 
C                              ITIME(2) = MONTH      ))       2 
C                              ITIME(3) = DAY        ))      24 
C Called by KEPROG : first call: print output to unit LIS2  
C               if called again: print output to unit LIS1  
C Calls: DATIME 
C+----------------------------------------------------------------------
      SUBROUTINE KEDATE 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
C     COMMON /SYSTB/ NOT USED   
      EQUIVALENCE (LIS1, IFILE(7)), (LIS2, IFILE(8))
      CHARACTER * 4  M(12)  
      DIMENSION L(12)   
      DATA M / 'Jan.',   'Feb.',   'Mar.',   'Apr.',   'May ',  'June', 
     +         'July',   'Aug.',   'Sep.',   'Oct.',   'Nov.',  'Dec.'/ 
      DATA    L  / 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31 / 
      DATA IPR /0/  
      IF (IPR .NE. 0) IPR = LIS1
      IF (IPR .EQ. 0) IPR = LIS2
C        THE FOLLOWING CALL FOR =DATIME= EXPECTS THE DAY-NUMBER 
C        RETURNED AS THE THIRD ARGUMENT.
C        EXAMPLE: THE NUMBER 84055 REPRESENTS THE 55-TH DAY IN 1984,
C        WHICH HAPPENS TO BE TH 24-TH OF FEBRUARY.  
C        THE dummy -DATIME- ROUTINE, GIVEN ABOVE, RETURNS ZERO'S.   
      CALL DATIME (I1, I2, I3)  
      CALL KERNZI (0, ITIME, 3) 
C        CHECK FOR dummy
      IF (I3.GT.0) GOTO 110 
      WRITE (LIS2, 100) 
  100 FORMAT (' TIME REPORT NOT AVAILABLE') 
      RETURN
  110 ITIME(1) = I3 / 1000 + 1900   
      IF (MOD(ITIME(1),4).EQ.0) L(2) = 29   
      IL = MOD(I3,1000) 
      DO 120 I=1,12 
      IF (IL.LE.L(I)) GOTO 130  
  120 IL = IL - L(I)
      I = 12
  130 ITIME(2) = I  
      ITIME(3) = IL 
      IHH = I1 / 100
      IMM = I1 - 100 * IHH  
      WRITE (IPR, 140) I3, IHH, IMM, IL, M(I), ITIME(1) 
  140 FORMAT (/7X, ' Day number:' ,I6, '. The time:', I3, ' h', I3, 
     *        ' min.', ' The date:', I3, ' ', A4, I5)   
      RETURN
C        END OF SUBROUTINE KEDATE   
      END   
CSUBROUTINE KETIME (IPRX)   
C-----------------------------------------------------------------------
C Subroutine to call the time  (CPU time, in msec)  
C Input : IPRX = printer unit number (usually IPRX = 7 or 8)
C                if IPRX = 0: the time will not be printed  
C Result in /SYSTA/ :  ITIME(4) = CPU time  (in msec) INTEGER   
C Called by -KEPROG- and other subroutines. 
C Calls: DATIME 
C+----------------------------------------------------------------------
      SUBROUTINE KETIME (IPRX)  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
C        IPRX IS NOT EQUIVALENCED TO COMMON /SYSTA/ BUT TRANSFERRED 
C        AS A PARAMETER:  IF IPRX.LE.0: DO NOT PRINT.   
      CHARACTER *4 MONTH(12)
      DATA MONTH / 'Jan.', 'Feb.', 'Mar.', 'Apr.', 'May ', 'June',  
     *             'July', 'Aug.', 'Sep.', 'Oct.', 'Nov.', 'Dec.'/  
C        SWITCH: IF ISW = 0: FIRST CALL: SET RELATIVE TIME TO ZERO. 
      DATA  ISW / 0 /   
C        Dummy DATA statement to avoid useless compiler warnings
      DATA IREL / 0 /   
C        THE FOLLOWING CALL FOR =DATIME= EXPECTS THE CPU TIME   
C        RETURNED AS THE SECOND ARGUMENT (AT PRESENT: IN msec)  
C        THE dummy -DATIME- ROUTINE, GIVEN ABOVE, RETURNS ZERO'S.   
      CALL DATIME (I1, I2, I3)  
C        CHECK dummy (IF dummy: =ITIME= HAS BEEN CLEARED BY -KEPROG-)   
      IF (I3.LE.0) RETURN   
C        CHECK FOR FIRST CALL   
      IF (ISW.NE.0) GOTO 100
      ISW = 1   
      IREL = I2 
  100 ITIME(4) = I2 - IREL  
C        DO NOT PRINT IF TIME = 0 OR IF IPRX = 0
      IF (ITIME(4).EQ.0 .OR. IPRX.LE.0) RETURN  
      F = FLOAT(ITIME(4)) / 1000.   
      M = ITIME(2)  
      WRITE (IPRX, 110) ITIME(3), MONTH(M), ITIME(1), PROGNM, F 
  110 FORMAT (/' Time report. Date: ', I3, 1X, A4, I5,  
     *        4X, 'CPU time used by ', A8, ':', F7.3, ' s') 
      RETURN
C        END OF SUBROUTINE KETIME   
      END   
CSUBROUTINE KERNAB (A, B, N)
C-----------------------------------------------------------------------
C Transport contents of array A to array B (N words)
C Input : A(N)  array to be copied  
C Output: B(N)  array with data copied from array A 
C Needed: N     dimension of A and B
C+----------------------------------------------------------------------
      SUBROUTINE KERNAB (A, B, N)   
      DIMENSION A(N), B(N)  
      DO 100 I=1,N  
  100 B(I) = A(I)   
      RETURN
C        END OF SUBROUTINE KERNAB   
      END   
CSUBROUTINE KERNAI (IA, IB, N)  
C-----------------------------------------------------------------------
C Transport contents of array IA to array IB (N words)  
C Input : IA(N)  array to be copied 
C Output: IB(N)  array with data copied from array IA   
C Needed: N      dimension of IA and IB 
C+----------------------------------------------------------------------
      SUBROUTINE KERNAI (IA, IB, N) 
      DIMENSION IA(N), IB(N)
      DO 100 I=1,N  
  100 IB(I) = IA(I) 
      RETURN
C        END OF SUBROUTINE KERNAI   
      END   
CSUBROUTINE KERNZA (X, A, N)
C-----------------------------------------------------------------------
C Fill array A with X (N words) 
C (usually zero's: X = 0.0) 
C Input : X 
C Output: A(N)   array filled with X (N equal words)
C Needed: N      dimension of A 
C+----------------------------------------------------------------------
      SUBROUTINE KERNZA (X, A, N)   
      DIMENSION A(N)
      DO 100 I=1,N  
  100 A(I) = X  
      RETURN
C        END OF SUBROUTINE KERNZA   
      END   
CSUBROUTINE KERNZI (IX, IA, N)  
C-----------------------------------------------------------------------
C Fill array IA with IX (N words) (usually zero's, IX = 0)  
C Input : IX
C Output: IA(N)   array filled with IX (N equal words)  
C Needed: N       dimension of IA   
C+----------------------------------------------------------------------
      SUBROUTINE KERNZI (IX, IA, N) 
      DIMENSION IA(N)   
      DO 100 I=1,N  
  100 IA(I) = IX
      RETURN
C        END OF SUBROUTINE KERNZI   
      END   
CSUBROUTINE KERNZ1 (CH, CHA, N) 
C-------------------------------------------------------------- 
C Fill array CHA with CH (N words)  
C INPUT : CH    One literal of type character * 1   
C         N     Dimension of array CHA  
C OUTPUT: CHA   A literal array with length N and   
C                 type character * 1
C+----------------------------------------------------------------------
      SUBROUTINE KERNZ1 (CH, CHA, N)
      CHARACTER * 1  CH, CHA(N) 
      DO 100 I=1,N  
  100 CHA(I) = CH   
      RETURN
C        END OF SUBROUTINE KERNZ1   
      END   
CSUBROUTINE KERNZ6 (CH, CHA, N) 
C-------------------------------------------------------------- 
C Fill array CHA with CH (N words)  
C Input : CH    One literal of type character * 6   
C         N     Dimension of the array CHA  
C Output: CHA   One literal array with length N and 
C               type character * 6  
C+----------------------------------------------------------------------
      SUBROUTINE KERNZ6 (CH, CHA, N)
      CHARACTER * 6  CH, CHA(N) 
      DO 100 I=1,N  
  100 CHA(I) = CH   
      RETURN
C        END OF SUBROUTINE KERNZ6   
      END   
CSUBROUTINE KEREQ1 (L, LL, N, KEND) 
C-----------------------------------------------------------------------
C Compare literal L with contents of literal array LL(N)
C         literal = CHARACTER*1      N = dimension of LL
C Return: KEND = position of L in table LL  
C         KEND = -1 if L is not present in array LL 
C+----------------------------------------------------------------------
      SUBROUTINE KEREQ1 (L, LL, N, KEND)
      CHARACTER * 1  LL(N), L   
      DO 100 KEND=1,N   
      IF (LL(KEND).EQ.L) GOTO 110   
  100 CONTINUE  
      KEND = -1 
  110 RETURN
C        END OF SUBROUTINE KEREQ1   
      END   
CSUBROUTINE KEREQ6 (L6, LL6, N, KEND)   
C-----------------------------------------------------------------------
C Compare literal L6 with contents of literal array LL6(N)  
C         literal=CHARACTER*6         N = dimension of LL6  
C Return: KEND = position of L6 in table LL6
C         KEND = -1 if L6 is not present in array LL6   
C+----------------------------------------------------------------------
      SUBROUTINE KEREQ6 (L6, LL6, N, KEND)  
      CHARACTER * 6  L6, LL6(N) 
      DO 110 KEND=1,N   
      IF (L6.NE.LL6(KEND)) GOTO 110 
C        CORRECT KEYWORD FOUND AT POSITION KEND 
      RETURN
  110 CONTINUE  
C        CORRECT KEYWORD NOT FOUND  
      KEND = -1 
      RETURN
C        END OF SUBROUTINE KEREQ6   
      END   
CSUBROUTINE KERC2I (L, KEND)
C-----------------------------------------------------------------------
C Compare L with contents of internal array with letters and digits:
C    translate L (=CHARACTER*1) to integer number I from internal array.
C    Lower case characters are recognized and treated as upper case.
C Return KEND = Position of L:         (but: KEND=0 if L=0) 
C    KEND =    -1 if L is not recognised
C    KEND =     0 if L=0
C    KEND =  1- 9 if 1, 2, 3, ... 9 
C    KEND =    10 if blank  
C    KEND = 11-36 if A, B, C, ....Z 
C    KEND = 37-49 if +  -  .  ,  *  /  =  $  '  (  )  ?  ?  
C    ----           37 38 39 40 41 42 43 44 45 46 47 48 49  
C Calls : KEREQ1
C+----------------------------------------------------------------------
      SUBROUTINE KERC2I (L, KEND)   
      CHARACTER * 1 L, LLL(49), LLC(26) 
      DATA LLL / '1','2','3','4','5', '6','7','8','9',' ',  
     +           'A','B','C','D','E', 'F','G','H','I','J',  
     +           'K','L','M','N','O', 'P','Q','R','S','T',  
     +           'U','V','W','X','Y', 'Z','+','-','.',',',  
     +           '*','/','=','$','''','(',')','?','?'      /
C        -----    41  42  43  44  45   46  47  48  49   
C                                 ''              ONE QUOTE IS: ''''
      DATA LLC / 'a','b','c','d','e', 'f','g','h','i','j',  
     +           'k','l','m','n','o', 'p','q','r','s','t',  
     +           'u','v','w','x','y', 'z'                  /
      KEND = 0  
      IF (L.EQ.'0') RETURN  
C        charactr 'zero' returned as integer 0. If not: 
      CALL KEREQ1 (L, LLL, 49, KEND)
C        IF NOT PRESENT, KEND = -1 HAS BEEN RETURNED
      IF (KEND.GT.0) RETURN 
C        test lower case / not to be distinguished  
      CALL KEREQ1 (L, LLC,  26, KEND)   
      IF (KEND.GT.0) KEND = KEND + 10   
      RETURN
C        END OF SUBROUTINE KERC2I   
      END   
CSUBROUTINE KERI2C (I, CCC, N)  
C-----------------------------------------------------------------------
C Convert number ABS(I) to CHARACTER * 6  CCC  ,  left adjusted 
C If I is too big then the biggest possible number (999...) is returned.
C Input : I        Integer number to be converted   
C Output: CCC      Character * 6
C Needed: N        Max number of digits to be converted (.LE. 6)
C+----------------------------------------------------------------------
      SUBROUTINE KERI2C (I, CCC, N) 
      CHARACTER * 6  CCC
      CHARACTER * 1  N10(10)
      DATA N10 / '1', '2', '3', '4', '5', '6', '7', '8', '9', '0' / 
      CCC = ' ' 
      JNUM = IABS(I)
      NN = N
      IF (NN .GT. 6) NN = 6 
      K = 10**NN
      IF (JNUM .GE. K) JNUM = K-1   
      J = K / 10
      DO 100 L=1,NN 
      IF (JNUM.GE.J) GOTO 110   
      NN = NN- 1
      J = J / 10
  100 CONTINUE  
C         NOW NN = CORRECT NUMBER OF CHARACTERS 
  110 DO 120 L=1,NN 
      K = JNUM / J  
      IF (K.EQ.0) THEN  
         CCC(L:L) = N10(10) 
      ELSE  
         CCC(L:L) = N10(K)  
         ENDIF  
      JNUM = JNUM - K*J 
  120 J = J / 10
      RETURN
C        END OF SUBROUTINE KERI2C   
      END   
CSUBROUTINE KERI2F (IA, FA, N)  
C-----------------------------------------------------------------------
C Transform integer array IA to floating array FA (N words) 
C Input : IA(N)  array to be copied                N = dimension
C Output: FA(N)  array with data copied from array A
C+--------------------------------------------------------------------  
      SUBROUTINE KERI2F (IA, FA, N) 
      DIMENSION IA(N), FA(N)
      DO 100 I=1,N  
  100 FA(I) = IA(I) 
      RETURN
C        END OF SUBROUTINE KERI2F   
      END   
CSUBROUTINE KERF2I (FA, IA, N)  
C-----------------------------------------------------------------------
C Transform contents of floating array FA   
C to integer array IA (N words): with rounding-off  
C Input : FA(N)  array to be copied 
C Output: IA(N)  array with data copied from array A
C Needed: N      dimension of FA and IA 
C+--------------------------------------------------------------------  
      SUBROUTINE KERF2I (FA, IA, N) 
      DIMENSION FA(N), IA(N)
      DO 100 I=1,N  
  100 IA(I) = NINT (FA(I))  
      RETURN
C        END OF SUBROUTINE KERF2I   
      END   
CSUBROUTINE KERC2U (CA, CB, N)  
C-----------------------------------------------------------------------
C Convert character CA (mixed case) to CB !upper case! for N characters 
C Input : CA    character *(*)  using N characters  
C Output: CB    same. WARNING: possible remaining char. are UNDEFINED   
C+----------------------------------------------------------------------
      SUBROUTINE KERC2U (CA, CB, N) 
      CHARACTER CA *(*), CB *(*)
      CHARACTER * 1  LUC(26), LLC(26)   
      DATA LUC / 'A','B','C','D','E', 'F','G','H','I','J',  
     +           'K','L','M','N','O', 'P','Q','R','S','T',  
     +           'U','V','W','X','Y', 'Z'                  /
      DATA LLC / 'a','b','c','d','e', 'f','g','h','i','j',  
     +           'k','l','m','n','o', 'p','q','r','s','t',  
     +           'u','v','w','x','y', 'z'                  /
      DO 120 I = 1, N   
      CB(I:I) = CA(I:I) 
      IF (CB(I:I) .EQ. ' ') GOTO 120
      CALL KEREQ1 (CB(I:I), LLC, 26, KEND)  
      IF (KEND .LE. 0) GOTO 120 
      CB(I:I) = LUC(KEND)   
  120 CONTINUE  
      RETURN
C        END OF SUBROUTINE KERC2U   
      END   
CSUBROUTINE KEPROG (NAME)   
C-----------------------------------------------------------------------
C                               Dec 95: first, read DDJOB to get CCODE !
C                               Jan 97: not if help request !   
C Initiate program  (called only once)  
C    Input : NAME   Program name (in FORMAT: A8)
C IFILE : input / output unit numbers.  
C    initiated by KEPROG as IFILE(I) = I for I=1,20 
C    usually: IFILE(5) = IRD  = 5  = TERMINAL INPUT 
C             IFILE(6) = IPR1 = 6  = TERMINAL OUTPUT
C             IFILE(7) = LIS1 = 7  = PRINT LISTING        (132 columns) 
C             IFILE(8) = LIS2 = 8  = Auxil. PRINT LISTING (132 columns) 
C             may be reset in MAIN,  or later,  at any time 
C Set name of program in =PROGNM=   
C CLEAR CCODE = compound code   
C CLEAR TITLE = title given by user 
C Print heading 
C Initiate time routine ITIME   
C    Date and time: ITIME(1) = year  (E.G. 1986)
C                   ITIME(2) = month (E.G. 2 (for febr.)
C                   ITIME(3) = day   (E.G. 24)  
C                   ITIME(4) = CPU TIME USED (IN msec)  
C IFSTAT   Input/output keywords
C initiated by KEPROG as: IFSTAT(..) = -2 (file untested)   
C May be used for extra print key, or to suppress output,   
C or to indicate IO-status for IFILE(..):   
C                   IFSTAT(..) = 0    old (existing) file opened
C                   IFSTAT(..) = -1   new (non-existing) file opened
C                   IFSTAT(..) = -2   not tested, or deleted
C                   IFSTAT(..) = ??? zie BINIFF 
C OPEN file LIS1 at unit number 7 for output LISTING, 130 columns max.  
C OPEN file LIS2 at unit number 8 for output LISTING, 130 columns max.  
C Note: old files LIS1 and LIS2 will be postioned at the end-sentinel:  
C      $FINISH : if not present, an ERROR STOP will occur.  
C ---- file IPR1 at unit number 6 for terminal is not opened
C ---- file IRD  at unit number 5 for terminal is not opened
C      (IBM restriction for file unit number 6, not allowed to open ! ) 
C      (For the CYBER this is done in KEYSWI: see file NIJX1 FORCYB ! ) 
C Clear array KEYS = Program keys   
C     KEYS(I)  = 0 , I=1,2,3,4,5,6,.....
C     KEYS(4)  = -1 No file DDJOB,     = 0  file DDJOB present / closed 
C                                        data remains in common SYSTA/B 
C     KEYS(5)  = -1 No file DDSYST for first call of DDSTART
C              = 0  File DDSYST present, chopped (header PROGNM removed)
C              = +1 Error on DDSYST file: header PROGNM not correct.
C     KEYS(13) = IRUN from file DDLOG   
C     KEYS(22) = 1 or 2 for new or old LIS1 listing, resp.  
C Set array SWITCH(..) = .FALSE.
C SWITCH(8)  must be set .TRUE. if a program is running in BATCH mode   
C            it is set   .TRUE. if the DDJOB file contains 'BATCH'  
C SWITCH(10) must be set .TRUE. for long output, directed to LIS2   
C Call subroutine KEYSWI for 'local' KEYS and SWITCH settings   
C Read DDLOG file, get IRUN, set KEYS(13), print LOG TITLE  
C   Get CCODE from DDLOG file, suppress printing of CCODE if = 'NONAME' 
C Test and read DDSYST file: if not present: no action but KEYS(5) = -1 
C   if present: read first word: is it equal to the program name NAME ? 
C   NO : print: 'unexpected (incorrect?) DDSYST file', set KEYS(5) = +1 
C   YES: skip this record, rewrite remainder to DDSYST,  : KEYS(5) =  0 
C Read DDJOB file, and set KEYS(4) and SWITCH(8).   
C    Note: the DDJOB file will be closed, but the data (first record)   
C    (interpreted by KERINB) remains in common SYSTA and SYSTB, ready   
C    for used in the calling routine.   
C Note: if KEPROG is used more than once (for imbedding full programs   
C in a super-program) then most of the above functions are skipped. 
C Note: blank COMMON / /  is used in this subr. 
C Calls: KEDATE (THIS IS THE ONLY TIME -KEDATE- IS USED), KETIME
C+----------------------------------------------------------------------
      SUBROUTINE KEPROG (NAME)  
      CHARACTER NAME *(*)   
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      LOGICAL NIJMEG
      EQUIVALENCE (NIJMEG, SWITCH(1))   
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (IDDL, IFILE(1)), (IDDJ, IFILE(1)), (IDDS, IFILE(2))  
      EQUIVALENCE (IRD,  IFILE(5)), (IHELP, IFILE(3))   
      EQUIVALENCE (IPR1, IFILE(6)), (LIS1, IFILE(7)), (LIS2, IFILE(8))  
      PARAMETER (NCHMAX=517)
C     ------ / / blank common for storage of DDSYST 
      COMMON / / CHONDA(NCHMAX) 
      CHARACTER * 80 CHONDA, CHINJ  
      LOGICAL FIRST 
      CHARACTER * 2 ISTAR   
      DATA ISTAR / '**' /   
      DATA FIRST /.TRUE./   
      DO 100 I=1,20 
      IFSTAT(I) = -2
  100 IFILE(I) = I  
C        clear CHOUT (character output) 
      CHOUT  = ' '  
      PROGNM = NAME 
      PROSNM = ' '  
C        CLEAR TITLE, CCODE, TIME AND KEYS  
      IF (FIRST) THEN   
         TITLE = ' '
***      CCODE = ' '
C Dec 95:   
         CCODE = 'CCODE'
         CALL KERNZI (0, ITIME, 4)  
         ENDIF  
      CALL KERNZI (0, KEYS, 28) 
C        CLEAR LOGICAL SWITCH   
      DO 103 I=1,28 
  103 SWITCH(I) = .FALSE.   
C        save FIRST in SWITCH(9) for communication with other routines  
      SWITCH(9) = FIRST 
C Dec 95 get CCODE !
      CALL FILINQ (IDDJ, 'DDJOB', 'FORMATTED', 'INPUT', KIDDJ)  
      KEYS(4) = KIDDJ   
**    IF (KIDDJ .NE. 0) RETURN  
C the DDJOB file must always be there... if not: let DDSTART decide!
      IF (KIDDJ .NE. 0) GOTO 101
C        KIDDJ=0 : DDJOB file present (if not: KIDDJ=-1)
      CALL KERINA (IDDJ, LIT, 1, LEND)  
C        contents of first record of DDJOB remains in CHIN and LIT  
      CHINJ = CHIN  
      CALL FILCLO (IDDJ, 'KEEP')
      CCODE = LIT(1)
    
C        call KEYSWI for 'local' KEYS and SWITCH settings   
  101 CALL KEYSWI   
C        IPR1 and IRD (=TERM) opened in KEYSWI for the CYBER only   
C        open LIS1 and LIS2, KEYS(22) = 2 if 2d opening, = 1 if 1st time
      KEYS(22) = 2  
C SWITCH(1)  is set      .TRUE. only for NIJMEGEN   
C95 
      IF (SWITCH(1)) THEN   
         CALL FILINQ (LIS1, 'IPR2', 'FORMATTED', 'OUTPUT', KINQ)
         CALL FILINQ (LIS2, 'IPR3', 'FORMATTED', 'OUTPUT', KINX)
      ELSE  
         CALL FILINQ (LIS1, 'LIS1', 'FORMATTED', 'OUTPUT', KINQ)
         CALL FILINQ (LIS2, 'LIS2', 'FORMATTED', 'OUTPUT', KINX)
         ENDIF  
    
C97 allow HELP if DDLOG file is present ....
      IF (CCODE.EQ.'END' .OR. CCODE.EQ.'HELP' .OR. CCODE.EQ.'H' .OR.
     *  CCODE.EQ.'CCODE' .OR. CCODE.EQ.'?' .OR. CCODE.EQ.'BATCH') RETURN
    
    
C        file LIS1 : find $FINISH    assume at least one record present:
      I = 0 
      IF (KINQ .LT. 0) GOTO 120 
  111 READ( LIS1, FMT = '(A80)', END = 113) CHIN
      IF (CHIN(1:7) .EQ. '$FINISH' ) GOTO 125   
      I = 1 
      GOTO 111  
  113 IF (I .EQ. 0) GOTO 120
      BACKSPACE  LIS1   
      WRITE (CHOUT, FMT='(''0ERROR : Program '', A8,'' ! problems !'')')
     *   PROGNM 
      CALL SHOUT
      CHOUT=' ERROR : Existing file LIS1 is incorrect: $FINISH missing!'
      CALL SHOUT
C95:
      WRITE (IPR1, 117) 
  117 FORMAT (' An incorrect LIS1 or LIS2 file usually is the result'/  
     * ' of a computer failure,  disk storage shortage, user',  
     * ' interrupt, '/  
     * ' or similar reason for a breakdown of the PRECEDING program !'/ 
     * ' ( Which could also be an implementation error ! See LIS1 . )'/ 
     * ' NOTE : Inspect and/or erase all unusual output files! ')   
C96Feb: call DDHELP for explanations. IHELP = IFILE(3) not yet connected
      CALL FILCLO (IHELP, 'KEEP')   
      CALL XHELP (IHELP, LIS1, 10.0)
      CALL KERROR (' Severe interrupt ERROR in preceding program?', 
     *     113, 'KEPROG')   
  120 KEYS(22) = 1  
      WRITE (LIS1, 122) (ISTAR, I=1,70) 
  122 FORMAT (/// 1X, 35A2, '*' / ' ****', 62X, ' ****' / ' ****',  
     +' The DIRDIF program system, version 96.3, update  31 Dec. 1996 ' 
     +             ,'****' / ' ****', 62X, ' ****' / 1X, 35A2, '*') 
C        initial message
      CALL FILCLO (IHELP, 'KEEP')   
      CALL XHELP (IHELP, LIS1, 11.0)
      CALL FILCLO (IHELP, 'KEEP')   
      GOTO 130  
  125 BACKSPACE  LIS1   
  130 CONTINUE  
C        test LIS2 / use KINX /  option 'OUTPUT':   
CS       KINQ = -1 : file was not present, a new one has been opened
CS       KINQ =  0 : file was present and not opened,   
CS                     it has been opened, but no REWIND
CS                   file was present and opened, REWIND
C95 OPEN earlier ...
*     IF (SWITCH(1)) THEN   
*        CALL FILINQ (LIS2, 'IPR3', 'FORMATTED', 'OUTPUT', KINX)
*     ELSE  
*        CALL FILINQ (LIS2, 'LIS2', 'FORMATTED', 'OUTPUT', KINX)
*        ENDIF  
C        read file LIS2 untill $FINISH  
      IF (KINX .LT. 0) GOTO 140 
C        file LIS2 : find $FINISH    assume at least one record present:
      I = 0 
  131 READ( LIS2, FMT = '(A80)', END = 133) CHIN
      IF (CHIN(1:7) .EQ. '$FINISH' ) GOTO 145   
      I = 1 
      GOTO 131  
  133 IF (I .EQ. 0) GOTO 140
      BACKSPACE  LIS2   
CPTB  WRITE (IPR1, FMT =
      WRITE (CHOUT, FMT='(''0===== Program '', A8,'' ===== problems'')')
     *   PROGNM 
      CALL SHOUT
      CHOUT = ' Existing file LIS2 is incorrect: $FINISH missing !' 
      CALL SHOUT
      WRITE (IPR1, 117) 
      WRITE (LIS1, 117) 
CPTB *     '('' Existing file LIS2 discarded. New file opened'')')  
CPTB  REWIND LIS2   nu errorstop:   
      CALL KERROR (' Severe interrupt ERROR in last executed program?', 
     *     133, 'KEPROG')   
  140 WRITE (LIS2, FMT='(''1      File LIS2: Auxiliary listing''/   
     * ''       !! Extra information for troublesome structures !!''/   
     * ''       Do not print ... Compare with LIS1 = LISTING print''/)')
      WRITE (LIS2, 122) (ISTAR, I=1,70) 
      GOTO 150  
  145 BACKSPACE  LIS2   
  150 WRITE (LIS2, 152) (ISTAR, I=1,23), PROGNM, (ISTAR, I=1,23)
  152 FORMAT (/ 1X, 23A2 / ' ****', 38X, '****' / ' ****', 16X, A8, 
     +   14X, '****' / ' ****', 38X, '****' / 1X, 23A2 )
C        CALL DATE (=TODAY) AND TIME (msec CPU) AND STORE IN =ITIME=
      CALL KEDATE   
C        first call of KEDATE: print output to unit LIS2
C             if called again: print output to unit LIS1
      IF (KINQ .LT. 0) THEN 
         CALL KEDATE
         CALL KETIME (LIS1) 
      ELSE  
         CALL KETIME (0)
C        THE DATE HAS BEEN PRINTED BY =KEDATE=  
C        THE PRINTING OF THE TIME IS SUPPRESSED BY THE PARAMETER (0)
         ENDIF  
      CALL LOGRD (IDDL, 'DDLOG', I) 
      WRITE (CHOUT, FMT='(''0============ Program '', A8)') PROGNM  
      IF (I .GT. 0) THEN
C        .... DDLOG file present: did we read the first record? 
         IF (LIT(1) .NE. 'DDLOG') THEN  
            REWIND IDDL 
            CALL KERINA (IDDL, LIT, 1, I)   
            ENDIF   
***      CCODE = LIT(2) 
C Dec 95: CCODE set above   
         IF (CCODE .EQ. 'CCODE') CCODE = LIT(2) 
         IF (CCODE .NE. LIT(2)) THEN
            CHOUT = ' Wrong CCODE on DDLOG file'
            CALL SHOUT  
            CALL KERROR (' What happened ??? ', 152, 'KEPROG')  
            ENDIF   
         IF (CCODE .NE. 'NONAME') THEN  
C           use CCODE as scratch: print CCODE right-adjusted
            IF (CCODE(5:6) .EQ. '  ') THEN  
               CCODE = ' '  
               CCODE(3:6) = LIT(2)(1:4) 
            ELSEIF (CCODE(6:6) .EQ. ' ') THEN   
               CCODE = ' '  
               CCODE(2:6) = LIT(2)(1:5) 
               ENDIF
            WRITE (CHOUT, FMT='(''0============ Execute program '', A8, 
     *         '' ============ for compound: '', A6  )') PROGNM, CCODE  
CPTB Nov93  WRITE (LIS2, FMT='(A72)') CHOUT 
C              reset CCODE left-adjusted
            CCODE = LIT(2)  
            ENDIF   
         ENDIF  
CPTB  June 92  Reset 96 
*     IF (PROGNM .NE. 'DDMAIN') THEN
         CALL SHOUT 
*     ELSE  
*        CALL SHOUT2
*        ENDIF  
      CALL LOGRD (IDDL, 'RUN', IRUN)
      IF (IRUN .LE. 0) THEN 
         IRUN = 0   
      ELSE  
         IRUN = NINT(FNUM(2))   
         CALL LOGRD (IDDL, 'TITLE', ITIT)   
         IF (ITIT .EQ. 1) THEN  
C              TITLE stored in DDLOG as: 'TITLE ='  
            TITLE = CHIN(8:72)  
            WRITE (LIS1, 160) TITLE 
            WRITE (LIS2, 160) TITLE 
  160       FORMAT (' LOG TITLE: ', A64)
            ENDIF   
         ENDIF  
      KEYS(13) = IRUN   
      CALL FILCLO (IDDL, 'KEEP')
      IF (.NOT. FIRST) GOTO 211 
C Test and read DDSYST file and set KEYS(5)  (-1 for no file)   
      KEYS(5) = -1  
      CALL FILINQ (IDDS, 'DDSYST', 'FORMATTED', 'INPUT', KIDDS) 
      IF (KIDDS .EQ. -1) GOTO 211   
      CALL KERINA (IDDS, LIT(32), 1, LEND)  
      IF (LIT(1) .NE. PROGNM(1:6)) THEN 
         CHOUT = ' Warning:  unexpected (incorrect?) DDSYST file'   
         CALL SHOUT 
         KEYS(5) = 1
         GOTO 211   
         ENDIF  
C        read and re-write remainder of DDSYST file (stop at STOP)  
         KEYS(5) = 0
      NCH = 0   
  201 CALL KERINA (IDDS, LIT(32), 1, LEND)  
      IF (LEND .EQ. -1) GOTO 207
      NCH = NCH + 1 
      CHONDA(NCH) = CHIN
      GOTO 201  
C        rewrite
  207 REWIND IDDS   
      DO 208 I = 1, NCH 
  208 WRITE (IDDS, FMT = '(A80) ') CHONDA(I)
      REWIND IDDS   
      CALL FILCLO (IDDS, 'KEEP')
  211 FIRST = .FALSE.   
C        BATCH job ? / set file DDJOB indicator 
C        Read DDJOB file, and set KEYS(4) and SWITCH(8).
C     Note: the DDJOB file will be closed, but the data (first record)  
C     (interpreted by KERINB) remains in common SYSTA and SYSTB, ready  
C        for used in the calling routine.   
C Dec 95 move to begin of subroutine to get CCODE ! 
**    CALL FILINQ (IDDJ, 'DDJOB', 'FORMATTED', 'INPUT', KIDDJ)  
**    KEYS(4) = KIDDJ   
      IF (KIDDJ .NE. 0) RETURN  
C        KIDDJ=0 : DDJOB file present (if not: KIDDJ=-1)
**    CALL KERINA (IDDJ, LIT, 1, LEND)  
C        contents of first record of DDJOB remains in CHIN and LIT  
**    CALL FILCLO (IDDJ, 'KEEP')
C        second word = BATCH ? ----> SWITCH(8) = BATCH indicator
C Dec 95
      CHIN = CHINJ  
      CALL KERINB (LIT(32), 1)  
      IF (LIT(2) .EQ. 'BATCH') SWITCH(8) = .TRUE.   
      IF (CCODE .NE. ' ') RETURN
      CCODE = LIT(1)
      WRITE (CHOUT, FMT='(''0'', 64(''=''), 1X, A6)') CCODE 
      CALL SHOUT
      RETURN
C        END OF SUBROUTINE KEPROG   
      END   
CSUBROUTINE KEPROX  
C-----------------------------------------------------------------------
C Call KEYSWI for final local modifications 
C Print 'END OF PROGRAM'   -------  WRITE '$FINISH' to LIS1 and LIS2
C Print TIME and TITLE and stop by FORTRAN statement STOP 0 
C Calls: KETIME KEYSWI  
C+----------------------------------------------------------------------
      SUBROUTINE KEPROX 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (LIS1, IFILE(7)), (LIS2, IFILE(8))
C     CHARACTER * 2  ISTAR  
C     DATA IISO   / '**' /  
      CHARACTER * 2  IISO   
      DATA IISO   / '==' /  
C        second call to KEYSWI  
      CALL KEYSWI   
      CALL KETIME (LIS2)
C     WRITE (LIS2, 110) TITLE, PROGNM, (IISO, I=1,23)   
C 110 FORMAT (' TITLE: ', A64 / ' End of program ' , A8 /   
C    +     ' ' , 23A2  //  '$FINISH')   
      IF (TITLE .NE. ' ') WRITE (LIS2, 110) TITLE   
  110 FORMAT (' TITLE: ', A64)  
      WRITE (LIS2, 111)  PROGNM, (IISO, I=1,23) 
  111 FORMAT (' End of program ' , A8 / 
     +     ' ' , 23A2  //  '$FINISH')   
CB090893
      WRITE (LIS1, FMT='('' End of program '', A8 // ''$FINISH'')') 
     * PROGNM   
      STOP 0
C        END OF SUBROUTINE KEPROX   
      END   
CSUBROUTINE KERNER (KEY, NAME)  
C-----------------------------------------------------------------------
C Input : KEY    see below  
C         NAME   Name of calling subroutine (A6)
C ERROR STOP ROUTINE, PRINT SPGM='PROSNM', MODULE='NAME'
C Print messages to unit IPR1 (TERM) and LIS1 (line printer)
C Write 'STOP' to DDSYST file and erase CONDA file  
C Call subr. KEYSWI to finish users modifications.  
C Stop by FORTRAN statement STOP 1  
C    Messages are:  
C KEY = 0    'ERROR STOP IN ...', no further messages.  
C KEY .GT. 0 'UNEXPECTED ERROR OCCURRED AT LABEL=..'
C KEY .LT. 0 'ERROR NUMBER KEY'   and followed by the message:  
C KEY  =  -1 'INPUT DATA INCORRECT' 
C      =  -2 'INPUT FILE INCORRECT' 
C      =  -3 'SORRY, DATA IS INCONSISTENT'  
C      =  -4 'MAY BE PROGRAMMERS ERROR...'  
C      =  -5 'SEE MANUAL FOR DETAILS'   
C      =  -6 'INPUT DATA INCORRECT, LAST INPUT BUFFER CONTENTS ='   
C                                   and print CHIN(1:72)
C ------- THIS LIST OF MESSAGES MAY BE EXTENDED --------
C ------- KMAX IS THE NUMBER OF SUCH MESSAGES: SEE DATA ST. 
C Calls: KETIME 
C+----------------------------------------------------------------------
      SUBROUTINE KERNER (KEY, NAME) 
      CHARACTER NAME *(*), NAMEX *8 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (IDDS, IFILE(2)), (ICON, IFILE(4))
      EQUIVALENCE (IPR1, IFILE(6)), (LIS1, IFILE(7)), (LIS2, IFILE(8))  
      CHARACTER * 6  SUBPGM 
      DATA SUBPGM /'SUBPGM'/
      NAMEX = NAME  
      IF (PROSNM.EQ.' ') SUBPGM=' ' 
      WRITE (CHOUT, 100) PROGNM, SUBPGM, PROSNM, NAMEX  
  100 FORMAT (' ERROR STOP IN ' ,A8, 3X,A6,1X,A6,' MODULE ',A8) 
      WRITE (LIS2, 100) PROGNM, SUBPGM, PROSNM, NAMEX   
      CALL SHOUT
      IF (KEY.EQ.0) GOTO 190
      IF (KEY.LT.0) GOTO 120
      WRITE (CHOUT, 110) KEY
  110 FORMAT (' ERROR (unexpected) OCCURED NEAR LABEL NUMBER', I6)  
      CALL SHOUT
      GOTO 190  
C-      KEY NEGATIVE
  120 WRITE (CHOUT, 130) KEY
  130 FORMAT (' ERROR NUMBER', I5)  
      CALL SHOUT
C-       ERROR MESSAGES (STANDARD)  
      IF (KEY.EQ.-1) WRITE (CHOUT, 140) 
  140 FORMAT (' ERROR : INPUT DATA INCORRECT')  
      CALL SHOUT
      IF (KEY.EQ.-2) WRITE (CHOUT, 150) 
  150 FORMAT (' ERROR : INPUT DATA FILE(S) INCORRECT')  
      CALL SHOUT
      IF (KEY.EQ.-3) WRITE (CHOUT, 160) 
  160 FORMAT (' ERROR : SORRY, DATA IS INCONSISTENT')   
      CALL SHOUT
      IF (KEY.EQ.-4) WRITE (CHOUT, 170) 
  170 FORMAT (' ERROR ..MAY BE PROGRAMMERS ERROR..')
      CALL SHOUT
      IF (KEY.EQ.-5) WRITE (CHOUT, 180) 
  180 FORMAT (' ERROR ... SEE MANUAL FOR DETAILS....')  
      IF (KEY.EQ.-6) THEN   
         WRITE (CHOUT, 140) 
         CALL SHOUT 
         WRITE (CHOUT, FMT='('' ERROR : LAST INPUT RECORD WAS:'')') 
         CALL SHOUT 
         WRITE (IPR1, 181) CHIN(1:72)   
         WRITE (LIS1, 181) CHIN(1:72)   
         WRITE (LIS2, 181) CHIN(1:72)   
  181    FORMAT (' ERROR ! ', A72)  
*** 96   CALL SHOUT 
         ENDIF  
  190 CONTINUE  
C96Feb general message! 
      WRITE (LIS1, 187) 
  187 FORMAT (/' ERROR ! Here follows a general ERROR message.'/
     * ' The present error-stop is the result of an internal test'/ 
     * ' which could refer to a well-defined user-error. '/ 
     * ' If you understand the printed message, ignore the following',  
     *   ' lines.'/ '   In most cases,',
     * ' error-stops occur at unexpected places or for unexpected'/ 
     * ' reasons, and consequently the error messages are ',
     *     'not transparant'/   
     * ' for the user. At present (1996) we are trying to improve those'
     * / ' messages, but that is a slow process... ')   
      WRITE (LIS1, 188) 
  188 FORMAT (  
     * ' If the present error message is not clear to you, please, ',   
     *      'tell us'/  
     * ' about it: we can help..., at least we can explain the message,'
     * / ' and we learn from your cooperation.'/
     * ' We need to know what can go wrong.'/   
     * ' And hopefully next DIRDIF release can be improved.'/   
     * ' Thank you for your help.    Paul T. Beurskens.'/)  
      CALL KETIME (LIS1)
      CALL KETIME (LIS2)
      CALL FILINQ (IDDS, 'DDSYST', 'FORMATTED', 'TEST', KINQ)   
      IF (KINQ .LT. 0) GOTO 220 
C        DDSYST file present: write 'STOP'  
      REWIND IDDS   
      WRITE (IDDS, FMT='(''STOP'')')
      REWIND IDDS   
      CALL FILCLO (IDDS, 'KEEP')
  220 CALL FILINQ (ICON, 'CONDA', 'FORMATTED', 'TEST', KINQ)
      IF (KINQ .EQ. 0) CALL FILCLO (ICON, 'DELETE') 
      CALL KEYSWI   
C        default: nothing done in KEYSWI ! Users modification ? 
      STOP 1
C        END OF SUBROUTINE KERNER   
      END   
CSUBROUTINE KERROR (MESGE, KEY, NAME)   
C-----------------------------------------------------------------------
C ERROR STOP ROUTINE
C Input : MESGE: CHARACTER STRING *(*) to be printed to IPR.
C         KEY:   standard error message (see KERNER)
C         NAME:  name of calling subroutine 
C Print error message MESGE (up to 70 characters)   
C    to unit IPR1 (TERM) and LIS1 (line printer)
C Call KERNER (KEY, NAME) ,  see subroutine KERNER: 
C      KERNER: write 'STOP' to DDSYST file; erase CONDA file; STOP 1
C Calls: KERNER 
C+----------------------------------------------------  
      SUBROUTINE KERROR (MESGE, KEY, NAME)  
      CHARACTER MESGE *(*) , MESGEX *70 
      CHARACTER NAME  *(*) , NAMEX  *8  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (IPR1, IFILE(6)), (LIS1, IFILE(7)), (LIS2, IFILE(8))  
    
      NAMEX  = NAME 
      MESGEX = MESGE
      WRITE (CHOUT, FMT='('' ERROR MESSAGE:   '')') 
      CALL SHOUT
      WRITE (IPR1, 100) MESGEX  
      WRITE (LIS1, 100) MESGEX  
      WRITE (LIS2, 100) MESGEX  
  100 FORMAT (' ERROR : ', A70) 
      CALL KERNER (KEY, NAME)   
C        END OF SUBROUTINE KERROR   
      END   
CSUBROUTINE KERINA (IRD, L, LMAX, LEND) 
C-----------------------------------------------------------------------
C Read card    Free format interpretation and check keywords.   
C              Do not check system cards
C Input : IRD       =  Input unit (usually card reader  UNIT=5) 
C         L(LMAX)   =  A user defined list of keywords  
C         LMAX      =  Dimension of array L.
C Output: LEND      =  Return key: see below
C /SYSTA/ and /SYSTB/   
C Output: FNUM (I)  Number (I-TH number on input RECORD) (=0: END)  
C         LIT(I)    Literal (I-TH literal on input RECORD)  
C Etc.              (only 32 literals can be stored)
C See KERINB
C ==========
C Interpretation of all literals against L contents is  
C stored in array =NLUSER=     .LE.0 means not present. 
C Lend returns :
C                -1  END OF FILE
C                 4  END CARD   
C                 5  FINISH CARD
C                 6  STOP CARD  
C                 0  FOR ANY OTHER CARD 
C Calls: KERINB 
C+----------------------------------------------------------------------
      SUBROUTINE KERINA (IRD, L, LMAX, LEND)
      CHARACTER * 6  L(LMAX)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      LEND = 0  
      IF (IRD.LE.0 .OR. IRD.GT.20) CALL KERROR (' IRD?',-4,'KERINA')
C        ALWAYS READ 80 COLUMNS 
      READ (IRD, 110, ERR = 120, END = 120, IOSTAT = IFSTAT(IRD)) CHIN  
  110 FORMAT (A80)  
      IF (IFSTAT(IRD) .EQ. 0) GOTO 130  
  120 LEND = -1 
      CHIN = ' '
C        IF EOF (LEND = -1): CALL KERINB TO CLEAR ARRAYS, THEN RETURN.  
  130 CALL KERINB (L, LMAX) 
      IF (LEND.LE.-1) RETURN
C        TEST FOR 'END', 'FINISH' ANS 'STOP' : LEND = 4,5,6, RESP.  
      IF (LIT(1).EQ.'END   ') LEND = 4  
      IF (LIT(1).EQ.'FINISH') LEND = 5  
      IF (LIT(1).EQ.'STOP  ') LEND = 6  
      RETURN
C        END OF SUBROUTINE KERINA   
      END   
CSUBROUTINE KERINB (LUSER, LUMAX)   
C-----------------------------------------------------------------------
C Interpret alpha-numeric data in free format   
C    and check all literals against user supplied table: LUSER  
C Input : LUSER(LUMAX) user supplied table with literal data
C         LUMAX: dimension of table LUSER   
C common /SYSTA/ and /SYSTB/ consist of:
C CHIN     Input characters (literals, numbers, characters) 
C NFNUM    Number of numbers stored in FNUM (max=32)
C FNUM(N)  A number (the N-TH number given on the input record),
C          N = 1, 2, 3 ... NFNUM
C NFDOT(N) Indicator: The number in NFNUM is an integer or a real:  
C          1=INTEGER, 2=REAL (number with dot), 0=end-of-numbers
C NCOLN(N) Number of column of fif st character of the N-th number  
C          (0 = end of data) (NCOLN(32) = negative signals that more
C          then 32 numbers were presented, but NFNUM=32 are stored) 
C NLIT     Number of literals stored in LIT (max=32)
C LIT(L)   The L-th litteral found (up to 6 characters given),  
C          L = 1, 2, 3 ... NLIT 
C NCOLL(L) Number of column of fif st char. of the L-TH literal 
C          (0 = END OF DATA; NCOLL(32) = NEG: more data were given) 
C NFDOL(I) Indicator: Interpretation of consecutive items (MAX=32): 
C          1=INTEGER, 2=FL.NUMBER (WITH DOT),   
C          0 signals END-OF-DATA,   
C          or negative: -1, -2, -3.... if the corresponding 
C             literal consists of 1, 2, 3... characters.
C NLUSER(L) Checking of literals with user-supplied array =LUSER=   
C          NLUSER(L)=K   if  LIT(L)=K-TH item in LUSER. 
C          NLUSER(L)=NEG if  LIT(L) is not present in =LUSER=   
C          LUMAX is the maximum value of K  
C          Note: use CALL KERINB (LIT,1) to avoid this user-test.   
C NOTE: Blank and comma usually are word separators.
C       Numbers may be separated by a + or a - sign 
C       (only if the sign is not followed by a blank)   
C       NOTE....  ',,'  is not interpreted as a dummy item -----
C CONTENTS: Results for item, number, literal  1,2,3,.... 32:   
C           E.G.: A Literal ( X ,  ABC7 ,  *** ,  12..3 )   
C           OR:   A Number ( +123 ,  -3 ,  -.56 ,  - 3 ,  + 0 ) 
C           A number may be signed or unsigned. 
C           Blanks inbetween sign and digits are permitted  
C           (if the sign is preceeded by a blank.   
C           ( -2+.003-.10  is interpreted as three numbers) 
C           ( 3 - 2            are two numbers (3  and  -2) 
C           ( 3-2         also are two numbers (3  and  -2) 
C           ( 3- 2   is one literal (3-) and one number (2) 
C           ( +   or   .   or   3-     only is one literal) 
C FNUM(I) is real-number (may be 0.0)   
C NCOLN(I) is column number of fif st char. 
C NCOLN(I) = 0 SIGNALS: No more numbers  on this card.  
C NCOLL(I) = 0 SIGNALS: No more literals on this card.  
C NFNUM=NLIT=NCOLL(1)=NCOLN(1)=0  Signals: One all blank card.  
C NCOLL(32)=-N SIGNALS: On column N is the fif st char. of literal 32.  
C                       But more items are present on this card-----
C NFNUM, NLIT, NCOLN(32)=-N Signals: on column N is the fif st char. of 
C                       number 32,  
C                       But more items are present on this card-----
C Origin: FREFOR: A. VAN DER BILT, APRIL 1981   
C Modified for DIRDIF: PTB, SEP 1981
C Transformed to KERINB: S. GARCIA-GRANDA, NOV 1985 
C FORTRAN77  W.B. + C.J., MAR 1987  
C Calls: KERNZA, KERNZI, KERNZ6, KERC2I, KERNER, KERINF, KEREQ6 
C+----------------------------------------------------------------------
      SUBROUTINE  KERINB (LUSER, LUMAX) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      CHARACTER * 6  LUSER(LUMAX)   
C        Use dummy LUSER: LIT(1) and LUMAX=1  to avoid this test
      CHARACTER * 1  CH1
      CHARACTER * 6  CHLIT, IBL, LBOS   
      DATA IDMAX  / 32 /
      DATA IBL    /'  '/
      DATA MCOL   / 72 /
C        CLEAR TABLES IN COMMON SYSTA AND SYSTB.
C        /SYSTA/ AND /SYSTB/ INPUT:OUTPUT BUFFER.   
      CALL KERNZ6 (IBL,  LIT, IDMAX)
      CALL KERNZA (0.0, FNUM, IDMAX)
      CALL KERNZI (0,  NCOLN, IDMAX)
      CALL KERNZI (0,  NCOLL, IDMAX)
      CALL KERNZI (0,  NFDOT, IDMAX)
      CALL KERNZI (0,  NFDOL, IDMAX)
      CALL KERNZI (0, NLUSER, IDMAX)
C        CHECK FOR dummy LUSER  
      LUMA = LUMAX  
      IF (LUMA.EQ.1 .AND. LUSER(1).EQ.' ') LUMA = 0 
      NFNUM = 0 
      NLIT  = 0 
      ITEM  = 0 
      KEND  = 0 
      NEND  = 0 
      I = 1 
C        START OR SKIP BLANKS,    I IS CORRECT OR TOO BIG:  
  110 IF (I.GT.MCOL) GOTO 270   
      DO 120 K=I,MCOL   
      CH1 = CHIN(K:K)   
      IF (CH1.NE.' ' .AND. CH1.NE.',') GOTO 130 
  120 CONTINUE  
      GOTO 270  
C        NEW ITEM FOUND: CHECK FOR NUMBER(S)
  130 NONUM  = 0
      NONUM2 = 0
      NSIG = 0  
      NDOT = 0  
      I = K 
C         I IS PRESENT STARTING ADRESS  
      DO 170 K=I,MCOL   
      CH1 = CHIN(K:K)   
      CALL KERC2I (CH1, J)  
C         COMPARE CH1 WITH INTERNAL ARRAY WITH LETTERS AND DIGITS   
C         RETURN J = CHARACTER PRESENT IN IC1:  
C           KEND =    -1 IF CHAR. NOT RECOGNISED
C           KEND =     0 IF CHAR. = 0   
C           KEND =  1- 9 IF 1, 2, 3, ... 9  
C           KEND =    10 IF BLANK   
C           KEND = 11-36 IF A, B, C, ....Z  
C           KEND = 37-40 IF +  -  .  ,  
C                          37 38 39 40  
C           KEND = 41-49 NOT USED IN PRESENT SUBROUTINE 
      IF (J.GE.0 .AND. J.LE.9) GOTO 140 
      IF (CH1.EQ.'.') GOTO 150  
      IF (J.LT.0 .OR. J.GE.41) GOTO 240 
      IF (J.GE.11 .AND. J.LE.36) GOTO 240   
C        LEFT WITH BLANK, COMMA, OR   SIGN:           END OF ITEM?  
C                 J = 10     40      37 OR 38   
      IF (NDOT.EQ.1  .AND. NONUM.EQ.0) GOTO 240 
      IF (CH1.EQ.',' .AND. NONUM.EQ.0) GOTO 240 
      IF (CH1.EQ.',') GOTO 180  
      IF (CH1.EQ.'+'.OR. CH1.EQ.'-') GOTO 160   
C        LEFT WITH BLANK: FOREGOING CHAR. MAY BE SIGN (IF FIRST CHAR.)  
      IF (NONUM2.EQ.1) GOTO 240 
      IF (NSIG.EQ.1) GOTO 170   
      IF (NONUM.EQ.0) GOTO 240  
C        LEFT: NONUM = 1 / END OF NUMERICAL WORD(S) 
      GOTO 180  
C        NUMBER (POSSIBLE SIGN HERE NO MORE RELEVANT)   
  140 NONUM  = 1
      NONUM2 = 0
      NSIG = 0  
      GOTO 170  
C        DOT (NO TWO DOTS FOR NUMBERS: GOTO 240 FOR LITERALS)   
  150 NDOT = NDOT + 1   
      IF (NDOT.EQ.2) GOTO 240   
      GOTO 170  
C        SIGN FOUND: MAY BE FIRST CHARACTER,  OR POSSIBLE CONTINUATION  
  160 IF (NSIG.EQ.1) GOTO 240   
      IF (NDOT.EQ.1 .AND. NONUM.EQ.0) GOTO 240  
      NSIG = 1  
      NONUM2 = NONUM
      NONUM  = 0
      NDOT = 0  
  170 CONTINUE  
C        END OF ARRAY CHIN. TREATMENT AS COMMA: 
      IF (NONUM.EQ.0) GOTO 240  
C        ENTER HERE FOR ANALYSIS OF ONE NUMBER / NO ERRORS POSSIBLE 
  180 ITEM  = ITEM  + 1 
      NFNUM = NFNUM + 1 
      IF (NFNUM.LE.IDMAX) NCOLN(NFNUM) = I  
      IF (NFNUM.GT.IDMAX) NCOLN(IDMAX) = - IABS(NCOLN(IDMAX))   
      NONUM = 0 
      NSIG  = 0 
      NDOT  = 0 
      DO 220 K=I,MCOL   
      CH1 = CHIN(K:K)   
      CALL KERC2I (CH1, J)  
C         COMPARE CHIN(K:K) NOW ONLY FOR NUMERALS (ERROR FREE)  
C           KEND =     0 IF CHAR. =0
C           KEND =  1- 9 IF 1, 2, 3, ... 9  
C           KEND =    10 IF BLANK   
C           KEND = 37-40 IF +  -  .  ,  
C                          37 38 39 40  
      IF (J.GE.0 .AND. J.LE.9) GOTO 190 
      IF (CH1.EQ.'.') GOTO 200  
C        LEFT WITH BLANK, COMMA, OR   SIGN:           END OF ITEM?  
C         J =      10     40          37 OR 38  
      IF (CH1.EQ.',') GOTO 230  
      IF (CH1.EQ.'+' .OR. CH1.EQ.'-') GOTO 210  
C        LEFT WITH BLANK OR SIGN: FOREGOING CHAR. MAY BE SIGN/ELSE=END  
      IF (J.NE.10) CALL KERNER (-4, 'KERINB')   
      IF (NSIG.EQ.1) GOTO 220   
      IF (NONUM.EQ.1) GOTO 230  
      CALL KERNER (-4, 'KERINB')
C        FIGURE FOUND  /  IF DOT: EXPONENT + 1  
  190 CONTINUE  
      NONUM = 1 
      NSIG  = 0 
      GOTO 220  
C        DOT (SET EXP.) 
  200 NDOT = 1  
      GOTO 220  
C        SIGN FOUND: MAY BE FIRST CHARACTER,  OR POSSIBLE CONTINUATION  
  210 IF (NONUM.EQ.1) GOTO 230  
      NSIG  = 1 
      NONUM = 0 
  220 CONTINUE  
      KEND = 999
  230 CONTINUE  
      CALL KERINF (CHIN, I, K-1, A, NEND)   
C       END OF CHIN: I =999 TO STOP   /  ELSE  K
      I = K 
      IF (NFNUM.LE.IDMAX) FNUM(NFNUM)  = A  
      IF (NFNUM.LE.IDMAX) NFDOT(NFNUM) = NDOT+1 
      IF (NFNUM.GT.IDMAX) NFNUM = IDMAX 
      IF (ITEM.LE.IDMAX)  NFDOL(ITEM) = NDOT+1  
      GOTO 110  
C        ENTER HERE FOR STORAGE OF LITERALS  / NO CHECK FOR NUMBERS 
  240 ITEM = ITEM + 1   
      NLIT = NLIT + 1   
      IF (NLIT.LE.IDMAX) NCOLL(NLIT)  = I   
      IF (NLIT.GT.IDMAX) NCOLL(IDMAX) = - IABS(NCOLL(IDMAX))
      L = 1 
      CHLIT = ' '   
      DO 250 K=I,MCOL   
      CH1 = CHIN(K:K)   
C        COMPARE CHIN(K:K) NOW ONLY FOR BLANK OR COMMA  
C        STORE CHAR. AT L = 1,2,3,4,5,6  (IGNORE REST)  
      IF (CH1.EQ.' ' .OR. CH1.EQ.',') GOTO 260  
      IF (L.LE.6) CHLIT(L:L) = CH1  
  250 L = L + 1 
C        END OF CHIN: I = 999 TO STOP   /  ELSE: K  
      KEND = 999
      L = MCOL - I + 2  
C        L = 1 TOO BIG  
  260 I = K 
      IF (NLIT.LE.IDMAX) LIT(NLIT) = CHLIT  
      IF (NLIT.GT.IDMAX) NLIT = IDMAX   
C        STORE NEG. NR OF CHAR., E.G.: ONE LETTER ONLY: NFDOL(ITEM) = -1
      IF (ITEM.LE.IDMAX) NFDOL(ITEM) = 1 - L
C        TEST LITERALS AGAINST USER SUPPLIED ARRAY LUSER
      IF (NLIT.GT.IDMAX) GOTO 270   
CBOS     convert lower case to upper case: in LIT , for KEYWORD comp.   
      CALL KERC2U (LIT(NLIT), LBOS, 6)  
      LIT(NLIT) = LBOS  
      IF (LUMA.GT.0) CALL KEREQ6 (LIT(NLIT), LUSER, LUMA, NLUSER(NLIT)) 
C                                                   NLUSER(NLIT) = LEND 
      IF (KEND.EQ.999) I = KEND 
      GOTO 110  
C        END OF CHIN.   
  270 RETURN
C        END OF SUBROUTINE KERINB   
      END   
CSUBROUTINE KERINC (IPRX, LEND) 
C-----------------------------------------------------------------------
C Interpretation of system keywords:
C        REMARK , TITLE , END , FINISH , STOP , BATCH , PRINT   
C IPRX = printer unit (usually:7 or 8);    IPRX = 0: no print.  
C        Print all input data if SWPRI = .TRUE. 
C LEND = return key:
C LEND = 0 if  no system card   
C LEND = 1 if  a complete blank card is found   
C LEND = 2 if 'REMARK'    is found (SUBR. =KEREQ4=) 
C LEND = 3 if 'TITLE'     ..   ..    ..      .. 
C LEND = 4 if 'END'       ..   ..    ..      .. 
C LEND = 5 if 'FINISH'    ..   ..    ..      .. 
C LEND = 6 if 'STOP'      ..   ..    ..      .. 
C LEND = 7 if 'BATCH'     ..   ..    ..      .. 
C LEND = 9 if 'PRINT'     ..   ..    ..      .. 
C BLANK is only possible if entif e card is blank   
C REMARK  and TITLE are printed in case IPRX.GT.0   
C TITLE:  If no former TITLE given: 
C         compress (2 bl = 1 bl) and store in TITLE (A64);  
C         else: ignore  
C BATCH:  SET SWITCH(8) = .TRUE. (for BATCH: no questionss asked)   
C PRINT:  SWPRI = SWITCH(10) = .TRUE. if long output
C ELSE:  no system card: LEND = 0.  
C Calls: KEREQ6 
C+----------------------------------------------------------------------
      SUBROUTINE KERINC (IPRX, LEND)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      LOGICAL SWPRI, BATCH  
      EQUIVALENCE (SWPRI, SWITCH(10))   
      EQUIVALENCE (BATCH, SWITCH(8)),  (LIS2, IFILE(8)) 
      CHARACTER * 64 TITLX  
      CHARACTER * 6  L(9)   
      DATA  L     / '    ', 'REMARK', 'TITLE', 'END', 'FINISH', 
     +              'STOP', 'BATCH',  '     ', 'PRINT' /
C        DIMENSION ARRAY =L= SET EQUAL TO  LMAX = 9 
      DATA LMAX / 9 /   
C        CHECK ARRAY =L=
      CALL KEREQ6 (LIT(1), L, LMAX, LEND)   
C        CHECK LEND:  NO SYSTEM CARD:   
      IF (LEND.LE.0) GOTO 100   
C        SYSTEM CARD OR BLANK CARD: 
      GOTO (1,2,3,4,4,4,7,1,9), LEND
C        NO LITERAL. BLANK CARD? , BUT NFNUM MAY BE .GT. 0  
    1 IF (NFNUM.LE.0) GOTO 4
C        RETURN 'NO SYSTEM' 
  100 LEND = 0  
      RETURN
C        ONE REMARK CARD IS FOUND: 72 COLUMNS   
    2 IF (IPRX .GT. 0) WRITE (IPRX, 110) CHIN(1:72) 
      IF (IPRX .NE. LIS2) WRITE (LIS2, 110) CHIN(1:72)  
  110 FORMAT (' INPUT: ' , 72A, / ) 
      GOTO 4
C        TITLE CARD FOUND.  
    3 IF (TITLE.NE.' ') GOTO 4  
      READ (CHIN(7:72), FMT=120) TITLE  
  120 FORMAT (A64)  
C        THIS IS THE ONLY PLACE WHERE THE TITLE IS STORED:  
C        STORE ONLY IF FIRST TITLE (COMPRESS) IGNORE LATER 'TITLES' 
      DO 122 I=61,1,-1  
CPTB 25 Mar 92  
      IF (TITLE(I:I+1) .EQ. '  ') TITLX      =TITLE 
      IF (TITLE(I:I+1) .EQ. '  ') TITLE(I:64)=TITLX(I+1:64) 
  122 CONTINUE  
      IF (TITLE(1:1)   .EQ. ' ' ) TITLX      =TITLE 
      IF (TITLE(1:1)   .EQ. ' ' ) TITLE(1:64)=TITLX(2  :64) 
      WRITE (CHOUT, 130) TITLE  
  130 FORMAT (' TITLE: ', A64)  
      CALL SHOUT2   
C        END, FINISH OR STOP FOUND.    (ALSO: ENTER HERE FOR RETURN)
    4 RETURN
C        BATCH:  SET BATCH = .TRUE. (FOR BATCH: NO QUESTIONS ASKED) 
    7 BATCH = .TRUE.
      GOTO 150  
C        PRINT:  SWITCH(10) = .TRUE. IF LONG OUTPUT 
    9 SWPRI = .TRUE.
C        PRINT MESSAGE  
  150 IF (SWPRI) WRITE (LIS2, 110)  CHIN(1:72)  
      RETURN
C        END OF SUBROUTINE KERINC   
      END   
CSUBROUTINE KERINF (CHIN, I, K, FF, KEND)   
C-----------------------------------------------------------------------
C Internal read subroutine for a floating point number  
C Read string CHIN(I:K) as a floating point number: FF  
C i.e.: with format: (K-I+1).0  
C Input : CHIN  Character string
C         I     Begin pointer   
C         K     End  pointer
C Output: FF    Floating point number with format: (K-I+1).0
C         KEND  = 0 Input correct   
C               = -1 Error found
C Calls: KERI2C 
C+----------------------------------------------------------------------
      SUBROUTINE KERINF (CHIN, I, K, FF, KEND)  
      CHARACTER * 80 CHIN   
      CHARACTER * 6  LL 
      CHARACTER * 8  CHFMT  
      M = K - I + 1 
      KEND = 0  
      CALL KERI2C (M, LL, 6)
      CHFMT = '(F'//LL(1:3)//'.0)'  
      READ (CHIN(I:K), FMT = CHFMT, ERR = 99) FF
      RETURN
   99 KEND = -1 
      RETURN
C        END OF SUBROUTINE KERINF   
      END   
CSUBROUTINE KERIFF (IRD, L, LMAX, LEND) 
C-----------------------------------------------------------------------
C Read card 
C Free format interpretation and check keywords.
C Check system cards
C If system card: Read next card if appropriate 
C If SWPRI = .TRUE. echo print of input cards   
C Input : IRD       =  Input unit (usually card reader, UNIT=5) 
C         L(LMAX)   =  A user defined list of keywords  
C         LMAX      =  Dimension of array L.
C Output: LEND      =  Return key: see below
C /SYSTA/ and /SYSTB/   
C Output: FNUM (I)  Number (I-TH number on input record) (=0: end)  
C         LIT(I)    Literal (I-TH literal on input record)  
C Etc.              (only 32 literals can be stored)
C See KERINB
C ==========
C Interpretation of all literals against L contents is  
C stored in array =NLUSER=     .LE.0 means not present. 
C LEND RETURNS :    -1  End of file 
C                    0  This card is not system card
C                    4  END card      5  FINISH card      6  STOP card  
C Calls: KERINB, KERINC 
C+----------------------------------------------------------------------
      SUBROUTINE KERIFF (IRD, L, LMAX, LEND)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      LOGICAL      SWPRI
      EQUIVALENCE (LIS2, IFILE(8))  
      EQUIVALENCE (SWPRI, SWITCH(10))   
      CHARACTER * 6  L(LMAX)
      IPRX = 0  
      IF (SWPRI) IPRX = LIS2
  100 CALL KERINA (IRD, L, LMAX, LEND)  
      IF (LEND.LE.-1) RETURN
      CALL KERINC (IPRX, LEND)  
      IF (LEND.EQ.0) RETURN 
C        IF NOT END / FINISH / STOP : READ NEXT 
      IF (LEND.LT.4 .OR. LEND.GT.7) GOTO 100
      RETURN
C        END OF SUBROUTINE KERIFF   
      END   
CSUBROUTINE KETERM (KNUM, KLIT, KEND)   
C-----------------------------------------------------------------------
C Free format read, interpretation, and check input record, 
C for terminal use only.
C Input : KNUM  = Requested number of numbers (reals or integers)   
C                 if neg.:  do not test for NFNUM = KNUM
C         KLIT  = Requested number of literals (max. 6 char. stored)
C                 if neg.:  Do not test for NLIT = KLIT 
C Output: KEND  = -3        If incorrect number and/or type of words
C         KEND  = -2        If a blank card is supplied 
C         KEND  = -1        If EOF. Note: Rewind IRD has been done. 
C                  0 - 49   One-character (CODE: see below) 
C                  99       Normal return: more than one character  
C                           (or one character, but not recognized)  
C If card is empty: print message and read again
C If KEND = -N, (N = 1, 2, 3): A message has been printed('WRONG DATA') 
C and the control is returned to the calling routine.   
C Note: The calling routine should repeat the instructions  
C Contents of commons /SYSTA/ and /SYSTB/ as produced by KERINB .   
C Summary:  
C Numbers are stored in FNUM(N), N = 1, 2, 3, ... NFNUM 
C    Fif st columns of numbers are given in NCOLN(N)
C    Decimal point indicated by NFDOT(N) = 2 (for integers: = 1)
C    NFNUM = Number of numbers  store in FNUM (max = 32)
C Literals (6 char. max.) are stored in LIT (L), L=1,2, ... NLIT
C    Fif st columns  literals are given in NCOLL(L) 
C    NLIT = Number of literals stored in LIT (max = 32) 
C Order of number and literals given in NFDOL(I)   (In part: max = 32)  
C    Word I: NFDOL(I) = 1(INTERGER) =2(REAL) =-n(literal of n char.)
C If the users answer consists of only character, the interpretation
C of this character is given in KEND as an integer number:  
C -If not recognized:     KEND = 99 
C -If one digit:   0 - 9  KEND = 0  1  2  3  4  5  6  7  8  9   
C -If one letter:  11-36  KEND = 11 12 13 14 15 16 17 18 19 20 21 22 23 
C                         for:    A  B  C  D  E  F  G  H  I  J  K  L M  
C                     or  KEND = 24 25 26 27 28 29 30 31 32 33 34 35 36 
C                         for:    N  O  P  Q  R  S  T  U  V  W  X  Y  Z 
C -Else:           37-49  KEND = 37 38 39 40 41 42 43 44 45 46 47 48 49 
C                         for:    +  -  .  ,  *  /  =  $  '  (  )  ?  ? 
C Calls: KERINB, KERC2I, KERNER 
C+----------------------------------------------------------------------
      SUBROUTINE KETERM (KNUM, KLIT, KEND)  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (IRD, IFILE(5)), (IPR1, IFILE(6)) 
C        Dummy DATA statement to avoid useless compiler warnings
      DATA I / 0 /  
      IF (KNUM.EQ.0 .AND. KLIT.EQ.0) CALL KERNER (-4, 'KETERM') 
C        ALLWAYS READ 80 COLUMNS
      READ (IRD, FMT = '(A80)', END = 105, ERR = 105)  CHIN 
      GOTO 120  
C        CARD EMPTY.
  105 WRITE (IPR1, 110) 
  110 FORMAT (' Your input line is empty' ) 
      REWIND IRD
      KEND = -1 
      RETURN
  120 CALL KERINB (LIT, 1)  
      IF (NFNUM.GT.0 .OR. NLIT.GT.0) GOTO 140   
      KEND = -2 
      WRITE (IPR1, 130) 
  130 FORMAT (' Blank line' )   
      RETURN
  140 IF ((KNUM.GE.0 .AND. NFNUM.NE.KNUM) .OR.  
     *    (KLIT.GE.0 .AND. NLIT .NE.KLIT))    THEN  
C            COUNTS ARE NOT OK. 
         WRITE (IPR1, 142) KLIT, KNUM, NLIT, NFNUM  
  142    FORMAT (' Program requested', I3, ' literal(s) and',   
     +   I3, ' number(s)' / ' but you supplied:', I3,   
     +   ' literal(s) and', I3, ' number(s). Please, try again'  /) 
         KEND = -3  
         RETURN 
         ENDIF  
C           COUNTS OK.  
      KEND = 99 
C        CHECK: IF ONLY ONE ONE-CHARACTER LITERAL ON THIS LINE  
      IF (NFDOL(2).NE.0) RETURN 
      IF (NLIT.EQ.1)  I = NCOLL(1)  
      IF (NFNUM.EQ.1) I = NCOLN(1)  
      IF (CHIN(I+1:I+1).NE.' ') RETURN  
C        ONE-CHARACTER INTERPRETATION IS GIVEN AS KEND (FROM KERC2I)
      CALL KERC2I (CHIN(I:I), KEND) 
      IF (KEND.LT.0) KEND = 99  
      RETURN
C        END OF SUBROUTINE KETERM   
      END   
CSUBROUTINE SHOUT   
C-----------------------------------------------------------------------
C Print CHOUT with FORMAT A72 to unit LIS1 (usually unit 7) and if  
C IPR1 .NE. LIS1 also to unit IPR1 (= 6 = terminal output)  and if  
C LIS2 .NE. LIS1 also to unit LIS2 (by calling SHOUT2)  
C INPUT : CHOUT (present in COMMON /SYSTB/) 
C         note that CHOUT(1:1) is the carriage control character.   
C If CHOUT(1:1)='0' it is blanked and replaced by an extra line in LIS1 
C+----------------------------------------------------------------------
      SUBROUTINE SHOUT  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (IPR1, IFILE(6)), (LIS1, IFILE(7))
      CHARACTER      CHOUTX *72 
      CHOUTX = CHOUT
      CHOUTX(1:1) = ' ' 
      IF (IPR1.NE.LIS1) WRITE (IPR1, 100) CHOUTX
  100 FORMAT (A72)  
      CALL SHOUT2   
C        clear CHOUT done in SHOUT2 
      RETURN
C        END OF SUBROUTINE SHOUT
      END   
CSUBROUTINE SHOUT2  
C-----------------------------------------------------------------------
C Print CHOUT to LIS1 and to LIS2, not to TERMINAL; see subroutine SHOUT
C IF CHOUT(1:1) .EQ. 0 THEN   extra blank line  
C+----------------------------------------------------------------------
      SUBROUTINE SHOUT2 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (LIS1, IFILE(7)), (LIS2, IFILE(8))
  100 FORMAT (A72)  
  101 FORMAT (/A72) 
      IF (CHOUT(1:1) .EQ. '0') THEN 
         CHOUT(1:1) = ' '   
         WRITE (LIS1, 101) CHOUT
         IF (LIS1 .NE. LIS2) WRITE (LIS2, 101) CHOUT
      ELSE  
         WRITE (LIS1, 100) CHOUT
         IF (LIS1 .NE. LIS2) WRITE (LIS2, 100) CHOUT
         ENDIF  
C        clear CHOUT
      CHOUT = ' '   
      RETURN
C        END OF SUBROUTINE SHOUT2 / END of subfile NIJX1
      END   
CSUB : second part of the NIJX subroutines  
C Summary of standard file handling routines
C RDCRYS : OPEN and REWIND if present.    If not present: error stop
C BINIFF : OPEN and REWIND if present.    If not present: error stop
C BINOFF : OPEN.    REWIND if present   
C ATOMIN : (no OPEN or REWIND)   If NAT=0 or error found: error stop
C RDCOND : OPEN and REWIND if present.    If not present: RETURN
C LOGRD  :  
C LOGWR  :  
C General definitions and conventions of file unit numbers and names
C file name    FILE IUNIT          Comment  
C                number 
C DDJOB        IDDJ    1           JOB: DDparameters given by user  
C DDLOG        IDDL    1           log book and important data  
C DDSYST       IDDS    2           JOB: sequence of programs
C ATOMS *1     IATOMS  1           atomic input parameters  
C ATOUT *1     IATOUT  2           atomic output parameters 
C CRYSDA       ICRYS   3           crystal data 
C CONDA        ICON    4           control data 
C         TERM IRD     5           terminal input   
C         TERM IPR1    6           terminal output  
C LISTING LIS1 LIS1    7 (DISP MOD printer output, rec. length  80  
C PGM   LISTING LIS2 LIS2    8 (DISP MOD printer output (auxil.), "  132
C DDHELP LIST  IHELP   9           text file for questions  
C CONDA2       ICON2  10 (DISP MOD old control data file
C E100         IE100  10           control data for PHASEX  
C FREFA        IFREF  11           structure factors, LRECL 28  
C FREFB        IFREF  11           structure factors, LRECL 28  
C FREFC        IFREF  11           structure factors, LRECL 28  
C HKL          IHKL   12           structure factors, not yet def.  
C SHELX        ..                  .. SHELX FORMAT  
C BINX         IBINX  12           structure factors, not yet used  
C BINFO        IBINFO 11           binary data file Fobs
C BINFC        IBINFC 12           binary data file Fcalc   
C BINFC2       IBINFC 12           binary data file Fcalc (expand)  
C BINS         IBINS  13           binary scratch file  
C BINDUA       IBINDU 14           binary data file for PHASEX  
C BINDIF       IBINDI 15           binary data file of PHASEX   
C BINFFT       IBINFF 16           binary data file for FFT 
C FMAP         IFMAP  17           bin.data: Fourier map from FFT   
C BINBIG       IBINBI 18           big bin. scratch file  in FFT2   
C *1: ATOM-files
C ATOMS        IATOMS   
C ATMOD        IATMOD   
C ATOLD        IATOLD    (DISP MOD  
C XYZN         IXYZN
C XYZI         IXYZI
C XYZO         IXYZO     (DISP MOD  
C Note: files 1 - 7, 9 and 10 are formatted with fixed record length 80,
C         but usually only filled up to record length 72
C       file 8 is formatted with fixed record length 132 (auxiliary)
C       file 11 - 20 are usually unformatted
C       file 11 and 12 can be formatted (MERBIN only)   
C+----------------------------------------------------------------------
CSUBROUTINE FILINQ (IUNIT, FNAMEX, FFORMX, FKEYX, KINQ) 
C-----------------------------------------------------------------------
C INQUIRES about files and can OPEN files and REWIND files. 
C IUNIT:  file unit number  
C FNAMEX: file name (IBM: as used in EXEC file definition)  
C         may be modified (concat. with CCODE, etc.) by subr. FILINX
C FFORMX: I/O access mode, 'FORMATTED' or 'UNFORMATTED' 
C FKEYX:  option KEY (what to do with this file?).  
C         Possible options:  'SCRATCH', 'TEST', 'INPUT' or 'OUTPUT' 
C KINQ:   -1 or 0: return KEY for old and present file status   
C Summary   
C If FKEYX = 'SCRATCH' :
C        OPEN file using STATUS = 'SCRATCH',
C ELSE, if present: 
C        OPEN file using STATUS = 'OLD' 
C ELSE, if not present: 
C        OPEN file using STATUS = 'NEW' only if 'OUTPUT' is requif ed.  
C REWIND an existing file, if it has been opened earlier,   
C    unless 'TEST' is asked for.
C   (Note: files LIS1 and LIS2 have special treatement, see KEPROG) 
C List of KINQ return key values:   
C If FKEYX = 'SCRATCH'  
C    KINQ = -1 : file was not present, a new one is opened now. 
C    KINQ =  0 : file was present, it has been opened,  REWIND. 
C If FKEYX = 'TEST' 
C    KINQ = -1 : file was not present, no file opened.  
C    KINQ =  0 : file was present, it was opened earlier or 
C                it has been opened now. No REWIND. 
C If FKEYX = 'INPUT'
C    KINQ = -1 : file was not present, no file opened (this could by
C                a user error: the calling routine must test KINQ). 
C    KINQ =  0 : file was present, it has been opened,  REWIND. 
C If FKEYX = 'OUTPUT'   
C    KINQ = -1 : file was not present, a new one has been opened.   
C    KINQ =  0 : file was present but not opened:   
C                   it has been opened now, but no REWIND   
C              : file was present and opened; now also: REWIND  
C                (VAX: for LIS1 and LIS2 defined as APPEND) 
C KINQ is stored in IFSTAT(IUNIT) if IUNIT is equal to IFILE(IUNIT).
C Note: IFSTAT(..) = -2 set by KEPROG (i.e.: file not yet tested).  
C       IFSTAT(..) = -2 set by FILCLO on deleting the file. 
C       IFSTAT(..) = -3 set by FILCLO on closing, STATUS = 'KEEP'.  
C On any error return from INQUIRE or OPEN : STOP, no RETURN.   
C+----------------------------------------------------------------------
      SUBROUTINE FILINQ (IUNIT, FNAMEX, FFORMX, FKEYX, KINQ)
CPTB *64 ! voor FNAME *7
      CHARACTER FNAMEX *(*), FFORMX *(*), FKEYX *(*),   
     *          FNAME  *64,  FFORM  *11,  FKEY  *7  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
*95   LOGICAL SWFILX
      EQUIVALENCE (LIS1, IFILE(7))  
*95   EQUIVALENCE (SWFILX, SWITCH(6))   
***   EQUIVALENCE (UNIT6, SWITCH(3))   logical UNIT6   === niet nodig!  
C        FORMIN = current I/O-mode ('FORMATTED' or 'UNFORMATTED') of
C                 an already existing and connected (= opened) file 
C                 as found by INQUIRE when inquif ing by file name. 
C        POSFMT = FORMATTED I/O-access possible?   'YES', 'NO' or   
C                 'UNKNOWN'.
C        POSUNF = UNFORMATTED I/O-access possible? 'YES', 'NO' or   
C                 'UNKNOWN'.
C        NUM    = unit number to which an existing and already  
C                 opened file is connected as found by INQUIRE when 
C                 inquif ing by file name.  
C        FULNAM = full file name of an already existing and named   
C                 (NMD = .TRUE.) file as returned by INQUIRE when   
C                 inquif ing by file name or by a unit number to which  
C                 an already existing and named (NMD = .TRUE.) file 
C                 is connected (= opened).  
      CHARACTER FORMIN *11, FULNAM *255, POSFMT *7, POSUNF *7, FULNA *63
      LOGICAL   OPN, EXS, NMD   
      FNAME = FNAMEX
C95:  IF (SWFILX) CALL FILINX (FNAME)   
      CALL FILINX (FNAME)   
      FFORM = FFORMX
      FKEY  = FKEYX 
      IF (FKEY.NE.'SCRATCH' .AND. FKEY.NE.'TEST' .AND. FKEY.NE.'INPUT'  
     *    .AND. FKEY.NE.'OUTPUT') THEN  
         WRITE (CHOUT, 147) FKEY
  147    FORMAT (' ERROR : ',A7,' used for SCRATCH TEST INPUT OUTPUT?') 
         CALL SHOUT 
         WRITE (CHOUT, 148) IUNIT   
  148    FORMAT (' ERROR ! other call params: UNIT=',I3,'  FNAME=   ')  
         CHOUT (48:72) = FNAME  
         CALL SHOUT 
         CALL KERROR('Programmers error in call params', 147, 'FILINQ') 
         ENDIF  
      IF (IUNIT.LE.0 .OR. IUNIT.GT.20) THEN 
         WRITE (CHOUT, 151) IUNIT   
  151    FORMAT (' ERROR :  in call params: UNIT=', I3, '  FNAME=   ')  
         CHOUT (49:72) = FNAME  
         CALL SHOUT 
         CALL KERROR ('Bad file unit number', 151, 'FILINQ')
         ENDIF  
C        Inquif e by name   
      INQUIRE (FILE = FNAME, ERR  = 900, IOSTAT = KINQ, EXIST = EXS,
     *         OPENED = OPN, FORM = FORMIN, NUMBER = NUM,   
     *         NAMED  = NMD, NAME = FULNAM, 
     *         FORMATTED = POSFMT, UNFORMATTED = POSUNF)
C     Inquif e by unit number is not possible in IBM VSFORTRAN (1990).  
C     So we trust that the unit number is not in use for another file.  
C        If file exists and opened already, test I/O-mode and   
C        unit number, then REWIND (if not 'TEST').  
      IF ( EXS ) THEN   
         IF ( OPN ) THEN
            IF (FORMIN .NE. FFORM ) GOTO 910
            IF (NUM    .NE. IUNIT ) GOTO 920
            IF (FKEY   .NE. 'TEST') REWIND IUNIT
            GOTO 200
            ENDIF   
C        File exists but not yet opened; test requested I/O-mode
C UNIX ?  apparently POSFMT is never YES:   POSFMT .NE. 'YES' chanched: 
         IF (FFORM .EQ. '  FORMATTED' .AND. POSFMT .EQ. 'NO') GOTO 930  
         IF (FFORM .EQ. 'FORMATTED'   .AND. POSFMT .EQ. 'NO') GOTO 930  
         IF (FFORM .EQ. 'UNFORMATTED' .AND. POSUNF .EQ. 'NO') GOTO 932  
         IF (FKEY .EQ. 'SCRATCH') THEN  
            OPEN (UNIT = IUNIT, ERR = 940, IOSTAT = KINQ,   
     *            FORM = FFORM, STATUS = 'SCRATCH') 
Corr 15 Jul 93  
            REWIND IUNIT
            GOTO 200
            ENDIF   
         OPEN (UNIT = IUNIT, ERR = 940, IOSTAT = KINQ, FILE = FNAME,
     *         FORM = FFORM, STATUS = 'OLD')
Corr 15 Jul 93  
         REWIND IUNIT   
C        Set IFSTAT(IUNIT)=0 / KINQ=0 / RETURN  
  200    IF (IUNIT .EQ. IFILE(IUNIT)) IFSTAT(IUNIT) = 0 
         KINQ = 0   
      ELSE  
C        File does not exist, open a new file according to FKEY.
         IF (FKEY .EQ. 'SCRATCH') THEN  
            OPEN (UNIT = IUNIT, ERR = 950, IOSTAT = KINQ,   
     *            FORM = FFORM, STATUS = 'SCRATCH') 
         ELSEIF (FKEY .EQ. 'OUTPUT') THEN   
            OPEN (UNIT = IUNIT, ERR = 950, IOSTAT = KINQ, FILE = FNAME, 
     *            FORM = FFORM, STATUS = 'NEW') 
            ENDIF   
C        Set IFSTAT(IUNIT) = -1 to indicate initial non-existence.  
         IF (IUNIT .EQ. IFILE(IUNIT)) IFSTAT(IUNIT) = -1
         KINQ = -1  
         ENDIF  
      RETURN
C Error statements. 
  900 WRITE (LIS1, 901) IUNIT, FNAME, KINQ  
  901 FORMAT (  
     *' ERROR Transmission error during execution of INQUIRE statement'/
     * 'ERROR ? Unit number:',I3,' File name: ', A24,' Error code:',I4) 
      GOTO 990  
  910 WRITE (LIS1, 911) FNAME, IUNIT, FFORM, FORMIN 
  911 FORMAT ( ' ERROR :',  
     * ' The requested c.q. expected I/O-access mode of an already' /   
     * ' ERROR !',  
     * ' existing and opened file does not match the I/O-access mode' / 
     * ' ERROR !',  
     * ' found by INQUIRE for file name: ',A24, 'Unit number: ', I2 /   
     * ' ERROR ! Requested mode: ', A11, 5X,'Mode found: ', A11)
      IF ( NMD ) GOTO 917   
C        error msg for unnamed files
  912 WRITE (LIS1, 913) 
  913 FORMAT (' ERROR :',   
     *    ' Full file name not returned by INQUIRE, unnamed file!') 
      GOTO 990  
C        error msg for named files  
C        PTB 25 Jun 1990 /Wil oud/ Wil 27 Nov. Wat4 / PTB : JS overleg: 
  917 FULNA = FULNAM
      WRITE (LIS1, 918) FULNA   
  918 FORMAT (' ERROR : Full file name: ',A63)  
      GOTO 990  
  920 WRITE (LIS1, 921) FNAME, IUNIT, NUM   
  921 FORMAT ( ' ERROR :',  
     * ' The requested c.q. expected unit number of an already',/,  
     * ' ERROR !',  
     * ' existing and opened file does not match the unit number',/,
     * ' ERROR ! found by INQUIRE for file name: ',A32/,
     * ' ERROR ! Requested unit number:',I3,5X,'Unit number found:',I3) 
      IF ( NMD ) GOTO 917   
      GOTO 912  
  930 WRITE (LIS1, 931) FNAME, IUNIT, FFORM, POSFMT 
  931 FORMAT (' ERROR :',   
     * ' The requested I/O-access mode for an already existing file' /  
     * ' ERROR !',  
     * ' does not match the allowed I/O-access mode for this file as' / 
     * ' ERROR !',  
     * ' found by INQUIRE for file name: ',A24, 'Unit number: ', I2 /   
     * ' ERROR !',  
     * ' Requested mode: ', A11, 5X, 'FORMATTED mode allowed: ', A7)
      IF ( NMD ) GOTO 917   
      GOTO 912  
  932 WRITE (LIS1, 933) FNAME, IUNIT, FFORM, POSUNF 
  933 FORMAT (' ERROR :',   
     * ' The requested I/O-access mode for an already existing file' /  
     * ' ERROR !',  
     * ' does not match the allowed I/O-access mode for this file as' / 
     * ' ERROR !',  
     * ' found by INQUIRE for file name: ',A24, 'Unit number: ', I2 /   
     * ' ERROR !',  
     * ' Requested mode: ', A11, 5X, 'UNFORMATTED mode allowed: ', A7)  
      IF ( NMD ) GOTO 917   
      GOTO 912  
  940 WRITE (LIS1, 941) FKEY, IUNIT, FNAME, KINQ
  941 FORMAT (' ERROR :',   
     * ' Transmission error during execution of OPEN statement' /   
     * ' ERROR ! on an already existing file, option ', A7 /
     * ' ERROR !',  
     * ' Unit number: ',I2, 4X, 'File name: ', A24, ' Error code: ',I4) 
      GOTO 990  
  950 WRITE (LIS1, 951) FKEY, IUNIT, FNAME, KINQ
  951 FORMAT (' ERROR :',   
     * ' Transmission error during execution of OPEN statement' /   
     * ' ERROR ! for a new file, option ', A7 / 
     * ' ERROR !',  
     * ' Unit number: ',I2, 4X, 'File name: ', A24, ' Error code: ',I4) 
C        Error message also to terminal:
  990 WRITE (CHOUT, 992) FNAME  
  992 FORMAT (' File error concerning file (name): ', A32)  
      CALL KERROR (CHOUT, 0, 'FILINQ')  
C        END OF SUBROUTINE FILINQ   
      END   
CSUBROUTINE FILCLO (IUNIT, FKEYX)   
C-----------------------------------------------------------------------
C Closes files  
C IUNIT: file unit number   
C FKEYX: option KEY, 'SCRATCH', 'DELETE', 'KEEP'
C Test if file exist and is opened. If not, return without any action.  
C If FKEYX = 'SCRATCH' : close and delete file with STATUS = 'DELETE'   
C       IFSTAT(IUNIT) = -2 as if unused 
C If FKEYX = 'DELETE'  : close and delete file with STATUS = 'DELETE'   
C       IFSTAT(IUNIT) = -2 as if unused 
C If FKEYX = 'KEEP' : close and keep file with STATUS = 'KEEP'  
C       IFSTAT(IUNIT) = -3 i.e. file is still present.  
C Note: IFSTAT(IUNIT) is reset only if IUNIT is equal IFSTAT(IUNIT) 
C       IFSTAT(..)    is set -2 by KEPROG (i.e. not yet tested) 
C       IFSTAT(..)    is set 0or -1 by FILINQ (i.e. now in use) 
C If error detected during inquif ing or opening, STOP, no RETURN   
C+----------------------------------------------------------------------
      SUBROUTINE FILCLO (IUNIT, FKEYX)  
      CHARACTER  FKEYX *(*), FKEY *7
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (LIS1, IFILE(7))  
      LOGICAL  OPN  
C --- CHARACTER  FKEYX *(*), FKEY *7
      FKEY = FKEYX  
      IF (FKEY .EQ. 'SCRATCH') FKEY = 'DELETE'  
      IF (FKEY.NE.'KEEP'.AND.FKEY.NE.'DELETE') CALL KERNER(-4,'FILCLO') 
      INQUIRE (UNIT = IUNIT, ERR = 200, OPENED = OPN)   
      IF (.NOT. OPN) RETURN 
C        file exist and is opened, now close and keep or delete 
      CLOSE (UNIT = IUNIT, ERR = 200, IOSTAT = KCLO, STATUS = FKEY) 
      IF (KCLO.GE.1)  GOTO 200  
      KCLO = -3 
      IF (FKEY.EQ.'DELETE') KCLO = -2   
      IF (IUNIT.EQ.IFILE(IUNIT)) IFSTAT(IUNIT) = KCLO   
      RETURN
C        close error detected   
  200 WRITE (CHOUT, 210) IUNIT, FKEY
  210 FORMAT (' ERROR on closing file ', I3, ', option: ', A7)  
      CALL KERROR (CHOUT, 0, 'FILCLO')  
C        END OF SUBROUTINE FILCLO   
      END   
CPAG      RDCRY    A COLLECTION OF CRYSDA INPUT ROUTINES      OCT 1986  
C-----------------------------------------------------------------------
C CONTENTS  
C 43 RDCRYS  READS MOST IMPORTANT ITEMS FROM CRYSDA TO FILL /CRYSA/ 
C 44 RDCRYB  PLACES THE POINTER AT ONE RECORD IN CRYSDA FILE
C 45 RDCRYX  READ N FLOATING NUMBERS FROM CRYSDA FILE   
C RDCRYS: READ DATA FROM CRYSDA FILE, unit ICRYS (USUALLY 3) ,  
C         fill COMMON /CRYSA/ and /CRYSB/ , and get CCODE from file.
C RDCRYB: SEARCHES IN THE CRYSDA FILE (ICRYS) FOR THE   
C         RECORD WITH THE KEYWORD GIVEN (LLIT)  
C RDCRYX: Read one or two records from the CRYSDA file, defined by LLIT 
C File structure: formatted records, see CRYSDA write-up.   
C The contents of the COMMON /CRYSA/ and /CRYSB/ are as 
C described in the CRYSDA write-up for items with the same name.
C Otherwise: ABSMU = MU, AMOLW = MOLW, ZET = Z, and:
C CELATY(I) is the chemical symbol for one atom type as 
C given on the FORMUL record,   
C CELALL(I) is the corresponding number of atoms in the 
C unit cell (i.e. as given in FORMUL, multiplied by Z). 
C+----------------------------------------------------------------------
CSUBROUTINE RDCRYS (ICRYS)  
C-----------------------------------------------------------------------
C Read DATA from CRYSDA file, unit ICRYS (usually 3) ,  
C fill COMMON /CRYSA/ and /CRYSB/ , and get CCODE from file.
C Input :  ICRYS, INPUT FILE  (NORMALLY UNIT 3) 
C Wrong data on the CRYSDA file leeds to an error STOP here.
C Note: If CCODE is already known and CCODE on the CRYSDA   
C         file is different, no data will be INPUT (error stop) 
C The contents of the COMMON /CRYSA/ and /CRYSB/ are as 
C    described in the CRYSDA write-up for items with the same name. 
C Otherwise: ABSMU = MU, AMOLW = MOLW, ZET = Z, and:
C CELATY(I) is the chemical symbol for one atom type as 
C    given on the FORMUL record,
C CELALL(I) is the corresponding number of atoms in the 
C    unit cell (i.e. as given in FORMUL, multiplied by Z).  
C    Note: CELATY and CELALL are defined for I=1,NTYPE only.
C Calls: RDCRYM, RDCRYB, KERNER 
C+----------------------------------------------------------------------
      SUBROUTINE RDCRYS (ICRYS) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (LIS1, IFILE(7)), (LIS2, IFILE(8))
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      COMMON /CRYSB/ SPGR,     WAVEAT,      CELATY(10)  
      CHARACTER      SPGR *16, WAVEAT *2,   CELATY *2   
      CHARACTER CONT*1  
      CHARACTER * 6  XTEST  
      CHARACTER * 6  LLIT(30)   
      CHARACTER * 6  NAME   
      DATA NAME    / 'RDCRYS' / 
      DATA LLMAX   / 27 /   
      DATA LLIT   / 'CRYSDA', 'CELL  ', 'CELLSD', 'SPGR  ', 'RCELL ',   
     +              'VOLUM ', 'WAVE  ', 'FORMUL', 'MOLW  ', 'Z     ',   
     +              'NELEC ', 'F000  ', 'MU    ', 'ICENT ', 'ILATT ',   
     +              'ISYST ', 'ILAUE ', 'IMULT ', 'IUNIQ ', 'IPOLA ',   
     +              'NTYPE ', 'NSYMM ', 'NLATT ', 'FRAC2C', 'CART2F',   
     +              'RRMAT ', 'SSMAT ', '      ', '      ', '      ' /  
      DATA NPRI / 0 /   
      CALL FILINQ (ICRYS, 'CRYSDA', 'FORMATTED', 'INPUT', KINQ) 
      IF (KINQ.EQ.-1) THEN  
         WRITE (CHOUT, 100) CCODE   
  100    FORMAT (' ERROR no crysda file found for ', A6)
         CALL KERROR (CHOUT, 0, 'RDCRYS')   
         ENDIF  
      NPRI = NPRI + 1   
      DO 170 I=1,LLMAX  
      CALL RDCRYB (ICRYS, LLIT(I), KEND)
C        KEND=1 if LLIT(I) found on columns (1:...) 
      IF (KEND.LT.0) THEN   
         WRITE (CHOUT, 917) LLIT(I) 
  917    FORMAT (' ERROR : search for keyword ', A6,
     *           ' on CRYSDA file failed')  
         CALL SHOUT 
         GOTO 990   
         ENDIF  
      GOTO  (1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 
     *      16,17,18,19,20,21,22,23,24, 25, 26, 27,170,170,170), I  
C        CRYSDA 
    1 IF (NPRI .EQ. 1) WRITE (LIS2, 101)
  101 FORMAT (' Input crystal data file  CRYSDA')   
      CALL KERINB (LIT(32),1)   
** Mar 96:  CCODE = 'CCODE' as default in auxiliar programs (no DDJOB!) 
      IF (CCODE .EQ. ' ' .OR. CCODE .EQ. 'CCODE') CCODE = LIT(2)
      IF (CCODE .EQ. LIT(2)) GOTO 170   
C        ERROR  
      WRITE (LIS1, 102) LIT(2), CCODE   
  102 FORMAT (' Error: compound code on CRYSDA file is: ', A6,  
     * ' expected: ', A6)   
      GOTO 990  
C        CELL   
    2 READ (CHIN, 130) CELL 
      GOTO 170  
C        CELLSD 
    3 READ (CHIN, 130) CELLSD   
      GOTO 170  
C        SPGR   
C NOTE: SPGR TO BE COMPRESSED TO A16 (LATER)
    4 CONTINUE  
      SPGR = CHIN(11:26)
      GOTO 170  
C        RCELL  
    5 READ (CHIN, 130) RCELL
      GOTO 170  
C        VOLUM  
    6 READ (CHIN, 130) VOLUM
      GOTO 170  
C        WAVE   
    7 READ (CHIN, 107) WAVEAT, WAVE 
  107 FORMAT (10X, A2, 8X, F10.6)   
      GOTO 170  
C        FORMUL 
    8 READ (CHIN, 108) (CELATY(J), CELALL(J), J=1,5), CONT  
  108 FORMAT (10X, 5(A2, F9.2, 1X), 1X, A1) 
      IF (CONT.EQ.'=') READ (ICRYS,108) (CELATY(J), CELALL(J), J=6,10)  
      GOTO 170  
C        MOLW   
    9 READ (CHIN, 130) AMOLW
      GOTO 170  
C        Z  
   10 READ (CHIN, 140) IZ   
      ZET = IZ  
      GOTO 170  
C        NELEC  
   11 READ (CHIN, 140) NELEC
      GOTO 170  
C        F000   
   12 READ (CHIN, 130) F000 
      GOTO 170  
C        MU 
   13 READ (CHIN, 130) ABSMU
      GOTO 170  
   14 READ (CHIN, 140) ICENT
      GOTO 170  
   15 READ (CHIN, 140) ILATT
      GOTO 170  
   16 READ (CHIN, 140) ISYST
      GOTO 170  
   17 READ (CHIN, 140) ILAUE
      GOTO 170  
   18 READ (CHIN, 140) IMULT
      GOTO 170  
   19 READ (CHIN, 140) IUNIQ
      GOTO 170  
   20 READ (CHIN, 140) IPOLA
      GOTO 170  
   21 READ (CHIN, 140) NTYPE
      DO 121 J=1,NTYPE  
  121 CELALL(J) = CELALL(J) * ZET   
      GOTO 170  
   22 READ (CHIN, 140) NSYMM
CCC      COMING FROM RDCRYM 
      DO 122 M=1,NSYMM  
  122 READ (ICRYS,1122) XTEST, ((IRSYMM(J,K,M),K=1,3),TSYMM(J,M),J=1,3) 
 1122 FORMAT (A6, 4X, 3(3I3,1X,F10.7))  
      IF (XTEST .NE. 'SYMMAT') GOTO 990 
      GOTO 170  
   23 READ (CHIN, 140) NLATT
CCC      COMING FROM RDCRYM 
      DO 123 M=1,NLATT  
  123 READ (ICRYS, 1123) XTEST, (TLATT(J,M), J=1,3) 
 1123 FORMAT (A6, 4X, 3(F10.7)) 
      IF (XTEST .NE. 'CENVEC') GOTO 990 
      GOTO 170  
   24 BACKSPACE ICRYS   
      READ (ICRYS, 150) ((FRAC2C(J,K), K=1,3), J=1,3)   
      GOTO 170  
   25 BACKSPACE ICRYS   
      READ (ICRYS, 150) ((CART2F(J,K), K=1,3), J=1,3)   
      GOTO 170  
   26 BACKSPACE ICRYS   
      READ (ICRYS, 150) ((RRMAT(J,K), K=1,3), J=1,3)
      GOTO 170  
   27 BACKSPACE ICRYS   
      READ (ICRYS, 150) ((SSMAT(J,K), K=1,3), J=1,3)
  130 FORMAT (10X, 6F10.5)  
  140 FORMAT (10X, I10) 
  150 FORMAT (3(10X, 3F15.6, /))
  170 CONTINUE  
C        input DO LOOP completed. Write sp gr and cell: 
      IF (NPRI .NE. 1) RETURN   
      WRITE (LIS2, 171) CELL, SPGR  
  171 FORMAT (' Cell', 3F8.3, 3F7.2, '  SpGr ', A16)
C NOTE: SPGR TO BE COMPRESSED TO A16 (LATER)
C        print cell & sp.gr if DDSTART and FFT (and ...?)   
      IF (PROGNM .EQ. 'DDSTART' .OR. PROGNM .EQ. 'FFT') 
     *   WRITE (LIS1, 171) CELL, SPGR   
      RETURN
  990 WRITE (LIS1,991) LLIT(I)  
  991 FORMAT (' ERROR : CONTENTS OF CRYSDA FILE INCORRECT: '/   
     *        ' ERROR ! TRYING TO READ RECORD: ', A6)   
      CALL KERNER (-6, NAME)
      RETURN
C        END OF SUBROUTINE RDCRYS   
      END   
CSUBROUTINE RDCRYB (ICRYS, LLITX, KEND) 
C---------------------------------------------------------------------- 
C Searches in the CRYSDA file (ICRYS) for the   
C record with the keyword given (LLITX) 
C and reads this record into CHIN(1:80).          No OPEN nor CLOSE file
C Input :  ICRYS = Input file (normally UNIT 3) 
C          LLITX = The keyword  
C Output:  KEND  = Return key  (KEND = -1 record not found) 
C                              (KEND =  1  well positioned) 
C Note: -  Data can be extracted from CHIN by an internal   
C          Read:     Read (CHIN, formatnr) listofvariables  
C       -  Some items (e.g. CELCO, FORMUL) are given on more
C          than one record and can be obtained by:  
C             backspace ICRYS   
C             read (ICRYS, formatnumber) listofvariables
C       -  The FREEFORMAT interpretation of the array CHIN can be   
C          done by: call KERINB (LIT,1) 
C          where LIT(1) is used as a DUMMY KEYWORD ARRAY.   
C+----------------------------------------------------------------------
      SUBROUTINE  RDCRYB (ICRYS, LLITX, KEND)   
      CHARACTER LLITX *(*), LLIT *6 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      LLIT = LLITX  
      KEND = -3 
  100 READ (ICRYS, 110, END=120) CHIN   
  110 FORMAT (A80)  
      IF (CHIN(1:4).EQ.'END')  GOTO 120 
      IF (CHIN(1:6).EQ.LLIT) GOTO 130   
CPTB Oct 93 corr 96:  1:6 => 1:5
      IF (CHIN(1:5).EQ.'TITLE' .AND. TITLE.EQ.' ') TITLE = CHIN(8:71)   
      GOTO 100  
  120 KEND = KEND + 1   
      REWIND ICRYS  
      IF (KEND.LT.-1) GOTO 100  
      RETURN
  130 KEND = 1  
      RETURN
C       END OF SUBROUTINE RDCRYB
      END   
CSUBROUTINE RDCRYX (ICRYS, LLITX, F, N) 
C---------------------------------------------------------------------- 
C Read one or two records from the CRYSDA file, defined by LLIT .   
C If N LE 6: Reads one record defined by LLIT   
C            with FORMAT (10X, N F10.5) and stores  
C            the N numerical results in ARRAY F(N)  
C            If N GT 6: reads two records with the scattering   
C            factors of one atom (SEQUENTIAL INPUT) 
C Input:  ICRYS = Input file (normally UNIT 3)  
C         LLIT  = Keyword for search,   
C                 CHARACTER*6 (e.g.: 'WAVE')
C Output: F     = Array with N real numbers 
C Needed: N     = Dimension of F,   
C                 Requested number of data  
C Calls: RDCRYB, KERNER 
C+----------------------------------------------------------------------
      SUBROUTINE RDCRYX (ICRYS, LLITX, F, N)
      CHARACTER LLITX *(*), LLIT *6 
      DIMENSION F(N)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      CHARACTER * 6  NAME   
      DATA NAME   / 'RDCRYX' /  
      LLIT = LLITX  
      CALL RDCRYB (ICRYS, LLIT, KEND)   
      IF (KEND.LT.0) GOTO 990   
      M = MIN0 (6, N)   
      READ (CHIN, 100) (F(I), I=1,M)
  100 FORMAT (10X, 6F10.5)  
      IF (N.LE.6) RETURN
C         IF N > 6, ONLY SFAC   
      IF (LLIT.NE.'SFAC') GOTO 990  
      READ (ICRYS, 110) (F(I), I=7,N)   
  110 FORMAT (10X, 3F10.5, 2F7.3, F11.3, F5.2)  
      RETURN
C         RECORD NOT FOUND  
  990 CALL KERNER (-2, NAME)
      RETURN
C        END OF SUBROUTINE RDCRYX   
      END   
CSUBROUTINE RCELLR (CELL, V, RCELL) 
C-----------------------------------------------------------------------
C Invert cell dimensions (a b c alpha beta gamma)        | Note:
C Input:    CELL:  unit cell dimensions                  | v.v. RCELL   
C Output:   V:     calculated volume of the cell         | v.v. 1/VOLUM 
C           RCELL: reciprocal cell dimensions            | v.v  CELL
C+----------------------------------------------------------------------
      SUBROUTINE RCELLR (CELL, V, RCELL)
      DIMENSION CELL(6), RCELL(6), AC(6)
      EQUIVALENCE (AC(1),      A), (AC(2),      B),  (AC(3),      C)
      EQUIVALENCE (AC(4),  ALPHA), (AC(5),   BETA),  (AC(6),  GAMMA)
*     R2D = 180. / 3.1415926535 
      R2D = 45. / ATAN(1.0) 
      CALL KERNAB (CELL, AC, 6) 
      CA = COS(ALPHA / R2D) 
      CB = COS(BETA  / R2D) 
      CC = COS(GAMMA / R2D) 
      SA = SQRT(1.0-CA**2)  
      SB = SQRT(1.0-CB**2)  
      SC = SQRT(1.0-CC**2)  
      CASTR = (CB*CC-CA) / (SB*SC)  
      CBSTR = (CA*CC-CB) / (SA*SC)  
      CCSTR = (CA*CB-CC) / (SA*SB)  
      SASTR = SQRT(1.0-CASTR**2)
      SBSTR = SQRT(1.0-CBSTR**2)
      SCSTR = SQRT(1.0-CCSTR**2)
      V = A*B*C * SQRT (1.0-CA*CA-CB*CB-CC*CC+2.0*CA*CB*CC) 
      RCELL(1) = B*C*SA / V 
      RCELL(2) = A*C*SB / V 
      RCELL(3) = A*B*SC / V 
      RCELL(4) = ASIN(SASTR) * R2D  
      RCELL(5) = ASIN(SBSTR) * R2D  
      RCELL(6) = ASIN(SCSTR) * R2D  
      IF (CASTR .LT. 0.0) RCELL(4) = 180.0 - RCELL(4)   
      IF (CBSTR .LT. 0.0) RCELL(5) = 180.0 - RCELL(5)   
      IF (CCSTR .LT. 0.0) RCELL(6) = 180.0 - RCELL(6)   
****  CALL KERNAB (RC, RCELL, 6)
      RETURN
C        END of subroutine RCELLR   
      END   
CSUBROUTINE CELLRR (CELL, RR)   
C-----------------------------------------------------------------------
C Given the CELL, calculate metric tensor RR = RRMAT
C+----------------------------------------------------------------------
      SUBROUTINE CELLRR (CELL, RR)  
      DIMENSION CELL(6), RR(3,3)
*     R2D = 180. / 3.1415926535 
      R2D = 45. / ATAN(1.0) 
      CA = COS(CELL(4) / R2D)   
      CB = COS(CELL(5) / R2D)   
      CC = COS(CELL(6) / R2D)   
C        real space metric tensor = THE CONTRAVARIANT METRIC TENSOR 
      RR(1,1) = CELL(1) * CELL(1)   
      RR(1,2) = CELL(1) * CELL(2) * CC  
      RR(1,3) = CELL(1) * CELL(3) * CB  
      RR(2,1) = RR(1,2) 
      RR(2,2) = CELL(2) * CELL(2)   
      RR(2,3) = CELL(2) * CELL(3) * CA  
      RR(3,1) = RR(1,3) 
      RR(3,2) = RR(2,3) 
      RR(3,3) = CELL(3) * CELL(3)   
      RETURN
C        END OF SUBR CELLRR 
      END   
CSUBROUTINE CELZAT (ACELTY, NCELTY, NCELLZ) 
C-----------------------------------------------------------------------
C Analyze cell contents / sort in decreasing order  
C Input:  data in CRYSA and CRYSB   
C Output: ACELTY(10) atom type (atomic symbol) CHARACTER*2  
C         NCELTY(10) number of atoms of this type in the cell (NINT !)  
C         NCELLZ(10) the corresponding Z value (number of electrons)
C+----------------------------------------------------------------------
      SUBROUTINE CELZAT (ACELTY, NCELTY, NCELLZ)
      DIMENSION ACELTY(10), NCELTY(10), NCELLZ(10)  
      CHARACTER ACELTY *2   
C        atoms: At.symbol   Nr/cell     Z for NEW order 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      EQUIVALENCE (LIS2,   IFILE(8))
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      COMMON /CRYSB/ SPGR,     WAVEAT,      CELATY(10)  
      CHARACTER      SPGR *16, WAVEAT *2,   CELATY *2   
      DIMENSION JCELLZ(10)  
C        temp: get Z in old order   
      DO 160 N = 1, NTYPE   
  160 CALL ATOMIZ(CELATY(N), K, JCELLZ(N))  
      DO 180 N = 1, 10  
      NCELLZ(N) = 0 
      NCELTY(N) = 0 
  180 ACELTY(N) = ' '   
      LZ = 999  
      DO 580 N = 1, NTYPE   
      DO 570 J = 1, NTYPE   
C        N=NEW, J=OLD,   LZ = past largest Z value (integer)
      IF (JCELLZ(J) .GE. LZ) GOTO 570   
      IF (JCELLZ(J) .EQ. NCELLZ(N)) 
     *   NCELTY(N) = NCELTY(N) + NINT(CELALL(J))
      IF (JCELLZ(J) .GT. NCELLZ(N)) THEN
         NCELLZ(N) = JCELLZ(J)  
         NCELTY(N) = NINT(CELALL(J))
         ACELTY(N) = CELATY(J)  
         ENDIF  
  570 CONTINUE  
***   TCELTY(N) = NCELTY(N) 
  580 LZ = NCELLZ(N)
      WRITE (LIS2, 611) (ACELTY(I), I=1,NTYPE)  
  611 FORMAT (' Cell contents.  Atoms:  ', 10(3X, A2))  
      WRITE (LIS2, 612) (NCELLZ(I), I=1,NTYPE)  
  612 FORMAT (17X, 'Z =  : ', 10I5) 
      WRITE (LIS2, 613) (NCELTY(I), I=1,NTYPE)  
  613 FORMAT (' Total number of atoms: ', 10I5) 
      RETURN
C        END OF SUBR CELZAT 
      END   
CSUBROUTINES BINXX :   A COLLECTION OF BINARY DATA INPUT/OUTPUT ROUTINES
C-----------------------------------------------------------------------
C CONTENTS  
C 51 BINIX   BIN. FILE: INPUT,  INITIATE READING
C 52 BINOX   BIN. FILE: OUTPUT, INITIATE WRITING
C 53 BINIFF  BIN. FILE: INPUT  ONE REFLECTION   
C 54 BINOFF  BIN. FILE: OUTPUT ONE REFLECTION   
C BINIX and BONOX are standard and are called only once.
C BINIFF and BINOFF are for input/output of 
C    NIT floating point numbers per reflection. 
C    (example: in file 'BINFC' : NIT = 2 for FP and PHASE only  
C    where FP and PHASE are the result of the program FCALC )   
C Note: input/output uses dummy array 'BUFF' .  
C       This array can be equivalenced to some commen block.
C Input and output arrays 'BUFF' and return keys 'NEND' 
C are subroutine variables and may not be changed by the
C user inbetween calls. Parallel use of the subroutines is  
C permitted, but use different variables:   
C    e.g. BUFI and BUFO for input/output 'BUFF' 
C    and  NITI and NITO for ..    ..     'NIT'  
C    and  NENI and NENO for ..    ..     'NEND' .   
C    or:  BUFFO and BUFFC for input BINFO and BINFC, etc.   
C The unused part of the array BUF is filled with zero's at the 
C fif st call of the input and/or output routines.  
C File structure:   
C _ The fif st record of the binary data file is a leading containing   
C      file control data and crystallographic control data. 
C - The following records are the reflection records, each with fixed   
C      record length, defined by the size of the buffer array BUF.  
C - One reflection record contains (at present) 198 real numbers:   
C      the size of the array BUF is 198.
C - The file is called the 'BINxx' file.
C      (Examples: BINFO for FOBS-data, BINFC for FCALC) 
C - Reflections are in the same order as given on the 'primary' BINFO   
C      file, which is generated by the program MERBIN. For instance,
C      indices hkl are not given on the BINFC file generated by FCALC.  
C - The 'BINxx' reflection records contain NIT "ITEMS" per reflection   
C      (For instance for NIT = 2, one structure factor can be   
C       given as FP (amplitude) and phase). 
C - The fif st record (= LEADING RECORD) contains the following 
C      data (example: NIT = 2, for FP and PHASE):   
C Data  name         contents file BINFC (for F and P)  
C ----  ----         ---------------------- 
C 1     NW           Number of words per reflection record = 198
C 2     NIT          Number of items per reflection (2) 
C 3     NRR          Number of refl. per record (99)
C 4     NW1          Number of words of BUFF in the 
C                    fif st record (FLOATING numbers).  
C                    Minimum: NW1=5 
C 5     CHIN *80     from COMMON /SYSTA/ containing:
C           FILENM( 1: 6)   file name (A6) (this example: 'BINFC')  
C           CCODE ( 7:12)   compound code (A6)  
C           PROGNM(13:20)   name generating program (A8)
C           TITLE (21:80)   title(1:60) (A60)   
C 6     BUF(1:NW1)   containing NW1 numbers:
C           ITIME        from COMMON /SYSTA/ made FLOATING  
C           BUF(5:NW1)   as defined by the user.
C - The following reflection record contains NRR reflections given  
C   by NIT words each  (e.g.: NIT=2 for: F, P, F, P, F, P,  ...)
C   for reflections in the same order as in the generating file.
C   If NIT * NRR is less then 198, the remainder is blanked.
C - After the last reflection comes a stop code: F = FSTOP = -67.0E06   
C   (end of data if  F < FSTOP = -66.9E06)  
C   If the total number of reflections happens to be an integer 
C   MULTIPLE of NIT, one additional record is needed for the stop code. 
C   After the stop code, the remainder of the record contains ZEROS.
C - The "unobserved" reflections are recognized by the 'JCODE' on   
C   the 'FREF' file. (Special signals about F and P may be  
C   coded on F and P).  
C - The fif st call of 'BINOFF' causes a rewind of the output file  
C   and a call for 'BINOX' for initialization and writing of the
C   leading record. 
C - Then 'BINOFF' is called for each reflection;the subroutine stores   
C   the items in 'BUF' and writes a record when the buffer is full  
C   (for N = 2: F and P for one refl.; 420 reflections per record). 
C - After the call for the last reflection, one more call for 'BINOFF'  
C   is needed to set the stop code and to write the last record.
C - The fif st call for 'BINIFF' causes a rewind of the input file  
C   and a call for 'BINIX' for initialization and reading the leading   
C   record. 
C - Then BINIFF is called for each reflection.  
C - After the call for the last reflection no more call for 'BINIFF'
C   is needed (although no harm is done; thus 'BINIFF' and 'BINOFF' 
C   may be treated in a similiar way).  
C - The END-OF-FILE is indicated by a negative value of the 
C   parameter: 'NEND'.  
C - The array 'BUF' is a parameter of the BINXX subroutines.
C - The main program is not allowed to change anything in 'BUF' 
C   nor in any of the other parameters: NIT, NEND ....  
C - The input and/or output of more then one file simultaneously
C   is allowed; the arrays 'BUF' must be independent.   
C   similarly: NEND as counter as well as END-SENTINEL. 
C+----------------------------------------------------------------------
CSUBROUTINE BINIX (IFI, FILENM, NIT, NW1, BUF)  
C-----------------------------------------------------------------------
C Initiate binary input file (see BINXX introduction)   
C Clear BUF, read fif st record.
C Parameters set in the calling routine  (example: F and P) 
C    IFI      : Input UNIT (e.g. 8) to read a binary file   
C    FILENM   : Name of input file (e.g. BINFO, BINFC)  
C    NIT      : Number of items per reflection (e.g. 2)       *)
C    NW1      : Number of words of BUF in the fif st line      *)   
C    BUF(198) : Buffer array                                  *)
C                                              *input from file)
C    The unused part of the array BUF is filled with zero's.
C+----------------------------------------------------------------------
      SUBROUTINE BINIX (IFI, FILENM, NIT, NW1, BUF) 
      CHARACTER FILENM *(*), FILEN *6   
      PARAMETER (MAXBUF = 198)  
      DIMENSION BUF(MAXBUF) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      LOGICAL SWPRI 
      EQUIVALENCE (SWPRI, SWITCH(10))   
      EQUIVALENCE (LIS2, IFILE(8))  
      FILEN = FILENM
      CALL FILINQ (IFI, FILEN, 'UNFORMATTED', 'INPUT', KINQ)
      IF (KINQ.LT.0) THEN   
         WRITE (CHOUT, FMT='(''Binary input file '',
     *         A6, 1X, A6, '' not found'')') CCODE, FILEN   
         CALL KERROR (CHOUT, 0, 'BINIX')
         ENDIF  
      IF (SWPRI) WRITE (LIS2, 100) FILEN
  100 FORMAT (' Read binary data file ', A6)
      CALL KERNZA (0., BUF, MAXBUF) 
      READ   (IFI, ERR=120, IOSTAT=IFSTAT(IFI)) 
     *           NW, NIT, NRR, NW1, CHIN, (BUF(I), I=1,NW1) 
      IF (CHIN(1:6) .NE. FILEN) THEN
         WRITE (CHOUT, 105) FILEN, CHIN(1:6)
  105    FORMAT (' Warning: filename conflict, file: ', A6, 
     *         ' interal i.d.: ', A6)   
         CALL SHOUT 
         ENDIF  
      IF (IFSTAT(IFI) .EQ. 0) RETURN
C        error on input file
  120 WRITE (CHOUT, 130) FILENM, IFI
  130 FORMAT (' Error input file ', A6, ', unit number ', I3)   
      CALL KERROR (CHOUT, 120, 'BINIX') 
      RETURN
C         END OF SUBROUTINE BINIX   
      END   
CSUBROUTINE BINOX (IFO, FILENM, NIT, NW1, BUF)  
C-----------------------------------------------------------------------
C Initiate binary output file (see BINXX introduction)  
C Write fif st record.  
C Parameters set in the calling routine  (example: F and P) 
C    IFO      : Output unit (e.g. 9) to write binary file   
C    FILENM   : Name of file (e.g. 'BINFC') 
C    NIT      : Number of items per reflection (e.g. 2)   *)
C    NW1      : Number of words of BUF in the fif st line  *)   
C    BUF(198) : Buffer array                              *)
C                                            * user defined)
C The unused part of the array BUF is filled with zero's.   
C Calls: KERNZA 
C+----------------------------------------------------------------------
C             NRR: NUMBER REFLEXIONS PER RECORD (E.G. 420)  
C             MAXBUF:  SIZE OF ARRAY BUF (198)  
      SUBROUTINE BINOX (IFO, FILENM, NIT, NW1, BUF) 
      CHARACTER FILENM *(*), FILEN *6   
      PARAMETER (MAXBUF = 198)  
      DIMENSION BUF(MAXBUF) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      LOGICAL SWPRI 
      EQUIVALENCE (SWPRI, SWITCH(10))   
      EQUIVALENCE (LIS2, IFILE(8))  
      FILEN = FILENM
      CALL FILINQ (IFO, FILEN, 'UNFORMATTED', 'OUTPUT', KINQ)   
      IF (SWPRI) WRITE (LIS2, 100) FILEN
  100 FORMAT (' Write binary data file ', A6)   
C        total length fif st record is limited: NW1 < MAXBUF-24 
      IF (NW1 .GT. MAXBUF-24) CALL KERNER (100, 'BINOX')
C         NIT IS GIVEN IN CALL  
      NW  = MAXBUF  
      NRR = MAXBUF / NIT
      DO 110 I=1,4  
  110 BUF(I) = ITIME(I) 
      CHIN(1 :6)  = FILEN   
      CHIN(7 :12) = CCODE   
      CHIN(13:20) = PROGNM  
      CHIN(21:80) = TITLE   
      WRITE (IFO, ERR=120, IOSTAT=IFSTAT(IFO))  
     *      NW, NIT, NRR, NW1, CHIN, (BUF(I), I=1,NW1)  
C        CLEAR REMAINDER OF THE BUFFER  
      IF (MAXBUF .GT. NW1) CALL KERNZA (0., BUF(NW1+1), MAXBUF-NW1) 
      IF (IFSTAT(IFO) .EQ. 0) RETURN
C        error on output file   
  120 WRITE (CHOUT, 130) FILENM, IFO
  130 FORMAT (' Error output file ', A6, ', unit number ', I3)  
      CALL KERROR (CHOUT, 0, 'BINOX')   
      RETURN
C         END OF SUBROUTINE BINOX   
      END   
CSUBROUTINE BINIFF (KEY, IFI, FILENM, FITEMS, NIT, BUF, NEND)   
C-----------------------------------------------------------------------
C Arguments 
C    Key:   
C      - POSITIVE : Fif st call: INIT.: Read first record   
C      - ZERO     : Normal read call
C      - NEGATIVE : Ignored (useless)   
C    IFI   : Input UNIT to read a binary file   
C    FILENM: File name (e.g. BINFO, BINFC)  
C    FITEMS: (Returns NIT Items), only used with KEY=0  
C    NIT   : Dimension of array FITEMS                      *)  
C    BUF   : BUF(198)                                       *)  
C                           * input from file,  read by BINIX)  
C                           * warning: NIT must be a variable)  
C    NEND: return key.  
C       on fif st call: 
C    NEND = -NW1 = negative size of array BUF input from leading record 
C       on following calls: 
C    NEND = number of items read and stored in buffer BUF, so far   
C         = 0   after reading a new record  
C    NEND = negative (as -NEND) means: stop code found: end of file 
C    Any possible file error : error stop   
C Calls: BINIX, KERNAB  
C+----------------------------------------------------------------------
C        NW1: NUMBER OF WORDS OF BUF IN THE FIRST LINE  
C        MAXBUF: SIZE OF ARRAY BUF (198)
      SUBROUTINE BINIFF (KEY, IFI, FILENM, FITEMS, NIT, BUF, NEND)  
      CHARACTER FILENM *(*), FILEN *6   
      PARAMETER (MAXBUF = 198)  
      DIMENSION BUF(MAXBUF) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
C        DIMENSION FITEMS (NIT) used for storage in CALL KERNAB 
      DIMENSION FITEMS (1)  
      DATA FSTOP / -66.9E06 /   
      IF (IFI.LE.0 .OR. IFI.GT.20) CALL KERROR (' IFI?',-4,'BINIFF')
      IF (KEY) 140, 110, 100
C          FIRST CALL   
  100 FILEN = FILENM
      CALL BINIX (IFI, FILEN, NIT, NW1, BUF)
      NEND = - NW1  
      RETURN
C          normal call  
  110 IF (NEND.LT.0) GOTO 115   
      IF (NEND.LE.MAXBUF-NIT) GOTO 120  
C          read next record 
  115 READ (IFI, ERR=150, END=150, IOSTAT=IFSTAT(IFI)) BUF  
      IF (IFSTAT(IFI) .NE. 0) GOTO 150  
      NEND = 0  
  120 IF (BUF(NEND+1).LE.FSTOP) GOTO 130
C          REFLECTION FOUND 
      CALL KERNAB (BUF(NEND+1), FITEMS, NIT)
      NEND = NEND + NIT 
      RETURN
C          STOP        (FINAL CALL:   NOT USED) 
  130 NEND = -NEND  
      IF (NEND.GE.0) NEND = -999
  140 RETURN
C        error on input file
  150 WRITE (CHOUT, 160) FILENM, IFI
  160 FORMAT (' Error reading input file ', A6, ', unit number ', I3)   
      CALL KERROR (CHOUT, 0, 'BINIFF')  
C          END OF SUBROUTINE BINIFF 
      END   
CSUBROUTINE BINOFF (KEY, IFO, FILENM, FITEMS, NIT, BUF, NEND)   
C-----------------------------------------------------------------------
C Arguments 
C    Key:   
C    - POSITIVE : Fif st call: INIT.: Write first record
C           LE.4: copy ITIME into BUF(1:4), set BUF(5)=0.0, 
C                 and write BUF(1:5) onto file IFO  
C           GT.4: copy ITIME into BUF(1:4) and write
C                 BUF(1:KEY) onto file IFO (max: KEY = 198) 
C                    (Note: BUF(5:KEY) must be filled   
C                     by user before the fif st call:   
C    - ZERO     : Normal write call 
C    - NEGATIVE : Writes the last record (with STOP CODE)   
C    IFO   :  Output UNIT to write a binary file
C    FILENM:  Name of file (e.g. BINFO, BINFC)  
C    FITEMS: (Table with NIT items), only used with KEY = 0 *)  
C    NIT   : Dimension of FITEMS                            *)  
C    BUF   : BUF(198) Buffer for output                     *)  
C                                              *user supplied)  
C    NEND  : count number of words stored in buffer, so far 
C            important if more than one file should be written  
C    = NEND = 0 after writing one record
C    = NEND = negative if a file error occurred, the error stop here!   
C Calls: BINOX, KERNAB, KERNZA  
C+----------------------------------------------------------------------
C              NW1: NUMBER OF WORDS OF BUF IN THE FIRST LINE
C              MAXBUF: SIZE OF ARRAY BUF (198)  
      SUBROUTINE BINOFF (KEY, IFO, FILENM, FITEMS, NIT, BUF, NEND)  
      CHARACTER FILENM *(*), FILEN *6   
      PARAMETER (MAXBUF = 198)  
      DIMENSION BUF(MAXBUF) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      DIMENSION FITEMS (NIT)
      DATA FSTOP / -67.0E06 /   
      IF (IFO.LE.0 .OR. IFO.GT.20) CALL KERROR (' IFO?',-4,'BINOFF')
      IF (KEY) 120, 110, 100
C          FIRST CALL   
  100 NW1 = MIN0(MAXBUF, MAX0(KEY,4))   
      IF (NW1.GT.4) GOTO 101
      NW1 = 5   
      BUF(5) = 0.   
  101 FILEN = FILENM
      CALL BINOX (IFO, FILEN, NIT, NW1, BUF)
      GOTO 140  
C          NORMAL CALL  
  110 CALL KERNAB (FITEMS, BUF(NEND+1), NIT)
      NEND = NEND + NIT 
      IF (NEND .LE. MAXBUF-NIT) RETURN  
C          OUTPUT   
      GOTO 130  
C          FINAL CALL   
  120 BUF(NEND+1) = FSTOP   
      CALL KERNZA (0.0, BUF(NEND+2), MAXBUF-NEND-1) 
  130 CONTINUE  
C the lable 130 cannot be at next statement for unknown reasons (Curt)  
      WRITE (IFO, ERR=150, IOSTAT=IFSTAT(IFO)) BUF  
C        FILE ERROR = NEGAT IOSTAT: ELSE ZERO   
  140 NEND = - IFSTAT(IFO)  
      IF (NEND.LT.0) GOTO 150   
      RETURN
C        error on output file   
  150 WRITE (CHOUT, 160) FILENM, IFO
  160 FORMAT (' Error writing output file ', A6, ', unit number ', I3)  
      CALL KERROR (CHOUT, 0, 'BINOFF')  
      RETURN
C          END OF SUBROUTINE BINOFF 
      END   
CSUBROUTINE ATOMIZ (LM, NLET, IZ)   
C-----------------------------------------------------------------------
C Get atomic number IZ  
C Input :  LM*2  = atomic name: one or two letters  
C          If one letter only: NM(1) = letter, NM(2) = not tested here  
C          If two letters: possible thif d lettr not tested 
C Output:  NLET  = number of letters (1 OR 2)   
C                  NLET is undefined if IZ is returned as IZ = -1   
C          IZ    = Z (atomic number); IZ = -1 if incorrect atomic name  
C                                     IZ =  1 if the atom name is Q 
C Calls: KERC2I 
C+----------------------------------------------------------------------
      SUBROUTINE ATOMIZ (LM, NLET, IZ)  
      CHARACTER * 2 LM, L, LL, LLC, LLLC
      DIMENSION L(100), LLC(100), LLLC(100) 
      DATA L    / 'H ', 'HE', 'LI', 'BE', 'B ', 'C ', 'N ', 'O ', 'F ', 
     *      'NE', 'NA', 'MG', 'AL', 'SI', 'P ', 'S ', 'CL', 'AR', 'K ', 
     *      'CA', 'SC', 'TI', 'V ', 'CR', 'MN', 'FE', 'CO', 'NI', 'CU', 
     *      'ZN', 'GA', 'GE', 'AS', 'SE', 'BR', 'KR', 'RB', 'SR', 'Y ', 
     *      'ZR', 'NB', 'MO', 'TC', 'RU', 'RH', 'PD', 'AG', 'CD', 'IN', 
     *      'SN', 'SB', 'TE', 'I ', 'XE', 'CS', 'BA', 'LA', 'CE', 'PR', 
     *      'ND', 'PM', 'SM', 'EU', 'GD', 'TB', 'DY', 'HO', 'ER', 'TM', 
     *      'YB', 'LU', 'HF', 'TA', 'W ', 'RE', 'OS', 'IR', 'PT', 'AU', 
     *      'HG', 'TL', 'PB', 'BI', 'PO', 'AT', 'RN', 'FR', 'RA', 'AC', 
     *      'TH', 'PA', 'U ', 'NP', 'PU', 'AM', 'CM', 'BK', 'CF', 'ES', 
     *      'FM' /  
      DATA LLC  / 'H ', 'He', 'Li', 'Be', 'B ', 'C ', 'N ', 'O ', 'F ', 
     *      'Ne', 'Na', 'Mg', 'Al', 'Si', 'P ', 'S ', 'Cl', 'Ar', 'K ', 
     *      'Ca', 'Sc', 'Ti', 'V ', 'Cr', 'Mn', 'Fe', 'Co', 'Ni', 'Cu', 
     *      'Zn', 'Ga', 'Ge', 'As', 'Se', 'Br', 'Kr', 'Rb', 'Sr', 'Y ', 
     *      'Zr', 'Nb', 'Mo', 'Tc', 'Ru', 'Rh', 'Pd', 'Ag', 'Cd', 'In', 
     *      'Sn', 'Sb', 'Te', 'I ', 'Xe', 'Cs', 'Ba', 'La', 'Ce', 'Pr', 
     *      'Nd', 'Pm', 'Sm', 'Eu', 'Gd', 'Tb', 'Dy', 'Ho', 'Er', 'Tm', 
     *      'Yb', 'Lu', 'Hf', 'Ta', 'W ', 'Re', 'Os', 'Ir', 'Pt', 'Au', 
     *      'Hg', 'Tl', 'Pb', 'Bi', 'Po', 'At', 'Rn', 'Fr', 'Ra', 'Ac', 
     *      'Th', 'Pa', 'U ', 'Np', 'Pu', 'Am', 'Cm', 'Bk', 'Cf', 'Es', 
     *      'Fm' /  
      DATA LLLC / 'h ', 'he', 'li', 'be', 'b ', 'c ', 'n ', 'o ', 'f ', 
     *      'ne', 'na', 'mg', 'al', 'si', 'p ', 's ', 'cl', 'ar', 'k ', 
     *      'ca', 'sc', 'ti', 'v ', 'cr', 'mn', 'fe', 'co', 'ni', 'cu', 
     *      'zn', 'ga', 'ge', 'as', 'se', 'br', 'kr', 'rb', 'sr', 'y ', 
     *      'zr', 'nb', 'mo', 'tc', 'ru', 'rh', 'pd', 'ag', 'cd', 'in', 
     *      'sn', 'sb', 'te', 'i ', 'xe', 'cs', 'ba', 'la', 'ce', 'pr', 
     *      'nd', 'pm', 'sm', 'eu', 'gd', 'tb', 'dy', 'ho', 'er', 'tm', 
     *      'yb', 'lu', 'hf', 'ta', 'w ', 're', 'os', 'ir', 'pt', 'au', 
     *      'hg', 'tl', 'pb', 'bi', 'po', 'at', 'rn', 'fr', 'ra', 'ac', 
     *      'th', 'pa', 'u ', 'np', 'pu', 'am', 'cm', 'bk', 'cf', 'es', 
     *      'fm' /  
      IZ = -1   
C         TEST FOR SECOND CHARACTER 
      CALL KERC2I (LM(2:2), KEND1)  
      NLET = 1  
      IF (KEND1.GT.10 .AND. KEND1.LT.37) NLET = 2   
      LL = LM(1:NLET)   
C         TEST FOR ATOM SYMBOL  (including Q for dummy or peak) 
      IF (LL .EQ. 'Q' .OR. LL .EQ. 'q') LL = 'H'
      IF (LL.EQ.'D' .OR. LL.EQ.'T') LL = 'H'
      IF (LL.EQ.'d' .OR. LL.EQ.'t') LL = 'H'
      DO 100 I=1,100
      IF (LL.EQ.L(I) .OR. LL.EQ.LLC(I) .OR. LL.EQ.LLLC(I)) GOTO 110 
  100 CONTINUE  
C        atomic name (chemical symbol) not found
      RETURN
C        CORRESPONDING ENTRY is present IN TABLE
  110 IZ = I
      RETURN
C        END OF SUBROUTINE ATOMIZ   
      END   
CSUBROUTINE ATOMCH (IZ) 
C-----------------------------------------------------------------------
C Check atom name = CHEM. SYMB. (+IDENTIFIER))  
C 'atom input line' is present in array CHIN
C if atom name is given as two words (chem.symbol + number) 
C then the name is concatenated and CHIN is reinterpreted   
C Return IZ = atomic number (integer Z) (> 0, else error stop here) 
C Note: Q is accepted as atom symbol (IZ=1) 
C Examples          X  stands for: any non-blank character(s)   
C                   +  stands for:  + or - or ' or (
C Then:             |   valid atom names       |   errors:  
C                   |                          |
C |) one word       |   CA         C           |   CC   
C    atom name      |   CA+        CU-         |   CA$+ 
C                   |   CA'        CU(34)      |   CA)  
C                   |   CA34       H(N12)      |   CA(8)
C                   |   CA+X       FE+2        |   FE.2 
C                   |   CA+XXX     FE+$2       |   FE$2 
C                   |   CA34X      H3(C8)      |
C                   |                          |
C 2) two words      |   CA 34      C  12       |   C -12     CA +   
C    (1 -4 blanks)  |   CA 0                   |   C (12)    CA3 4  
C Maximum number of non-blank CHARACTERS: 6 
C Simulation of 'atom input line' :  CHIN = 'ATOM  C         0. 0. 0.'  
C and:  CHIN(7:12) = ATOMNAME    CALL KERINB (LIT, 1)   CALL ATOMCH (IZ)
C Calls: KERC2I, ATOMIZ 
C+----------------------------------------------------------------------
      SUBROUTINE ATOMCH (IZ)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      IZ = 0
      IF (NFDOL(2).GE.0) RETURN 
C        FIRST LITERAL = 'ATOM',  SECOND LITERAL = ATOMNAME... OK   
      I = NCOLL(2)  
C        CHECK NUMBER OF LETTERS (NLET) AND ATOMIC NUMBER (IZ)  
      CALL ATOMIZ (CHIN(I:I+1), NLET, IZ)   
C        error stop if IZ not positive: 
      IF (IZ .LE. 0) GOTO 150   
      I = I + NLET  
C        BLANK?:  CHECK CONTINUATION
      IF (CHIN(I:I).NE.' ') GOTO 110
C        BLANK AFTER CHEMICAL SYMBOL: ITEM 3 IS UNSIGNED INTEGER
C                                     or it is  THE X-PARAMETER 
C        NFDOL(3):    2 = FLOATING POINT NUMBER, = 1 = INTEGER, 
C                 LT. 0 = LITERAL (E.G. '3A')   
      IF (NFDOL(3).EQ.2) RETURN 
      IF (NFDOL(3).LE.0) GOTO 150   
C        INTEGER FOUND; UNSIGNED?  +1 FOR X-parameter IS ALLOWED.   
      K = NCOLN(1)  
      IF (CHIN(K:K).EQ.'+' .OR. CHIN(K:K).EQ.'-') RETURN
C        UNSIGNED INTEGER FOUND,  MAX 4 BLANKS  (At.name max 6 char.)   
      IF (K-I.GT.4) GOTO 150
C95Nov.  However:  ATOM P 0 0 0    ....is acceptabele? (without occ, B )
      IF (NFNUM .EQ. 3) RETURN  
C        COMPRESS AT.SYMBOL use CHOUT as scratch  / clear   
      CHOUT(I:NCOLN(2)-1) = CHIN(K:NCOLN(2)-1)  
      CHIN(I:NCOLN(2)-1) = CHOUT(I:NCOLN(2)-1)  
      CHOUT = ' '   
      CALL KERINB (LIT(32),1)   
      RETURN
C       ATOM NAME IS ONE WORD, CHECK VALIDITY   
  110 CALL KERC2I (CHIN(I:I), NEN)  
C        '+' OR '-' IS ACCEPTABLE   
      IF (NEN.EQ.37 .OR. NEN.EQ.38) NEN = 0 
C        ALSO prime (') and '(' are accetable   
      IF (NEN.EQ.45 .OR. NEN.EQ.46) NEN = 0 
C        AND NUMBERS: 0, 1, 2, ... , 9   ARE OK:
      IF (NEN.LT.0 .OR. NEN.GT.9) GOTO 150  
      RETURN
C            ERROR atomic symbol not followed by: blank digit +  -  '  (
  150 CALL KERROR (' Incorrect atomic symbol', -6, 'ATOMCH')
C        END OF SUBR. ATOMCH
      END   
CSUBROUTINE ATOMIN (IFAT, ATXYZ, ATNAME, IZAT, MAXAT, NAT, KEYT)
C-----------------------------------------------------------------------
C ATOMIN: Read 'ATOMS' or 'ATMOD' file and store in ATXYZ...
C IFAT   = Input unit of atom file (usually 1 or 2) 
C ATXYZ(NSLOT,MAXAT) =  Atom data (X, Y, Z, occ, B ..)  
C ATNAME(MAXAT)      =  Atom name (A6)  (compressed !!) 
C IZAT(MAXAT)        =  Atom Z (INTEGER: IZ)
C MAXAT  = Max. number of atoms = dimension of arrays in MAIN   
C NAT    = Number of atoms read (> 0, if not: error stop here)  
C          ----------------- (if NAT > MAXAT: error stop here)  
C KEYT   = Temperature factor mode (1=Bov , 2=Biso , 3=Aniso/mixed) 
C Call ATOMST to modify atom data to standardize input atoms
C    IF 'Q' atom (dummy): set weight = Biso = 0.0   
C Note: file ID on leading record must be ATOMS or ATMOD
C    if file ID = ATOMS then CCODE on leading record must be correct
C On return, the leading record is returned to CHIN and interpreted.
C Calls: ATOMIA, ATOMST 
C+----------------------------------------------------------------------
      SUBROUTINE ATOMIN (IFAT, ATXYZ, ATNAME, IZAT, MAXAT, NAT, KEYT)   
C        NSLOT = 10 for: x, y, z, occ, B or B11, B22, B33, B23, B13, B12
      PARAMETER (NSLOT = 10)
      DIMENSION ATXYZ(NSLOT,MAXAT), IZAT(MAXAT) 
      CHARACTER * 6 ATNAME(MAXAT)   
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      EQUIVALENCE (IPR1, IFILE(6)), (LIS1, IFILE(7))
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      CHARACTER      CHIN2 *80  
C        OPEN and REWIND done in MAIN (incl. check for ATOMS or ATMOD)  
   99 FORMAT (/' DIRDIF cannot proceed:'/   
     *         ' the input ATOMS or ATMOD file is incorrect:'/  
     *         ' maybe a leftover of a preceding error stop? MSG:') 
      IF (IFAT.LE.0 .OR. IFAT.GT.20) CALL KERROR (' IFAT?',-4,'ATOMIN') 
      READ (IFAT, 105, ERR = 940, END = 940, IOSTAT = IFSTAT(IFAT)) 
     *      CHIN(1:72)  
  105 FORMAT (A72)  
      CHIN2 = CHIN  
      CALL KERINB (LIT, 1)  
**951 IF (LIT(1) .NE. 'ATMOD' .AND. LIT(1) .NE. 'ATOMS') CALL KERROR
**   *   ('No file identification on ATOMS or ATMOD file', -6,'ATOMIN') 
      IF (LIT(1) .NE. 'ATMOD' .AND. LIT(1) .NE. 'ATOMS') GOTO 951   
**953 IF (LIT(1) .EQ. 'ATOMS' .AND. LIT(2) .NE.  CCODE) CALL KERROR 
**   *   ('Incorrect CCODE on ATOMS file', -6,'ATOMIN') 
      IF (LIT(1) .EQ. 'ATOMS' .AND. LIT(2) .NE.  CCODE) GOTO 953
C        Initiate SUBR ATOMIA   
      LEND = 999
      NAT = 1   
  107 CALL ATOMIA (IFAT, ATXYZ, ATNAME, IZAT, MAXAT, NAT, LEND) 
C        LEND = -1 if E.O.F. / KEND = .GT.0 if END, FINISH, STOP
      IF (LEND.NE.0) GOTO 200   
      NAT = NAT + 1 
C        strictly speaking: next call could be the END card ....
C        but next items can also include esd's, to be stored in NAT+1   
      IF (NAT .EQ. MAXAT) CALL KERROR ('Too many atoms', -6, 'ATOMIN')  
      GOTO 107  
C        END of ATOMS   
  200 NAT = NAT - 1 
**955 IF (NAT .LE. 0) CALL KERROR   
**   *   ('No atoms found on ATOMS or ATMOD file', -6, 'ATOMIN')
      IF (NAT .LE. 0) GOTO 955  
      IF (LEND .LT. 0) THEN 
         CHOUT = ' Warning ATOMS or ATMOD file: END card missing'   
         CALL SHOUT 
         ENDIF  
C        Modify atom data to standardize input atoms
C        Get KEYT = Temp.factor mode: overall, Biso, Aniso/mixed
C                              KEYT =   1      2     3  
      CALL ATOMST (0, ATXYZ, NAT, KEYT) 
C        for Q-atoms (dummies): weight = 0.0
      DO 302 I = 1, NAT 
      IF (ATNAME(I) (1:1) .EQ. 'Q') THEN
         ATXYZ(4,I) = 0.0   
         ATXYZ(5,I) = 0.0   
         ENDIF  
  302 CONTINUE  
      CHIN = CHIN2  
      CALL KERINB (LIT, 1)  
      RETURN
**940 CALL KERROR('File error reading ATOMS or ATMOD file', 0,'ATOMIN') 
  940 WRITE (LIS1, 99)  
      WRITE (IPR1, 99)  
      CALL KERROR('File error reading ATOMS or ATMOD file', 0,'ATOMIN') 
**951 IF (LIT(1) .NE. 'ATMOD' .AND. LIT(1) .NE. 'ATOMS')
  951 WRITE (LIS1, 99)  
      WRITE (IPR1, 99)  
      CALL KERROR   
     *   ('No file identification on ATOMS or ATMOD file', -6,'ATOMIN') 
**953 IF (LIT(1) .EQ. 'ATOMS' .AND. LIT(2) .NE.  CCODE) 
  953 WRITE (LIS1, 99)  
      WRITE (IPR1, 99)  
      CALL KERROR ('Incorrect CCODE on ATOMS file', -6,'ATOMIN')
**955 IF (NAT .LE. 0)   
  955 WRITE (LIS1, 99)  
      WRITE (IPR1, 99)  
      CALL KERROR   
     *   ('No atoms found on ATOMS or ATMOD file', -6, 'ATOMIN')
C        END OF SUBROUTINE ATOMIN   
      END   
CSUBROUTINE ATOMIA (IFAT, ATXYZ, ATNAME, IZAT, MAXAT, NAT, LEND)
C-----------------------------------------------------------------------
C ATOMIA: Read one atom from 'ATOMS' or 'ATMOD' file
C         and store xyz and B in ATXYZ... at posn NAT   
C         and store esd's ............... at posn NAT+1 
C IFAT   = Input unit of atom file (usually 1)  
C ATXYZ(NSLOT,NAT)   =  Atom data (X, Y, Z, occ, B ..)  
C ATNAME(NAT)        =  Atom name (A6)   (compressed .... !)
C IZAT(NAT)          =  Atom Z (INTEGER)
C NAT    = Number of atom to be read in now 
C LEND   = 999 initalisation (set by calling program)   
C LEND   =   0 atom  record found      )
C LEND   =  -1 end of file             )   set by subr. ATOMIA  
C LEND   >   1 END, FINISH or STOP     )
C Calls: KERIFF, KERINB, ATOMCH 
C+----------------------------------------------------------------------
      SUBROUTINE ATOMIA (IFAT, ATXYZ, ATNAME, IZAT, MAXAT, NAT, LEND)   
C        NSLOT = 10 for: x, y, z, occ, B or B11, B22, B33, B23, B13, B12
      PARAMETER (NSLOT = 10)
      DIMENSION ATXYZ(NSLOT,MAXAT),   IZAT(MAXAT)   
      CHARACTER * 6 ATNAME(MAXAT)   
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      CHARACTER CHIN2 *80 ,  LITA(4) *6 
      DATA LITA /'ATOM', 'BIJ', 'ATESD', 'BIJESD' / 
C        Dummy DATA statement to avoid useless compiler warnings
      DATA LEND2 / 0 /  
C        Initialisation 
      IF (LEND .EQ. 999) THEN   
         CALL KERIFF (IFAT, LITA, 4, LEND)  
         IF (LIT(1).NE.'ATOM') CALL KERROR  
     *   ('Fif st atom on ATOMS or ATMOD file not: ATOM', -6, 'ATOMIA') 
      ELSE  
         CHIN = CHIN2   
         LEND = LEND2   
         CALL KERINB (LIT, 1)   
         ENDIF  
      IF (LEND.NE.0) RETURN 
C        Interpretation:  check atom
C        New atom found:  Check atom symbol 
      CALL ATOMCH (IZAT(NAT))   
      ATNAME(NAT) = LIT(2)  
      DO 110 I = 1, NSLOT   
C        Note: always at least 3 items. 
      IF (I.LE.3 .AND. NCOLN(I).LE.0) CALL KERROR   
     *   ('Data on atoms card not correct', -6, 'ATOMIA')   
C        IF NSLOT .GT. 3: remaining items may be absent (FNUM(I)=0) 
C                         REMAINING positions in ATXYZ are cleared  
  110 ATXYZ(I,NAT) = FNUM(I)
C        Read next record from file 
  117 CALL KERIFF (IFAT, LITA, 4, LEND) 
C        LEND = -1 if E.O.F. / LEND = .GT.0 if END, FINISH, STOP
      IF (LEND .NE. 0) GOTO 201 
C        save last input line and last LEND for next call:  
C        IF LEND = 0: No system card: now to be interpreted.
      GOTO (201, 202, 203, 204), NLUSER(1)  
C        Unknown record:  NLUSER NE 1,2,3,4 for ATOM BIJ ATESD BIJESD   
      CALL KERROR   
     *   ('Record on ATOMS or ATMOD file not recognised', -6, 'ATOMIA') 
  201 CHIN2 = CHIN  
      LEND2 = LEND  
      LEND = 0  
      RETURN
C        'BIJ' --- etc. --- do not check number of items ---
  202 CALL KERNAB (FNUM, ATXYZ(5,NAT), 6)   
      GOTO 117  
C        'ATESD' esd for x y z and perhaps occ. and Biso
  203 CALL KERNAB (FNUM, ATXYZ(1,NAT+1), 5) 
      GOTO 117  
C        'BIJESD' esd for aniso   (input after ATESD .. !)  
  204 CALL KERNAB (FNUM, ATXYZ(5,NAT+1), 6) 
      GOTO 117  
C        END OF SUBROUTINE ATOMIA   
      END   
CSUBROUTINE ATOMPR (IPRX, NAPR, ATXYZ, ATNAME, IZAT, NAT)   
C-----------------------------------------------------------------------
C PRINT ATOMS ... name  x, y, z, IZAT, (occ and B, if not empty)
C NAT  = dimension of atom tables   
C NAPR = number of atoms to be printed if NAT > 2.5 * NATPR,
C        otherwise print all atoms (= NAT)  
C IPRX = output unit (usually LIS1 or LIS2) 
C+----------------------------------------------------------------------
      SUBROUTINE ATOMPR (IPRX, NAPR, ATXYZ, ATNAME, IZAT, NAT)  
      DIMENSION ATXYZ(10,NAT), IZAT(NAT), ATNAME(NAT)   
      CHARACTER *6 ATNAME   
      NATX = (NAPR * 5 + 1) / 2 
      IF (NATX .GT. NAT) NATX = NAT 
      IF (NATX .LT. NAT) NATX = NAPR
      IF (NATX .LE. 0) NATX = MIN0 (3, NAT) 
      WRITE (IPRX, FMT='('' Number of atoms stored:'', I4)') NAT
C        check temp. factor for NATX atoms: 
      KEYT = 1  
      DO 102 I=1,NATX   
      IF (ATXYZ(4,I) .LT. 0.999 .OR. ATXYZ(5,I) .GT. 0.0001) KEYT = 2   
      IF (ATXYZ(6,I) .GT. 0.000001) GOTO 103
  102 CONTINUE  
      IF (KEYT .EQ. 1) WRITE (IPRX, FMT='   
     *   ('' Atom name    x        y        z'', 8X,''Z'')')
      IF (KEYT .EQ. 2) WRITE (IPRX, FMT=' ('' Atom name    x'', 
     *    ''        y        z'', 8X,''Z   occ.f.      B'')')   
      GOTO 104  
  103 WRITE (IPRX, FMT=' ('' Atom name    x'',  
     *    ''        y        z'', 8X,''Z   occ.f.      B.equiv.'')')
  104 DO 109 I=1,NATX   
      IF (ATXYZ(4,I) .LT. 0.999 .OR. ATXYZ(5,I) .GT. 0.0001) THEN   
         WRITE (IPRX, 106)  ATNAME(I), (ATXYZ(J,I),J=1,3), IZAT(I), 
     *      (ATXYZ(J,I),J=4,5)  
  106    FORMAT (3X, A6, 2X, 3F9.5, I4, 2F9.4)  
      ELSE  
         WRITE (IPRX, 106)  ATNAME(I), (ATXYZ(J,I),J=1,3), IZAT(I)  
         ENDIF  
  109 CONTINUE  
      IF (NAT .GT. NATX) WRITE (IPRX, FMT='('' Printing of remaining'', 
     *                                    '' atoms supressed.'')')  
      RETURN
C        END OF SUBR ATOMPR 
      END   
CSUBROUTINE ATOMWR (IATOMS, ATXYZ, ATNAME, NAT) 
C-----------------------------------------------------------------------
C Output atoms to ATOMS or ATMOD file.  
C Write header (with date, RUN, etc.) and REMARK record: see ATOMWA 
C IATOMS = file  unit   
C NAT    = dimension of atom tables ATXYZ and ATNAME
C IF FNUM(32) > 0 then FNUM(32) = scale  ! Write, and clear FNUM(32)
C SWITCH(25) = ATMOD  : used in subr. ATOMWR and ATOMWA 
C No OPEN, REWIND or CLOSE file 
C Calls: ATOMWA, ATOMWB 
C+----------------------------------------------------------------------
      SUBROUTINE ATOMWR (IATOMS, ATXYZ, ATNAME, NAT)
      DIMENSION ATXYZ(10,NAT), ATNAME(NAT)  
      CHARACTER *6 ATNAME   
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (LIS2, IFILE(8))  
C        SWITCH(25) = ATMOD  : used in subr. ATOMWR and ATOMWA  
      CHARACTER FATOMX * 6  
      FATOMX = 'ATOMS'  
      IF (SWITCH(25)) FATOMX = 'ATMOD'  
C        Write heading records  
      CALL ATOMWA (IATOMS)  
C        Write atoms
      DO 109 NATR = 1, NAT  
  109 CALL ATOMWB (IATOMS, ATXYZ, ATNAME, NATR) 
      WRITE (LIS2, 120) FATOMX, NAT 
  120 FORMAT (' Number of atoms written to ', A6, 'file:', I4)  
      WRITE (IATOMS, FMT = '(''END'')') 
      RETURN
C        END OF SUBR ATOMWR 
      END   
CSUBROUTINE ATOMWA (IATOMS) 
C-----------------------------------------------------------------------
C Write heading records to ATOMS or ATMOD file  
C IATOMS = file  unit   
C Header rec. : ATOMS or ATMOD generated by program: PGNAME, date , RUN 
C    IF FNUM(32) > 0 then FNUM(32) = scale  ! Write, and clear FNUM(32) 
C    IF SWITCH(25) = .TRUE.  write ATMOD file and replace CCODE by CART 
C Second rec. : REMARK CHOUT(1:65) (if not empty)   
C There is no OPEN or CLOSE or REWIND....   
C+----------------------------------------------------------------------
      SUBROUTINE ATOMWA (IATOMS)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
C        SWITCH(25) = ATMOD  : used in subr. ATOMWR and ATOMWA  
C        write scale via ATOMWR and ATOMWA  
      IT = MAX0 (0, 10000 * (ITIME(1)-1900) + 100 * ITIME(2) + ITIME(3))
      IF (SWITCH(25)) THEN  
C           fif st record: ATMOD file, with Cartesian coords:   
         WRITE (IATOMS, 101) PROGNM, IT, KEYS(13)   
  101    FORMAT ('ATMOD  CART   generated by program ', 
     *            A8, ' date', I7, ' RUN', I4)  
      ELSEIF (FNUM(32) .LT. 0.0001) THEN
C           fif st record ATOMS : no scale given
         WRITE (IATOMS, 102) CCODE, PROGNM, IT, KEYS(13)
  102    FORMAT ('ATOMS  ', A6, ' generated by program ',   
     *            A8, ' date', I7, ' RUN', I4)  
      ELSE  
C           fif st record ATOMS : scale given in FNUM(32) / clear   
         WRITE (IATOMS, 103) CCODE, PROGNM, IT, KEYS(13), FNUM(32)  
  103    FORMAT ('ATOMS  ', A6, ' gener. progr. ',  
     *            A8, ' date', I7, ' RUN', I4, ' SC=', F12.7)   
         FNUM(32) = 0.0 
         ENDIF  
C        second record  
      IF (CHOUT .NE. ' ') THEN  
         WRITE (IATOMS, FMT = '(''REMARK '', A65)') CHOUT(1:65) 
         CHOUT = ' '
         ENDIF  
      RETURN
C        END OF SUBR ATOMWA 
      END   
CSUBROUTINE ATOMWB (IATOMS, ATXYZ, ATNAME, NATR)
C-----------------------------------------------------------------------
C Write atomic parameters for atom NATR to file IATOMS (ATOMS or ATMOD) 
C IATOMS = file  unit   
C one record: ATOM name  x  y  z  (occ and B, if not empty) 
C        and: BIJ                 (if necessary; B --> BEQ) 
C NATR   = running index of atom tables ATXYZ and ATNAME
C Call : ATBEQ  
C+----------------------------------------------------------------------
      SUBROUTINE ATOMWB (IATOMS, ATXYZ, ATNAME, NATR)   
      DIMENSION ATXYZ(10,NATR), ATNAME(NATR)
      CHARACTER *6 ATNAME   
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      DIMENSION BEQ(1)  
      BEQ(1) = ATXYZ(5,NATR)
C        check anisotropy   
      IF (ATXYZ(5,NATR) .GT. 0.00001 .AND. ATXYZ(6,NATR) .GT. 0.00001)  
     *   CALL ATBEQ (ATXYZ(1,NATR), BEQ, 1) 
C        write 5 numbers if  (W>0 and W<1) or B>0   
      IF ((ATXYZ(4,NATR) .GT. 0.00001 .AND. ABS(ATXYZ(4,NATR)-1.)   
     *   .GT. 0.00001) .OR. ATXYZ(5,NATR) .GT. 0.00001) THEN
         WRITE (IATOMS, 104) ATNAME(NATR), (ATXYZ(J,NATR), J=1,4), BEQ  
  104    FORMAT ('ATOM  ', A6, 2X, 3F9.5, 2F8.4)
      ELSE  
         WRITE (IATOMS, 104) ATNAME(NATR), (ATXYZ(J,NATR), J=1,3)   
         ENDIF  
      IF (ATXYZ(5,NATR) .GT. 0.00001 .AND. ATXYZ(6,NATR) .GT. 0.00001)  
     *   WRITE (IATOMS, 108)  ATNAME(NATR), (ATXYZ(J,NATR), J = 5,10)   
  108 FORMAT ('BIJ   ', A6, 2X, 6F9.5)  
      RETURN
C        END OF SUBR ATOMWB 
      END   
CSUBROUTINE ATOMST (KEY, ATXYZ, NAT, KEYT)  
C-----------------------------------------------------------------------
C Modify atom data to standardize input atoms:  
C and get KEYT = Temperature factor mode (=1, 2, 3) 
C Input:  KEY = 1 input DATA in 'ATOMS' mode : Change B to U
C         KEY = 2 ..    ..   ..  'XYZN' mode : Change U to B
C         KEY = 0 do not change U or B values   
C         NAT     Number of atoms   
C Output: ATXYZ(NSLOT,MAXAT)   Atom data (X, Y, Z, occ, B ....) 
C Call ATOMST  to change U or B into B or U, respectively,  
C Replace zero occupancy factor by DEFAULT 1.000
C Find temp.factor mode: overall, Biso, Aniso/mixed 
C Answer: KEYT =   1      2     3   
C Note: No test for (ATXYZ(7,I).LT.-0.000001) or otherwise  
C       non-pos.-definite temp. factor. 
C+----------------------------------------------------------------------
      SUBROUTINE ATOMST (KEY, ATXYZ, NAT, KEYT) 
C        NSLOT = 10 for: x, y, z, occ, B or B11, B22, B33, B23, B13, B12
      PARAMETER (NSLOT = 10)
      DIMENSION ATXYZ(NSLOT,NAT)
      PARAMETER (U2B = 8. * 3.141593 **2)   
      FAC = U2B 
      IF (KEY .EQ. 1) FAC = 1. / U2B
      KEYT = 1  
      DO 200 I=1,NAT
      IF (ABS(ATXYZ(4,I)).LT.0.000001) ATXYZ(4,I) = 1.0 
C        FIND TEMP.FACTOR TYPE (OVERALL, ISO, ANISO-MIXED)  
C        ANSWER:          KEYT =   1      2     3   
      IF (ATXYZ(5,I).LT.0.000001) THEN  
         ATXYZ(5,I) = 0.0   
         ATXYZ(6,I) = -0.000001 
         GOTO 150   
         ENDIF  
C        Temp.factor found  
*           IF (NSLOT.LT.10) skip follwing test 
      IF (ATXYZ(6,I).GT.0.000001) THEN  
         KEYT = 3   
      ELSE  
         ATXYZ(6,I) = -0.000001 
         ENDIF  
      IF (KEYT.EQ.1) KEYT = 2   
C        IF KEY=2:'XYZN ': U; DO TRANSFORM TO B 
C        IF KEY=1:'ATOMS': B; DO transform to U 
  150 IF (KEY .EQ. 0) GOTO 200  
C        change 
      IF (ATXYZ(5,I) .EQ. 0) GOTO 200   
      ATXYZ(5,I) = ATXYZ(5,I) * FAC 
      IF (ATXYZ(6,I) .LE. 0) GOTO 200   
      DO 180 J=6, NSLOT 
  180 ATXYZ(J,I) = ATXYZ(J,I) * FAC 
  200 CONTINUE  
      RETURN
C        END OF SUBR ATOMST 
      END   
CSUBROUTINE ATOMOC (KEY, ATXYZ, MSELF, NAT) 
C-----------------------------------------------------------------------
C Modify atom data and get symmetry-multiplicity (occupation) factor
C    If KEY = 1: multiply occ.fact. by 1/(symmetry-multipl.)
C    If KEY = 2: multiply occ.fact. by (symmetry-multipl.)  
C    If KEY = 0: do not change occ.factor, however, set MSELF:  
C                MSELF is the multiplicity of symmetry identicities 
C Note: use this routine only if needed .... no check ....  
C Input:  KEY = 1 input data from 'ATOMS' file (occ=1.) do change...
C         KEY = 2 ..    ..   ..   'XYZN'  file (occ=1/mult) 
C         NAT     Number of atoms   
C         ATXYZ   atomic parameters, dimension: ATXYZ(10,NAT)   
C Output: ATXYZ (4,NAT) occupation factor (1.0 for normal atoms)
C               (standard is: partial occupation (disorder) 
C               (SHELX: mult. by the symmetry reduction factor) 
C         MSELF Self multiplicity (.GE. 1), only filled if KEY=0
C               dimension: MSELF(NAT)   
C Calls: ISELFD 
C                                                      S. GARCIA-GRANDA 
C+----------------------------------------------------------------------
C HKL(3) FOR SYMMETRY TRANSFORMED INDICES   
      SUBROUTINE ATOMOC (KEY, ATXYZ, MSELF, NAT)
C        NSLOT = 10 for: x, y, z, occ, B or B11, B22, B33, B23, B13, B12
      PARAMETER (NSLOT = 10)
      DIMENSION ATXYZ(NSLOT,NAT), MSELF(NAT)
C        ATXYZ(NSLOT,NAT)   ATOM DATA (X, Y, Z, occ, B, ...)
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION  XYZ(3) 
CPTB: opm: DO 1,NLAT en XYZ(K) = ... +TLATT(K,IL)   
CPTB  moet in de binnen LOOP  .....  use SYMOP1 and SYMOP2 ... of ??
CPTB-----------nog doen --------------------------------------------
      DO 150 I=1,NAT
C        COUNT NUMBER OF HITS   
      N = 0 
      DO 140 IL=1,NLATT 
      DO 140 J=1,NSYMM  
      DO 120 K=1,3  
  120 XYZ(K) = TSYMM(K,J) + TLATT(K,IL) 
     *       + ATXYZ(1,I) * IRSYMM(K,1,J)   
     *       + ATXYZ(2,I) * IRSYMM(K,2,J)   
     *       + ATXYZ(3,I) * IRSYMM(K,3,J)   
      N = N + ISELFD (ATXYZ(1,I), XYZ, 0.04)
      IF (ICENT.EQ.1)  GOTO 140 
      DO 130 IC=1,3 
  130 XYZ(IC) = -XYZ(IC)
      N = N + ISELFD (ATXYZ(1,I), XYZ, 0.04)
  140 CONTINUE  
C  If KEY = 0: -------> occ.fact. is stored in MSELF
C  If KEY = 1: multiply occ.fact. by 1/(symmetry-multipl.)  
C  If KEY = 2: multiply occ.fact. by (symmetry-multipl.)
      IF (KEY .EQ. 0) MSELF(I) = N  
      IF (KEY .EQ. 1) ATXYZ(4,I) = ATXYZ(4,I) / FLOAT(N)
      IF (KEY .LE. 1) GOTO 150  
C         KEY=2: bring back to 1.0: check rounding off  
      ATXYZ(4,I) = ATXYZ(4,I) * FLOAT(N)
      IF (ABS (ATXYZ(4,I) - 1.0) .LT. 0.0001) ATXYZ(4,I) = 1.0  
  150 CONTINUE  
      RETURN
C        END OF SUBR ATOMOC 
      END   
CSUBROUTINE ATBEQ (ATXYZ, BEQ, NAT) 
C---------------------------------------------------------------------  
C Calc. equivalent isotropic B from anisotropic thermal parameters  
C       Reference: W.C. Hamilton, ACTA CRYST. 12, 609 (1959).   
C Input:  (ATXYZ(NSLOT,NAT) 
C         Items 5:10 = Bij = anisotropic temp. factors  
C Output: BEQ(NAT) = Ave. isotropic temp. factor
C Note: if NAT=1 then prelims will be calculatd only once   
C SI(I) = SIN(ANGLE/RAD)
C CO(I) = COS(ANGLE/RAD)
C R4    = 3 * (1 - SUM(CO**2) + (2 * CO(1) * CO(2) * CO(3)))
C+----------------------------------------------------------------------
      SUBROUTINE ATBEQ (ATXYZ, BEQ, NAT)
C        NSLOT = 10 for: x, y, z, occ, B or B11, B22, B33, B23, B13, B12
      PARAMETER (NSLOT = 10)
      DIMENSION ATXYZ(NSLOT,NAT), BEQ(NAT)  
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION SI(3), CO(3), SISI(6)   
      LOGICAL CONT  
      DATA CONT /.FALSE./   
C        Dummy DATA statement to avoid useless compiler warnings
      DATA R4 / 0.0 /   
      IF (NAT .GT. 1) CONT = .FALSE.
      IF (CONT) GOTO 133
      CONT = .TRUE. 
      RAD = 57.295789   
      DO 100  I=4,6 
      SI(I-3) = SIN(CELL(I)/RAD)
      CO(I-3) = COS(CELL(I)/RAD)
      IF (ABS(CELL(I)-90.).LT.0.0001)  CO(I-3)=0.0  
  100 CONTINUE  
      R4 = 1.0  
      DO 110  I=1,3 
  110 R4 = R4 - CO(I)**2
      R4 = (R4 + (2. * CO(1) * CO(2) * CO(3))) * 3. 
      DO 130  I=1,3 
      SISI(I) = SI(I)**2
      DO 130  J=1,3 
      IF (J - I)   130, 130, 120
  120 SISI(9-I-J) = SI(I) * SI(J) * 2.0 * CO(6-I-J) 
  130 CONTINUE  
  133 DO 150  M=1,NAT   
      B = 0.0   
      DO 140  I=1,6 
  140 B = B + SISI (I) * ATXYZ(I+4,M)   
  150 BEQ(M) = B / R4   
      RETURN
C         END OF SUBROUTINE ATBEQ   
      END   
CSUBROUTINE ATBETA (ATXYZ, NAT) 
C---------------------------------------------------------------------  
C Program to calculate beta's from anisotropic Bij 's   
C Input:  ATXYZ(NSLOT,NAT)  
C         Items 5:10 = Bij = anisotropic temp. factors  
C Output: BETAij values, suitable for structure factor calculation  
C+----------------------------------------------------------------------
      SUBROUTINE ATBETA (ATXYZ, NAT)
C        NSLOT = 10 for: x, y, z, occ, B or B11, B22, B33, B23, B13, B12
      PARAMETER (NSLOT = 10)
      DIMENSION ATXYZ(NSLOT,NAT)
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
C RLP    - RECIPROCAL AXES VALUES   
      DIMENSION RLP(3), RLP2(6) 
CPTB     mogelijk tweede call: terug transformatie ...  
      DATA IFIRST /0/   
      IFIRST = IFIRST + 1   
CPTB     IF = 2 transform back  
      DO 200 K=1,3  
      RLP(K)  = SQRT(SSMAT(K,K))
  200 RLP2(K) = SSMAT(K,K)  
      RLP2(4) = RLP(2) * RLP(3) * 2.
      RLP2(5) = RLP(1) * RLP(3) * 2.
      RLP2(6) = RLP(1) * RLP(2) * 2.
C        TEMPERATURE FACTORS TO BE USED IN FCALC ARE B (NOT U)  
C        IF ATXYZ(5,...) .LE. 0.0: OVERALL TEMPERATURE FACTOR BP
      DO 220 I=1,NAT
C        IF ATXYZ(6,...) .LT. 0.0: ATXYZ(5,...) = B(ISOTR)  
      IF (ATXYZ(6,I).LE.0.0) GOTO 220   
C        IF ANISOTROPIC, MULTIPLY WITH THE APPROPRIATE RECIPROCAL AXES  
C        VALUES AS NEEDED BY THE ANISOTROPIC TEMPERATURE FACTOR 
C        EXPRESSION / WARNING: ATXYZ(6,..) ARE NOT TEMP.FACT. NOMORE
C        CALC. Rij(6)  = B11 * Astar**2 or B12 * 2*Astar*Bstar  
      DO 210 J=5,10 
  210 ATXYZ(J,I) = ATXYZ(J,I) * RLP2(J-4)   
  220 CONTINUE  
      RETURN
C         END OF SUBROUTINE ATBETA  
      END   
CSUBROUTINE CELZIN (ATXYZ, IZAT, NAT, NCELLZ, NCELIN)   
C-----------------------------------------------------------------------
C Count input atoms for all atom types  
C Input:  ATXYZ and IZAT (params and Z, resp) for NAT atoms 
C         NCELLZ(10) number of at.(Z) /cell, ordered by CELZAT  
C Output: NCELIN(10) number of such atoms /cell, input  
C Note: if no H given, ignore IZ=1  
Call: ATOMOC
C+----------------------------------------------------------------------
      SUBROUTINE CELZIN (ATXYZ, IZAT, NAT, NCELLZ, NCELIN)  
      DIMENSION ATXYZ(10,NAT),  IZAT(NAT), NCELLZ(10), NCELIN(10)   
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      EQUIVALENCE (LIS2,   IFILE(8))
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION IOCC(1) 
      CALL KERNZI (0, NCELIN, 10)   
C        loop to count input atoms  
      DO 590 I = 1, NAT 
C        get symm. multiplicity in IOCC(1)  
C        IOCC(1) = 1 for general position, with IMULT atoms per cell.   
C        IMULT = NSYMM * ICENT * NLATT   // Nr of at. = IMULT/IOCC(1)   
      CALL ATOMOC (0, ATXYZ(1,I), IOCC(1), 1)   
      NN = NINT (ATXYZ(4,I) * FLOAT (IMULT/IOCC(1)))
      DO 585 N = 1, NTYPE   
      IF (NCELLZ(N) .NE. IZAT(I)) GOTO 585  
      NCELIN(N) = NCELIN(N) + NN
      GOTO 590  
  585 CONTINUE  
      IF (IZAT(I) .LE. 1) GOTO 590  
      CALL KERROR   
     *   (' Input atom type not defined by CRYSDA', 585, 'CELZIN')  
  590 CONTINUE  
      WRITE (LIS2, 614) (NCELIN(I), I=1,NTYPE)  
  614 FORMAT (' Number of atoms input: ', 10I5) 
      RETURN
C        END OF SUBR CELZIN 
      END   
CSUBROUTINE RDCOND (IRDX, L, LMAX, KEND)
C-----------------------------------------------------------------------
C Read keywords from control data file: CCODE CONDA 
C Short write-up CONDA file:
C Fif st file record:  CONDA CCODE .... 
C Second file record, optional: TITLE ....  
C For each program (as may as needed):  
C    Fif st record: PROGRAM programname .....   
C    Following records: keyword data ....   
C Note: all keywords must be defined in the calling pgm !   
C Last record: END (or next line must be PROGRAM)   
C Consecutive programs must be given in the correct order.  
C Last useful file record: FINISH   
C Optional: FINISH may be followed by unused records.   
C Write-up of the subroutine RDCOND 
C Fif st call: test if CONDA file is present: If it is: 
C    find record with fif st word: 'PROGRAM'
C                and second word:  program-name as given in L(1).   
C    store title in TITLE / print to LIS1 and LIS2  
C Following calls: read next record and check   
C    first word of input record against L(i), i=1,LMAX .
C Keep recalling untill all control data are processed. 
C If that has been done, and all control data have been processed:  
C    rewrite the CONDA file, but omit all foregoing records.
C Input : IRDX: input CONDA file  (normally unit 4, name ICON)  
C         L   : list of keywords
C         L(1): fif st keyword = the name of the calling program
C         LMAX: number of keywords stored in array L
C Output: KEND: return key: 
C         KEND =  1 fif st record (keyword = L(1) = program name) found 
C         KEND = -1 fif st record (keyword) not found   
C         KEND = -2 CONDA file not found
C Output after next call :  
C         KEND =  i next record: keyword = L(i) found   
C         KEND =  0 next record: no keyword found:  
C                   i.e. end of data for the program
C         Note: KEND=0 implies the the CONDA file has been rewritten,   
C                   leaving out present and preceding control data. 
C               If no more control data is present, 
C               the CONDA file is deleted, else it is closed.   
C At the first call a CONDA file is openened,   
C REWIND, and CCODE is tested.  
C The first call for a program initiates the positioning of the file
C    and reads the data present on the PROGRAM record.  
C After KEND=1 the calling program may call RDCOND again
C    to read following control data, as listed in array L(LMAX).
C The return key (KEND) is set equal to the position of the 
C    fif st word (of the input record) in the array L, and  
C    the contents of the input record are interpreted in the
C    usual way by the freeformat reading routines (e.g. KERINB).
C    Thus LIT(1) etc. represents the contents of the last input record. 
C KEND = 0 if the control data for this program is finished.
C KEND is set negative if the CONDA file does not exist, or if the  
C    correct 'PROGRAM' record (with second word = L(1) ) is not present 
C    (e.g. 'FINISH', 'STOP' or 'End-of-File' is encountered) .  
C The PROGRAM calls should be in the correct calling order. 
C Note the use of blank COMMON / / : it is needed in RDCOND.
C+----------------------------------------------------------------------
      SUBROUTINE RDCOND (IRDX, L, LMAX, KEND)   
      CHARACTER * 6  L(LMAX)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (LIS1, IFILE(7)), (LIS2, IFILE(8))
      LOGICAL FIRST 
      EQUIVALENCE (SWITCH(9), FIRST)
C Note: if FIRST=.FALSE. then a second MAIN program is in execution 
C       at present : not used ??
      PARAMETER (NCHMAX=517)
C     ------ / / blank common for storage of CONDA data 
      COMMON / / CHONDA(NCHMAX) 
      CHARACTER * 80 CHONDA 
      CHARACTER * 6  PROLD  
      LOGICAL CONDA 
      DATA    CONDA, PROLD / .TRUE., ' ' /  
C        Dummy DATA statement to avoid useless compiler warnings
      DATA NCH, NCHA, KDAT  / 0, 0, 0 / 
      KEND = -2 
      IF (.NOT. CONDA)  RETURN  
      IF (PROLD .NE. ' ') GOTO 300  
C        initiate 'CONDA' file, IRDX = ICON = file unit 
C        KINQ = 0 (exist, open, rewind), KINQ = -1 (does not exist) 
      CALL FILINQ (IRDX, 'CONDA', 'FORMATTED', 'INPUT', KINQ)   
      IF (KINQ.EQ.-1) THEN  
         WRITE (LIS2, 190) CCODE
  190    FORMAT (' Control data file: ', A6,' CONDA not present')   
         CONDA = .FALSE.
         RETURN 
         ENDIF  
C        now CONDA file opened, read fif st line: CONDA CCODE ...   
      CALL KERINA (IRDX, LIT, 1, LEND)  
C        LEND = -1 EOF, = 4 END, = 5 FINISH, = 6 STOP   
      IF (LEND.NE.0 .OR. LIT(1).NE.'CONDA' .OR. LIT(2).EQ.' ')  
     * CALL KERROR ('ERROR on fif st record of CONDA file', 0, 'RDCOND')
C        literal found, i.e. 'CONDA' found  
      IF (CCODE .EQ. ' ') CCODE = LIT(2)
      WRITE (LIS2, 230) 
  230 FORMAT (' Input control data file  CONDA')
C        error: different CCODE found   
      IF (CCODE .NE. LIT(2)) THEN   
         WRITE (CHOUT, 250) CCODE, LIT(2)   
  250    FORMAT ('ERROR: CCODE = ', A6,' but on CONDA file it is ', A6) 
         CALL KERROR (CHOUT, 0, 'RDCOND')   
         ENDIF  
C        store fif st record
      NCH = 1   
      NCHA = 1  
      CHONDA(NCH) = CHIN
C        Read next record ...  TITLE .. ? ... .and REWIND ...   
      CALL KERINA (IRDX, LIT, 1, LEND)  
C        LEND = -1 means EOF,   = 4 means END,   = 5 FINISH,   = 6 STOP 
      IF (LEND.LT.0 .OR. LEND.GE.5) THEN
         WRITE (CHOUT, FMT='('' Empty CONDA file ...... '')')   
         CALL SHOUT 
         CONDA = .FALSE.
         CALL FILCLO (IRDX, 'DELETE')   
         RETURN 
         ENDIF  
C        CONDA file OK. See if this record is a TITLE   
      PROLD = '$DUMMY'  
      IF (LIT(1) .EQ. 'TITLE') THEN 
C95:
         IF (TITLE(1:64) .NE. CHIN(7:70)) THEN  
            TITLE = CHIN(7:80)  
C        assumed that TITLE is given on columns 1-5, 6=blank
            WRITE (LIS1, FMT='('' RUN TITLE: '', A64)') TITLE   
            WRITE (LIS2, FMT='('' RUN TITLE: '', A64)') TITLE   
            ENDIF   
C        store TITLE record 
         NCH = 2
         NCHA = 2   
         CHONDA(NCH) = CHIN 
      ELSE  
         BACKSPACE IRDX 
         ENDIF  
C        seach for PROGRAM call 
C           also enter here at next (normal) call   
  290 CALL KERINA (IRDX, L, LMAX, LEND) 
C        LEND = -1 means EOF,   = 4 means END,   = 5 FINISH,   = 6 STOP 
      IF (LEND .LT. 0 .OR. LEND .GE. 5) THEN
         WRITE (LIS2, 295) L(1) 
  295    FORMAT (' Requested record: PROGRAM ', A6 /
     *            ' not found in CONDA file ' ) 
C PTB 3 June 1991 ??????  CONDA blijft, PROLD terug naar blank  
*****    CONDA = .FALSE.
         PROLD = ' '
         KEND = -1  
         CALL FILCLO (IRDX, 'KEEP') 
         RETURN 
         ENDIF  
      IF   (LIT(1).NE.'PROGRA' .OR. LIT(2).NE.L(1)) GOTO 290
C        PROGRAM found  
      KDAT = 0  
      KEND = 1  
      RETURN
C        PROGRAM found earlier, read following records if LMAX > 1  
  300 KEND = 0  
      CALL KERIFF (IRDX, L, LMAX, KSTOP)
C        KSTOP=0 if no system card,   =4,5,6 if END, etc,   =-1 if EOF  
C        GOTO: 801=read next line, 803=store present line, 807=finished 
      IF (KSTOP .LT. 0) GOTO 807
      IF (KSTOP .GE. 5) GOTO 803
      IF (KSTOP .NE. 0) GOTO 801
C        end of data also if next is PROGRAM , KEND=0 : 
      IF (LIT(1).EQ.'PROGRA') GOTO 803  
      IF (KDAT .EQ. 0) THEN 
         WRITE (LIS2, 320) CCODE
  320 FORMAT (' Input from control data file CONDA for compound ', A6)  
         KDAT = 1   
         ENDIF  
C        fif st or next KEYWORD FOUND   
      WRITE (LIS2, 322) CHIN(1:72)  
  322 FORMAT (' Input: ' , A72) 
C        NLUSER(1) = number where LIT(1) is found in array L
C        NLUSER(1) = -1 if LIT(1) is not found in array L   
      IF (NLUSER(1).LE.0) CALL KERROR (' Unidentified control card',
     *    0, 'RDCOND')  
      KEND = NLUSER(1)  
      RETURN
C        read and re-write remainder of CONDA file (stop at FINISH) 
  801 CALL KERINA (IRDX, LIT(32), 1, LEND)  
      IF (LEND .EQ. -1) GOTO 807
  803 NCH = NCH + 1 
      IF (LIT(1) .EQ. 'STOP' .OR. LIT(1) .EQ. 'FINISH') NCHA = NCHA+1   
      IF (NCH .GE. NCHMAX) CALL KERROR ('CONDA too big', 801, 'RDCOND') 
      CHONDA(NCH) = CHIN
      IF (LIT(1) .NE. 'STOP' .AND. LIT(1) .NE. 'FINISH') GOTO 801   
C        rewrite
  807 REWIND IRDX   
      DO 808 I = 1, NCH 
  808 WRITE (IRDX, FMT = '(A80)') CHONDA(I) 
      REWIND IRDX   
      IF (NCHA .GE. NCH) THEN   
         CALL FILCLO (IRDX, 'DELETE')   
         CONDA = .FALSE.
         ENDIF  
      PROLD =' '
      RETURN
C       END OF SUBROUTINE RDCOND
      END   
CSUBROUTINE LOGWR (IDDL)
C-----------------------------------------------------------------------
C Fif st call of subroutine LOGWR in subroutine DDSTART 
C Normal call of subroutine LOGWR to write mesagge MSG in file DDLOG
C    Description of the DDLOG file:  CCODE.DDLOG
C The DDLOG file is a formatted file. It is used for communication  
C between different programs and for different consecutive jobs / runs. 
C The file may be inspected by the user:
C REMARK records  may be inserted, but any change in the DDLOG  
C records must conform to the FORMAT for this record.   
C    (The DDLOG file is not designed for manual alterations !)  
C Contents: record 1:          DDLOG CCODE date 
C           record 2:          TITLE = .........
C           following records: PROGNAME date (KEYWORDS data ....)   
C           last record:       END  
C A number of different subroutines LOGpgm are used by different
C programs. Within these subroutines the printable text 
C (character strings) and the FORTRAN FORMAT (for the variables 
C to be printed) are defined.   
C For instance:  CALL  LOGWIL (SC)  
C Or: subroutine LOGMER called by program MERBIN to write 7 parameters  
C In general:    CALL  LOGpgm (var1, var2, ....)
C All LOGpgm subroutines call one common subroutine LOGWR . 
C Subroutine LOGWR writes a message (stored in CHOUT) to the DDLOG file 
C IDDL = unit number for DDLOG file 
C Execution:
C If DDLOG file exists: open DDLOG file, read until 'END' , 
C    BACKSPACE, write CHOUT and write 'END' , clear CHOUT.  
C If no DDLOG file exists: open DDLOG file, write heading, ask for a
C    title, write TITLE, initiate RUN number (IRUN = 1, equiv.KEYS(13)),
C    write CHOUT and write 'END' to the DDLOG file; clear CHOUT.
C Note: only CHOUT(1:56) is written to DDLOG file. Write CHOUT to LIS2 .
C+----------------------------------------------------------------------
      SUBROUTINE LOGWR (IDDL)   
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (IRD,  IFILE(5)), (IPR1, IFILE(6)), (LIS1, IFILE(7))  
      EQUIVALENCE (LIS2, IFILE(8))  
      EQUIVALENCE (IRUN, KEYS(13))  
      LOGICAL BATCH, FULAUT 
      EQUIVALENCE (BATCH, SWITCH(8)), (FULAUT, SWITCH(12))  
C        save CHOUT in CHOUT2   
      CHARACTER*56 CHOUT2   
C95 
      DATA IFIRST / 0 / 
      IFIRST = IFIRST + 1   
      CHOUT2 = CHOUT
C        Get date as one integer number (Yr, Mo, Day)   
      IT = 0
      IF (ITIME(1) .GT. 0)  
     *    IT = 10000 * (ITIME(1)-1900) + 100 * ITIME(2) + ITIME(3)  
C        Subroutine FILINQ inquif es, opens and rewinds a file  
C        KINQ = 0 (file opened), = -1 (file doesn't exist)  
      CALL FILINQ (IDDL, 'DDLOG', 'FORMATTED', 'OUTPUT', KINQ)  
      IF (KINQ.EQ.0) GOTO 220   
C         if file CCODE.DDLOG did not exist, write head 
      WRITE (IDDL, 200) CCODE, IT   
  200 FORMAT ('DDLOG ', A6,' GENERATION DATE ', I7,' DO NOT DESTROY')   
      WRITE (LIS1, 201) IT  
      WRITE (LIS2, 201) IT  
  201 FORMAT (' DDLOG file: GENERATION DATE ', I7,' DO NOT DESTROY')
      IF (BATCH .OR. FULAUT) GOTO 215   
  210 WRITE (IPR1, FMT='('' Welcome to DIRDIF Wonderland'' /
     * '' Please give TITLE (will be stored in DDLOG file):'')')
      CALL KETERM (-1, -1, KEND)
      IF (KEND.LT.0) GOTO 210   
      TITLE = CHIN  
  215 CHOUT = ' Welcome to DIRDIF Wonderland'   
      CALL SHOUT2   
      IF (TITLE .NE. ' ') THEN  
         WRITE (IDDL, FMT='(''TITLE = '', A64)') TITLE  
         WRITE (LIS1, FMT='('' LOG TITLE: '', A64)') TITLE  
         WRITE (LIS2, FMT='('' LOG TITLE: '', A64)') TITLE  
         ENDIF  
      CHOUT = 'RUN   1' 
      WRITE (IDDL, 217) PROGNM, IT, CHOUT(1:56) 
  217 FORMAT (A8, I7, 1X, A56)  
      WRITE (LIS1, FMT='(A)')   
     * ' Note: DDLOG is used for communication between various programs'
      CHOUT = ' '   
      IRUN = 1  
      IF (CHOUT2 .EQ. ' ') RETURN   
      GOTO 250  
    
C         CCODE.DDLOG exists: read until 'END'  
  220 READ (IDDL, FMT='(A3)', END=230) CHIN(1:3)
      IF (CHIN(1:3).NE.'END') GOTO 220  
      GOTO 245  
  230 WRITE (LIS1, 240) 
  240 FORMAT (' Warning: no END record found on the DDLOG file')
C        If no END: last record lost ?? 
  245 BACKSPACE IDDL
C        CCODE.DDLOG opened and correctly positioned for writing
  250 WRITE (IDDL, 260) PROGNM, IT, CHOUT2  
  260 FORMAT (A8, I7, 1X, A56 / 'END' / 'END')  
      IF (IFIRST .EQ. 1) WRITE (LIS2, FMT='(1X)')   
      WRITE (LIS2, 262) PROGNM, IT, CHOUT2  
  262 FORMAT (' Control data for DDLOG:'
     *    / 1X, A8, I7, 1X, A56)
      CHOUT = ' '   
      RETURN
C        END OF SUBROUTINE LOGWR
      END   
CSUBROUTINE LOGRD (IDDL, LITX, KLOG)
C-----------------------------------------------------------------------
C Reads the file DDLOG  === file write-up: see LOGWR ====   
C If DDLOG is not present: return with KLOG = -1
C Else open and rewind file and read.   
C Test if requested literal LITX is present:
C    if found, store record in CHIN, continue reading, and  
C    if LITX is found again, overwrite data in CHIN, etc.,  
C    interpret data and fill common data SYSTA and SYSTB ,  
C    and return with KLOG = n = posn of LITX in LIT .   
C    NOTE: the DDLOG file will be positioned ready to read next record! 
C Else: LITX not found: return with KLOG = 0 .  
C IDDL = unit number for DDLOG file 
C Summary:  
C LITX =  Literal to be searched for = PROGNM or KEYWORD
C KLOG =  n LITX found at n-th position in array LIT, data stored in
C           CHIN with normal interpretation (KERINA & KERINB convention)
C KLOG =  0 LITX not found in file CCODE.DDLOG  
C KLOG = -1 file CCODE.DDLOG not found  
C+----------------------------------------------------------------------
      SUBROUTINE LOGRD (IDDL, LITX, KLOG)   
      CHARACTER LITX *(*)   
      CHARACTER LITS(1) *6  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (IRD,  IFILE(5))  
      EQUIVALENCE (IPR1, IFILE(6))  
      EQUIVALENCE (LIS1, IFILE(7))  
***   CHARACTER CHINX *72   
      CHARACTER CHINX *72   
C        Subroutine FILINQ inquif es, opens and rewind an existing file 
C         KLOG = 0 (file opened), = -1 (file doesn't exist) 
      CALL FILINQ (IDDL, 'DDLOG', 'FORMATTED', 'INPUT', KLOG)   
      IF (KLOG.EQ.-1) RETURN
      ICOUNT = 0
      IREGEL = 0
      LITS(1) = LITX
C         CCODE.DDLOG exists: read and search for LITS  
  200 CALL KERINA (IDDL, LITS, 1, LEND) 
C 12 Oct 95 count input record: 
      ICOUNT = ICOUNT + 1   
C        end-of-file (+error in file / do not stop) 
      IF (LEND .EQ. -1) WRITE (LIS1,
     *    FMT='('' Warning: no END marker on the DDLOG file'')' )   
C        also e-o-f, or: END, FINISH, STOP : no more data; finished 
      IF (LEND .NE. 0) GOTO 230 
C        if requested literal has been found: signal in NLUSER(1):  
C        if requested literal not present ...  (print msg to IPRI2 ?)   
      DO 210 I=1,NLIT   
      IF (NLUSER(I).EQ.1) GOTO 220  
  210 CONTINUE  
      GOTO 200  
C        LITS found: may be LIT(1), or       LIT(2), or ... with:   
C                           PROGNM  or fif st KEYWORD or .........  
  220 KLOG = I  
C 12 Oct 95 save input record number:   
      IREGEL = ICOUNT   
      CHINX = CHIN  
C        save CHIN, and look for more recent data   
      GOTO 200  
C         end of CCODE.DDLOG found  
  230 IF (KLOG .EQ. 0) RETURN   
C        re-interpret data in CHINX 
      CHIN = CHINX  
      CALL KERINB (LITS, 1) 
C 12 Oct 95 skip counted input records: 
      REWIND (IDDL) 
      DO 300 I=1,IREGEL 
  300 READ (IDDL,FMT='(A1)')
      RETURN
C        END OF SUBROUTINE LOGRD
      END   
CSUBROUTINE COPY80 (IIN, FIN, IOUT, FOUT)   
C-----------------------------------------------------------------------
C Copy a file of 80 columns:
C    IIN : unit number of input  file with file name FIN
C    FIN : file name (max 7 characters) 
C    IOUT: unit number of output file with file name FOUT   
C    FOUT: file name (max 7 characters) 
C Input file does not exist: return without any action  
C Input file exists: open (if not already done) and rewind, 
C    Output file does not exist: open new output file FOUT. 
C    Output file exists: rewind, read and skip all records up to FINISH.
C    Copy input file FIN to output file FOUT, and append FINISH record. 
C    Rewind input file and close output file
C+----------------------------------------------------------------------
      SUBROUTINE COPY80 (IIN, FIN, IOUT, FOUT)  
      CHARACTER FIN *(*), FOUT *(*), FINX *7, FOUTX *7  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (KEYS(13), IRUN)  
      EQUIVALENCE (LIS1, IFILE(7))  
C95!! LOGICAL EXS   
      CHARACTER LAST *6 
      FINX  = FIN   
      FOUTX = FOUT  
      LAST = ' '
C95 
***   IF (IIN.EQ.0 .OR. FIN.EQ.' ') CALL KERROR 
      IF (IIN.LE.0 .OR. IIN.GT.20 .OR. FIN.EQ.' ') CALL KERROR  
     *   ('No input unit number or no file name given', 0, 'COPY80')
C95   IF (IOUT.EQ.0 .OR. FOUT.EQ.' ') CALL KERROR   
      IF (IOUT.LE.0 .OR. IOUT.GT.20 .OR. FOUT.EQ.' ') CALL KERROR   
     *   ('No output unit number or no file name given', 0, 'COPY80')   
C        Test presence of input file. Special case: need not be present.
C95!! INQUIRE (FILE=FINX, ERR=220, IOSTAT=KINQ, EXIST=EXS)  
C95!! IF (.NOT. EXS) RETURN 
      CALL FILINQ (IIN, FINX, 'FORMATTED', 'INPUT', KINQ)   
C96:
      IF (KINQ .NE. 0) RETURN   
*     IF (KINQ .NE. 0) THEN 
*        WRITE (LIS1, 123) FINX, FOUTX  
* 123    FORMAT (' Input file ',A7,' for copy to file ',A7,' not found')
*        RETURN 
*        ENDIF  
C        Open output file   
      CALL FILINQ (IOUT, FOUTX, 'FORMATTED', 'OUTPUT', KINQ)
C        not old file: goto copy:   
CPTB 25 Jun 90  
      IF (KINQ .EQ. -1) THEN
         IF (FOUT .EQ. 'ATOLD') 
     *      WRITE (IOUT, 142) CCODE, (ITIME(I), I=1,3), IRUN, CCODE 
  142       FORMAT ('ATOLD ', A6, ' file (= ATOMS OLD) created: DAY',   
     *        I5, 2I3, ' RUN', I4 / 
     *        '    Note: for proper reuse of old atomic parameters:'/   
     *        '    select wanted header record (ATOMS ', A6, '), and'/  
     *        '    copy it with following records up to (incl.) END'/   
     *        '    to the ATOMS file'/) 
         IF (FOUT .NE. 'ATOLD') 
     *      WRITE (IOUT, 144) FOUT, CCODE, (ITIME(I),I=1,3), IRUN, CCODE
  144       FORMAT ('REMARK : ', A6, 1X, A6, ' file created:  DAY', 
     *         I5, 2I3, ' RUN', I4 )
         GOTO 200   
         ENDIF  
C        KINQ=0: old file: skip  (see if END is on last record < FINISH 
      NR = 0
CPTB 25 Jun 90 reset Wil's "corr" van 8 Jun 
  150 READ (IOUT, 202, END=180, ERR=250) CHIN   
      NR = NR + 1   
      IF (CHIN(1:6) .NE. 'FINISH') THEN 
         LAST = CHIN(1:6)   
         GOTO 150   
         ENDIF  
      BACKSPACE IOUT
      GOTO 190  
C        EOF of IOUT without FINISH 
  180 REWIND IOUT   
      DO 182 I = 1, NR  
CPTB 25 Jun 90 reset Wil's "corr" van 8 Jun 
  182 READ (IOUT, 202)  
  190 IF (LAST .NE. 'END   ') WRITE (IOUT, FMT='(''END'')') 
      WRITE (IOUT, 192) PROGNM, (ITIME(I), I=1,3), IRUN 
CPTB 25 Jun 90  
  192 FORMAT (/ 'Next file appended by program ', A8,   
     *       '   DAY', I5, 2I3, ' RUN', I4 /)   
C        copy input file IIN to output file IOUT
  200 N = 0 
CPTB 25 Jun 90 reset Wil's "corr" van 8 Jun 
      READ (IIN, 202, END=210, ERR=270) CHIN
  202 FORMAT (A80)  
      N = N + 1 
      WRITE (IOUT, 202) CHIN
      IF (CHIN(1:6) .NE. 'FINISH') GOTO 200 
  210 IF (CHIN(1:6) .NE. 'FINISH') WRITE (IOUT, FMT='(''FINISH'')') 
      REWIND IIN
      REWIND IOUT   
      CALL FILCLO (IOUT, 'KEEP')
      RETURN
C        errors 
C95  220 WRITE (CHOUT, 230) FINX, IIN   
C95  230 FORMAT (' Error inquif e file ', A7, ', unit number ', I3) 
C95      GOTO 282   
  250 WRITE (CHOUT, 280) FOUTX, IOUT
      GOTO 282  
  270 WRITE (CHOUT, 280) FINX, IIN  
  280 FORMAT (' Error reading file ', A7, ', unit number ', I3) 
  282 CALL KERROR (CHOUT, 0, 'COPY80')  
      RETURN
C        END OF SUBROUTINE COPY80   
      END   
CSUBROUTINE VALDIS (KEY, V1, V2, KARR, KM, KEND)
C-----------------------------------------------------------------------
C Find the distribution of values of a real variable
C within a given interval.  
C    Call VALDIS (-1, VMIN, VMAX, KARR, KM, KEND) where:
C KEY=-1  INITIATION CALL:  Clear and set CONSTANTS.
C VMIN and VMAX define the interval;
C The interval VMIN,VMAX is devided in  (KM-2) boxes.   
C The increment per box is:   VINC = (VMIN-VMAX)/(KM-2) 
C KARR is the array for the distribution counts; KM = dimension 
C KEND is the number of counts, set to zero.
C    Call VALDIS (0, VALUE, V2, KARR, KM, KEND) where:  
C KEY=0   Distribution call:  COUNT.
C VALUE is the value to be counted in position KARR(KAD);   
C V2 is dummy: it is not used in this call  
C KAD is the address in array KARR, calculated as   
C KAD = IFIX( (VALUE - VMIN + 2*VINC)/VINC )
C KAD = 1  if value.LT.VMIN ,   KAD = KM if value.GE.VMAX   
C KEND is the current number of counts  
C    Call VALDIS (KEY, VLIM, V2, KARR, KM, KEND) where: 
C KEY.GT.0: FINAL CALL:  accumulation; conclusion.  
C KEY = N = Number of counts requested  
C VLIM  is the limitation (threshold) returned by the subr. 
C There will be approximately  N counts with:  VALUE.GE.VLIM
C The result for VLIM is obtained by linear interpolation,  
C    and may not be very accurate.  
C If the threshold (for N) is outside the interval (VMIN - VMAX)
C    the return result for VLIM is obtained by interpolation
C    with respect to the minimum or maximum value encountered.  
C If for instance N=0 or N.GE.KEND VLIM = VMIN or VMAX, resp.   
C KEND is the total number of counts
C    (V2 is dummy: it is not used in this call) 
C+----------------------------------------------------------------------
C LOCAL MEANING: EQUIVALENCE (V1, VALUE, VLIM)  
      SUBROUTINE VALDIS (KEY, V1, V2, KARR, KM, KEND)   
      DIMENSION KARR(KM)
C        Dummy DATA statement to avoid useless compiler warnings
      DATA VINC, VBOT, VTOP, VSUB, VMIN / 0.0, 0.0, 0.0, 0.0, 0.0 / 
      IF (KEY) 100, 110, 140
C        INITIATION 
  100 KEND = 0  
      CALL KERNZI (0, KARR, KM) 
      VMIN = V1 
      VMAX = V2 
      VINC = (V2 - V1) / (KM - 2)   
      VSUB = VMIN - VINC - VINC 
      GOTO 130  
C        COUNT  
  110 KEND = KEND + 1   
      IF (KEND.GT.1) GOTO 120   
      VBOT = V1 
      VTOP = V1 
  120 IF (V1.GT.VTOP) VTOP = V1 
      IF (V1.LT.VBOT) VBOT = V1 
      KAD = IFIX( (V1 - VSUB) / VINC )  
      IF (KAD.LE.0)  KAD = 1
      IF (KAD.GT.KM) KAD = KM   
      KARR(KAD) = KARR(KAD) + 1 
  130 RETURN
C        CONCLUSIONS
  140 IF (VINC.GT.0.) GOTO 150  
      VSUB = VBOT   
      VBOT = VTOP   
      VTOP = VSUB   
C        THE RESULT NOW IS VALID ALSO FOR NEGATIVE INCREMENT
  150 KE = KEND - KEY   
C        IF KE.LT.0 ALL IS O.K. 
      V1 = VBOT 
      IF (KE.LE.0) GOTO 130 
C        KE IS THE NUMBER OF COUNTS .LT. THRESHOLD  
      KSOM = 0  
      DO 160 KAD=1,KM   
      KSOM = KSOM + KARR(KAD)   
      IF (KSOM.GE.KE) GOTO 170  
  160 CONTINUE  
C        INTERPOLATION  
  170 A2 = VMIN + KAD*VINC - VINC   
      A1 = A2 - VINC
      IF (KAD.EQ.1)  A1 = VBOT  
      IF (KAD.EQ.KM) A2 = VTOP  
      V1 = A1 + ((A2-A1) * (KE-KSOM+KARR(KAD))) / KARR(KAD) 
      GOTO 130  
C        END OF SUBROUTINE VALDIS   
      END   
CSUBROUTINE LINPRI (KEY, FITEMS, NIT)   
C-----------------------------------------------------------------------
C Subroutine to print data lines (floating point numbers only)  
C The calling program stores the data to be printed in array 'FITEMS';  
C The subroutine LINPRI will transport the contents of 'FITEMS' 
C    into an internal array 'BUF', and if the correct number of 
C    items are transported, the contents of the array 'BUF' 
C    will be written to the printer given by initiation in KEY: 
C Initiation call with KEY > 0 :
C    KEY          is the file unit used for the printer = IPR   
C    NIT          NITMAX = max. number of items per output line (LE 100)
C    CHOUT        FORMAT to pe brinted, stored in common /SYSTB/
C                 must be given in quotes and parentheses: '(....)' 
C                 F1.0 for numbers >  1.0 gives *, else .   
C                 F2.0 for numbers > 10.0 gives **, else N. 
C    Note: These items are transported for internal use.
C Storage and print call,  KEY = 0: 
C    FITEMS       is the array with the data to be transported to 'BUF' 
C    NIT          is the number of FITEMS send from calling subroutine  
C                 (the number of words cannot exceed 100)   
C    Note: The contents of 'BUF' are printed if, after transportation,  
C          the array 'BUF' would contain more than NITMAX words.
C Final call with KEY < 0:  
C    No transportation will take place. 
C    The contents of 'BUF' are printed. 
C    The initiation setting is not changed. 
C+----------------------------------------------------------------------
      SUBROUTINE LINPRI (KEY, FITEMS, NIT)  
      DIMENSION FITEMS(NIT) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      CHARACTER PRFORM *72  
      PARAMETER (MAXBUF = 100)  
      DIMENSION BUF(MAXBUF) 
C        Dummy DATA statement to avoid useless compiler warnings
      DATA NUMNIT, NITMAX, IPR  / 0, 0, 0 / 
      IF (NIT.GT.MAXBUF .OR. NIT.LE.0) CALL KERROR  
     *    (' Incorrect number of itmes send to LINPRI', 0, 'LINPRI')
      IF (KEY) 240, 220, 200
C        initiation 
  200 IPR = KEY 
      PRFORM = CHOUT
      CHOUT = ' '   
      NITMAX = NIT  
  210 CALL KERNZA (0., BUF, NITMAX) 
      NUMNIT = 0
      RETURN
C        transport,  print if necess.   
  220 IF (NUMNIT+NIT.GT.NITMAX) THEN
          WRITE (IPR, FMT=PRFORM) (BUF(IBUF),IBUF=1,NUMNIT) 
          CALL KERNZA (0., BUF, NITMAX) 
          NUMNIT = 0
      ENDIF 
      DO 230 I=1,NIT
  230 BUF(NUMNIT+I) = FITEMS(I) 
      NUMNIT = NUMNIT + NIT 
      RETURN
C        final call 
  240 IF (NUMNIT.GT.0) WRITE (IPR, FMT=PRFORM) (BUF(IBUF),IBUF=1,NUMNIT)
      GOTO 210  
C        END OF SUBROUTINE LINPRI   
      END   
CSUBROUTINE XHELP (IHELP, IPRX, XLAB)   
C-----------------------------------------------------------------------
C Subroutine for extra HELP information in LIS1 or LIS2 output listing  
C Reading and printing File: DIRDIF.HELP  95: DDHELP
C IHELP = file unit number of the HELP file 
C    At first call this unit will be opened (with NIJX conventions),
C       thereafter the unit number must be the same with each call. 
C       (If file not present: print warning.)   
C    If IHELP = 0 or negative, the file will be closed. 
C       (The subr. XHELP may be recalled at any time,   
C       if so, the unit number may be reassigned at fif st recall.) 
C IPRX = output unit for printing: usually  LIS1 or LIS2
C XLAB = (REAL !) Lable in file DIRDIF.DDHELP which is to be printed.   
C       Note on the DDHELP file format: 
C       Label XLAB is given (in the DDHELP file) with '+' in comlumn 1. 
C       The first word after this label-number must be a literal.   
C       The printing starts at the labeled line and is stopped  
C             if + is encountered on coloumn 1 of the following line.   
C       Convention: labels in file are in the range +1.000 - +999.999   
C             (including + on cc 1) floating point, in increasing order.
C ===>  Search starts after line '$XPRINT' on coloums 1 - 7 .   
C             Column 1:1 = '+' new label : start or stop printing   
C             Column 1:2 = '++' : comment line, skip.   
C+----------------------------------------------------------------------
      SUBROUTINE XHELP (IHELP, IPRX, XLAB)  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      DATA IN, NLAB /0, 1000000/
C        IN = file unit for input/ unless LE 0  
C        IN = 0 at start
C        IN = -1 file closed
C        IN = -2 file does not exist
      IF (IN .EQ. -2) RETURN
C        at initiation time:
      IF (IHELP .LE. 0) THEN
         IF (IN .GT. 0) CALL FILCLO (IN, 'KEEP')
         IN = -1
         RETURN 
         ENDIF  
      XLAB5 = XLAB - 0.0005 
      IF (IN .GT. 0) GO TO 110  
      IF (IN .LE. 0) THEN   
         IN = IHELP 
C95:     test presence of help file    HELP=old-name, DDHELP=new-name   
***      CALL FILINQ (IHELP, 'HELP', 'FORMATTED', 'INPUT', KINQ)
***      IF (KINQ .EQ. 0) GO TO 110 
         CALL FILINQ (IHELP, 'DDHELP', 'FORMATTED', 'INPUT', KINQ)  
         IF (KINQ .EQ. 0) GO TO 110 
         CHOUT = ' File DIRDIF.DDHELP not found'
         CALL SHOUT 
         IN = -2
         RETURN 
         ENDIF  
  110 IF (IN .NE. IHELP) CALL KERNER (-4, 'XHELP')  
      LAB  = NINT (1000. * XLAB)
      IF (LAB .LE. 0 .OR. LAB .GE. 1000000) THEN
         CHOUT = ' Help call range error'   
         CALL SHOUT 
         RETURN 
         ENDIF  
      IF (LAB .GT. NLAB) GOTO 220   
      REWIND IN 
C        Read help lines (KERINA not used to avoid interpretation)  
C        SKIP Preliminaries 
  200 READ (IHELP, 210, END=980, ERR=990) CHIN(1:72)
  210 FORMAT (A72)  
      IF (CHIN(1:7) .NE.'$XPRINT') GOTO 200 
C        found / search for number LAB  
  220 READ (IHELP, 210, END=980, ERR=990) CHIN(1:72)
C          + for number / ++ for comment
      IF (CHIN(1:1) .NE. '+') GOTO 220  
      IF (CHIN(1:2) .EQ. '++') GOTO 220 
      CALL KERINB (LIT, 1)  
C        user array LIT now used as dummy,  here we want to find +N 
C**** IF (NCOLN(1) .NE. 1) GOTO 220 
      IF (XLAB5 .GT. FNUM(1)) GOTO 220  
C        No more GT : must be EQ
      NLAB = NINT (1000. * FNUM(1)) 
      IF (NLAB  .NE. LAB) GOTO 980  
C        Prepare for print / found first coloumn of second word = I 
      I = NCOLL(1) - 1  
      IF (I .LE. 0) I =72   
      CHIN (1:I) = ' '  
      IF (I .LT. 72) I = I + 1  
C        use CHOUT as scratch   
      CHOUT = CHIN(I:72)
      CHIN = CHOUT  
      CHOUT = ' '   
  310 WRITE (IPRX, 312) CHIN (1:72) 
  312 FORMAT (1X, A72)  
C        Read new line  
      READ (IHELP, 210, END=980, ERR=990) CHIN(1:72)
      IF (CHIN(1:1) .NE. '+') GO TO 310 
C        finished   
      BACKSPACE IHELP   
      RETURN
  980 CHOUT = ' Requested label not found on DDHELP file'   
      CALL SHOUT
      RETURN
  990 CALL KERROR ('Error reading DDHELP file', 990, 'XHELP')   
C        END of SUBROUTINE XHELP / END of subfile NIJX2 
      END   
CSUB : third part of the NIJX subroutines   
C Contents: reflection subr.  ISELFD ...
C+----------------------------------------------------------------------
CSUBFUNCTION ISELFD (X, Y, DMAX)
C-----------------------------------------------------------------------
C This function checks if two atomic positions are identical. Atoms 
C have identical atomic positions if the interatomic distance is less   
C than (or equal to) DMAX. Only primitive lattice translations will be  
C considered.   
C List of arguments:
C    X(I)     : Fractional coordinates of first atom (I=1, 2, 3).   
C    Y(I)     : Fractional coordinates of second atom (I=1, 2, 3).  
C    DMAX     : Restriction to the interatomic distance in Angstrom.
C               DMAX should be GE zero but this will not be checked.
C Function values returned: 
C    ISELFD=0 : The interatomic distance is greater than DMAX.  
C    ISELFD=1 : The interatomic distance is less than or equal to DMAX. 
C Author: Erwin J. W. Lam, July 1989 mod. Oct. 1990 
C Based on FUNCTION ISELF by S. GARCIA-GRANDA, 198? 
C Used from COMMON  /CRYSA/ 
C    RCELL(I)   : length of reciprocal-lattice vectors (I=1,2,3)
C    RRMAT(I,J) : direct-space metric tensor = a symmetrical tensor.
C Call: VMATV1  
C+----------------------------------------------------------------------
C List of important local variables:
C    D(I)   : fractional coordinate of the interatomic distance vector  
C             (I=1, 2, 3). Since these coords may be taken modulus 1,   
C             we can reduce them to the interval (-0.5, +0.5).  
C    DM(I)  : max. absolute values of coords. D(I). The set of vectors  
C             with a length DMAX defines a sphere with radius DMAX  
C             around the origin of the direct latice. This sphere is
C             enclosed in a parallelepiped with faces parallel to the   
C             faces of the unit cell. The edges of the parallelepiped   
C             are given by the the fractional coordinates +/- DM(I).
      FUNCTION ISELFD (X, Y, DMAX)  
      DIMENSION X(3), Y(3)  
C     ------ /CRYSA/ Storage of important crystal data. 
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     *               WAVE,     CELALL(10),  AMOLW,      ZET,
     *               NELEC,    F000,        ABSMU,      ICENT,  
     *               ILATT,    ISYST,       ILAUE,      IMULT,  
     *               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     *         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     *         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION DM(3), D(3) 
      DATA DMOLD /-999.0/   
C        Dummy DATA statement to avoid useless compiler warnings
      DATA DMAXSQ / 0.0 /   
C Calculate the absolute value DM(I) of the fractional coordinates of   
C the intersections of the I-th direct-lattice axis with the planes of  
C the parallelepiped. This is done each time DMAX changes.  
      IF (DMOLD .NE. DMAX) THEN 
         DO 100 I=1, 3  
  100    DM(I) = DMAX * RCELL(I)
         DMOLD = DMAX   
         DMAXSQ = DMAX * DMAX   
         ENDIF  
C Reduce the fractional coordinates D(I) of the interatomic-distance
C vector to the interval (-0.5, +0.5) by substracting the nearest   
C whole number. Then, check if the interatomic-distance vector is   
C outside the parallelepiped in which case ISELFD=0.
      ISELFD=0  
      DO 120 I=1, 3 
      D(I) = X(I) - Y(I) - ANINT (X(I)-Y(I))
      IF (ABS (D(I)).GT.DM(I)) RETURN   
  120 CONTINUE  
C If the reduced interatomic-distance vector is inside the  
C parallelepiped we calculate the exact distance by using the   
C direct-space metric tensor.   
      CALL VMATV1 (D, RRMAT, D, DIST2)  
      IF (DIST2 .LE. DMAXSQ) ISELFD = 1 
      RETURN
C        END OF FUNCTION ISELFD 
      END   
CSUBROUTINE DISTSQ (X, Y, DMAX, Z, DIST2)   
C-----------------------------------------------------------------------
C This subroutine checks if two atomic positions are close, and,
C if not: DIST2 is set to a large value (9999.9),   
C else:   DIST2 (= square of interatomic distance) is calculated.   
C         Only primitive lattice translations are considered.   
C List of arguments:
C Input : X(I)  = Fractional coordinates of first atom (I=1, 2, 3). 
C         Y(I)  = Fractional coordinates of second atom (I=1, 2, 3).
C         DMAX  = Restriction to the interatomic distance in Angstrom.  
C                 DMAX should be GE zero, but this will not be checked. 
C Output: Z(I)  = Y(I) - X(I) (MOD 1) i.e., -0.5 <= Z(I) <= 0.5 
C         DIST2 = The square of the interatomic distance, however,  
C                 in case the vector Z(I) is ouside the parallelepiped  
C                 (see write-up ISELFD) then:   
C                 DIST2 = 9999.9 and Z(I) is undefined. 
C Note:   So if DIST2 <= DMAX**2 then position of Y(I) nearest to X(I)  
C (considering only primitive translations) is: Ynew(I) = X(I) + Z(I).  
C For technical details, see write-up of ISELFD 
C                                           Erwin J. W. Lam, 16-10-1990 
C Call: VMATV1  
C+----------------------------------------------------------------------
      SUBROUTINE DISTSQ (X, Y, DMAX, Z, DIST2)  
      DIMENSION X(3), Y(3), Z(3)
C     ------ /CRYSA/ Storage of important crystal data. 
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     *               WAVE,     CELALL(10),  AMOLW,      ZET,
     *               NELEC,    F000,        ABSMU,      ICENT,  
     *               ILATT,    ISYST,       ILAUE,      IMULT,  
     *               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     *         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     *         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION DM(3)   
      DATA DMOLD /-9999.9/  
      IF (DMOLD .NE. DMAX) THEN 
         DO 100 I=1, 3  
  100    DM(I) = DMAX * RCELL(I)
         DMAXSQ = DMAX * DMAX   
         DMOLD=DMAX 
         ENDIF  
      DIST2 = 9999.9
      DO 120 I=1, 3 
      Z(I) = Y(I) - X(I) - ANINT (Y(I)-X(I))
      IF (ABS (Z(I)) .GT. DM(I)) RETURN 
  120 CONTINUE  
      CALL VMATV1 (Z, RRMAT, Z, DIST2)  
      RETURN
C        END OF SUBROUTINE DISTSQ   
      END   
CSUBROUTINE SYMOP1 (IS, X, XS)  
C-----------------------------------------------------------------------
C Apply IS-th symm.operation to X(3) / put result in XS(3)  
C i.e.  XS = IRSYMM * X + TSYMM 
C+----------------------------------------------------------------------
      SUBROUTINE SYMOP1 (IS, X, XS) 
      DIMENSION X(3), XS(3) 
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     *               WAVE,     CELALL(10),  AMOLW,      ZET,
     *               NELEC,    F000,        ABSMU,      ICENT,  
     *               ILATT,    ISYST,       ILAUE,      IMULT,  
     *               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     *         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     *         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION RSYMM(3,3,24)   
      LOGICAL CONT  
      DATA CONT / .FALSE. / 
      IF (CONT) GOTO 200
      CONT = .TRUE. 
      CALL KERI2F (IRSYMM, RSYMM, 9 * NSYMM)
  200 IF (IS .EQ. 1) THEN   
         CALL KERNAB (X, XS, 3) 
      ELSE  
         CALL MATXV3 (RSYMM(1,1,IS), X, XS) 
         XS(1) = XS(1) + TSYMM(1,IS)
         XS(2) = XS(2) + TSYMM(2,IS)
         XS(3) = XS(3) + TSYMM(3,IS)
         ENDIF  
C        END OF SUBROUTINE SYMOP1   
      END   
CSUBROUTINE SYMOP2 (IC, IL, XS, XST)
C-----------------------------------------------------------------------
C Apply IC (1 nonc., 2 centrosymm.) and IL (Lattice transl., 1 for P)   
C to XS(3)  and put result in XST(3)
C+----------------------------------------------------------------------
      SUBROUTINE SYMOP2 (IC, IL, XS, XST)   
      DIMENSION XS(3), XST(3)   
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     *               WAVE,     CELALL(10),  AMOLW,      ZET,
     *               NELEC,    F000,        ABSMU,      ICENT,  
     *               ILATT,    ISYST,       ILAUE,      IMULT,  
     *               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     *         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     *         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      IF (IC .EQ. 1) THEN   
         XST(1) = TLATT(1,IL) + XS(1)   
         XST(2) = TLATT(2,IL) + XS(2)   
         XST(3) = TLATT(3,IL) + XS(3)   
      ELSE  
         XST(1) = TLATT(1,IL) - XS(1)   
         XST(2) = TLATT(2,IL) - XS(2)   
         XST(3) = TLATT(3,IL) - XS(3)   
         ENDIF  
C        END OF SUBROUTINE SYMOP2   
      END   
CSUBFUNCTION ISELFX (X, Y, DMAX)
C-----------------------------------------------------------------------
CJMS 27-11-91   If, and only if, the function value ISELFX=1 is to be   
C               returned, Y is replaced by its translation-symmetry 
C               related position which is nearest to X. 
C This subr. is used only by LOCKIN 
C This function checks if two atomic positions are identical. Atoms 
C have identical atomic positions if the interatomic distance is less   
C than (or equal to) DMAX. Only primitive lattice translations will be  
C considered.   
C List of arguments:
C    X(I)     : Fractional coordinates of first atom (I=1, 2, 3).   
C    Y(I)     : Fractional coordinates of second atom (I=1, 2, 3).  
C    DMAX     : Restriction to the interatomic distance in Angstrom.
C               DMAX should be GE zero but this will not be checked.
C Function values returned: 
C    ISELFX=0 : The interatomic distance is greater than DMAX.  
C    ISELFX=1 : The interatomic distance is less than or equal to DMAX. 
C               In this case only Y is replaced by its translation- 
C               symmetry related position which is nearest to X 
C Author: Erwin J. W. Lam, July 1989 mod. Oct. 1990 
C Based on FUNCTION ISELF by S. GARCIA-GRANDA, 198? 
C Used from COMMON  /CRYSA/ 
C    RCELL(I)   : length of reciprocal-lattice vectors (I=1,2,3)
C    RRMAT(I,J) : direct-space metric tensor = a symmetrical tensor.
C Call: VMATV1  
C+----------------------------------------------------------------------
C List of important local variables:
C    D(I)   : fractional coordinate of the interatomic distance vector  
C             (I=1, 2, 3). Since these coords may be taken modulus 1,   
C             we can reduce them to the interval (-0.5, +0.5).  
C    DM(I)  : max. absolute values of coords. D(I). The set of vectors  
C             with a length DMAX defines a sphere with radius DMAX  
C             around the origin of the direct latice. This sphere is
C             enclosed in a parallelepiped with faces parallel to the   
C             faces of the unit cell. The edges of the parallelepiped   
C             are given by the the fractional coordinates +/- DM(I).
      FUNCTION ISELFX (X, Y, DMAX)  
      DIMENSION X(3), Y(3)  
C     ------ /CRYSA/ Storage of important crystal data. 
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     *               WAVE,     CELALL(10),  AMOLW,      ZET,
     *               NELEC,    F000,        ABSMU,      ICENT,  
     *               ILATT,    ISYST,       ILAUE,      IMULT,  
     *               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     *         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     *         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION DM(3), D(3) 
      DATA DMOLD /-999.0/   
C        Dummy DATA statement to avoid useless compiler warnings
      DATA DMAXSQ / 0.0 /   
C Calculate the absolute value DM(I) of the fractional coordinates of   
C the intersections of the I-th direct-lattice axis with the planes of  
C the parallelepiped. This is done each time DMAX changes.  
      IF (DMOLD .NE. DMAX) THEN 
         DO 100 I=1, 3  
  100    DM(I) = DMAX * RCELL(I)
         DMOLD = DMAX   
         DMAXSQ = DMAX * DMAX   
         ENDIF  
C Reduce the fractional coordinates D(I) of the interatomic-distance
C vector to the interval (-0.5, +0.5) by substracting the nearest   
C whole number. Then, check if the interatomic-distance vector is   
C outside the parallelepiped in which case ISELFX=0.
      ISELFX=0  
      DO 120 I=1, 3 
      D(I) = X(I) - Y(I) - ANINT (X(I)-Y(I))
      IF (ABS (D(I)).GT.DM(I)) RETURN   
  120 CONTINUE  
C If the reduced interatomic-distance vector is inside the  
C parallelepiped we calculate the exact distance by using the   
C direct-space metric tensor.   
      CALL VMATV1 (D, RRMAT, D, DISTSQ) 
      IF (DISTSQ .LE. DMAXSQ) THEN  
         DO 130 I = 1,3 
  130    Y(I) = Y(I) + ANINT( X(I)-Y(I) )   
         ISELFX = 1 
         ENDIF  
      RETURN
C        END OF FUNCTION ISELFX 
      END   
CSUBROUTINE LOCKIN (ATIN, DMAX, ATOUT, DIST, NPOS)  
C-----------------------------------------------------------------------
C Lockin self-superimposing atomic position on nearby symmetry element  
C ATIN(3):  Atomic position to be tested
C DMAX:     Limit (passed to ISELFX) for two positions to be
C           considered self-superimposing;  
C ATOUT(3): Array of locked-in x,y,z-parameters, equals ATIN for a  
C           general position;   
C DIST:     Distance from original position to locked-in position,  
C           = 0.0 for a general position;   
C NPOS:     Number of symmetry-related positions that are averaged  
C           to get the locked-in postion = multiplicity of the point
C           group symmetry of the locked-in position;   
C           NPOS = 1 for a general position. Maximum NPOS is 48.
C Calls: ISELFX 
C (LOCKIN is the only subr. using ISELFX)   
C                                                J.M.M. Smits, 26-11-91 
C+----------------------------------------------------------------------
      SUBROUTINE LOCKIN (ATIN, DMAX, ATOUT, DIST, NPOS) 
      DIMENSION ATIN(3), ATOUT(3), D(3) 
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION  XYZ(3), XYZC(3), TPOS(3,48)
      LOGICAL CENTRO, AGAIN 
      DATA CENTRO / .FALSE. /   
      DATA DELTA  / 0.0001  /   
      AGAIN = .FALSE.   
      IF ( ICENT .EQ. 2 ) CENTRO = .TRUE.   
      CALL KERNZA ( 0.0, ATOUT, 3 ) 
C        Put in ATIN as the first hit; symmetry element x,y,z will  
C        always produce a hit which is present already. 
      CALL KERNAB (ATIN, TPOS, 3)   
      NPOS = 1  
      NADD = 0  
C        For all NPOS possible positions TPOS(), check the distance to  
C        all symmetry related positions; add hits that weren't found
C        before. Stop if no new hits are found. 
  120 DO 200 I = 1,NPOS 
CJMS 7-1-92 Add DO-loop JT = 1,NLATT to include lattice centering   
C           vectors: XYZ = TSYMM + TLATT + TPOS*IRSYMM  
C Example:  Space group     B m         =           B n 
C                        x,  y, z                x,  y, z   
C                        x, -y, z            0.5+x, -y, 0.5+z   
C                   -----------------------------------------   
C                    0.5+x,  y, 0.5+z        0.5+x,  y, 0.5+z   
C                    0.5+x, -y, 0.5+z            x, -y, z   
      DO 190 JT = 1,NLATT   
      DO 190 J  = 1,NSYMM   
      IF ( CENTRO ) AGAIN = .TRUE.  
      DO 130 K = 1,3
      XYZ(K) = TSYMM(K,J) + TLATT(K,JT) +   
     *   TPOS(1,I) * IRSYMM(K,1,J) +
     *   TPOS(2,I) * IRSYMM(K,2,J) +
     *   TPOS(3,I) * IRSYMM(K,3,J)  
  130 XYZC(K) = -XYZ(K) 
  140 IF ( ISELFX (ATIN, XYZ, DMAX) .EQ. 1 ) THEN   
C            Test hit against all positions found so far, including 
C            the new ones found in this cycle.  
         DO 150 L = 1,NPOS+NADD 
         IF ( ( ABS(XYZ(1)-TPOS(1,L)) .LT. DELTA ) .AND.
     *      ( ABS(XYZ(2)-TPOS(2,L)) .LT. DELTA ) .AND.  
     *      ( ABS(XYZ(3)-TPOS(3,L)) .LT. DELTA ) ) GOTO 170 
  150    CONTINUE   
C           Add a new position to the set of symmetry related   
C           positions which are close to the starting position. 
         NADD = NADD + 1
         IF ( NPOS+NADD .GT. 48 ) CALL KERROR   
     *      ('Program symm. error?', 150, 'LOCKIN') 
         DO 160 K = 1,3 
  160    TPOS(K,NPOS+NADD) = XYZ(K) 
         ENDIF  
C        Repeat, if necessary, for a center of symmetry 
  170 IF ( .NOT. CENTRO )  GOTO 190 
      IF ( AGAIN ) THEN 
         DO 180 K = 1,3 
  180    XYZ(K) = XYZC(K)   
         AGAIN = .FALSE.
         GOTO 140   
         ENDIF  
  190 CONTINUE  
  200 CONTINUE  
C        Stop if no new hits were found (NADD .EQ. 0)   
      IF ( NADD .EQ. 0 ) GOTO 220   
      NPOS = NPOS + NADD
      NADD = 0  
      GOTO 120  
C        Finish up  
  220 DIST = 0.0
      FNPOS = FLOAT(NPOS)   
      DO 240 I = 1,3
      DO 230 K = 1,NPOS 
  230 ATOUT(I) = ATOUT(I) + TPOS(I,K)   
  240 ATOUT(I) = ATOUT(I) / FNPOS   
      IF ( NPOS .LE. 1 ) GOTO 260   
      DO 250 I = 1,3
  250 D(I) = ATIN(I) - ATOUT(I) 
      CALL VMATV1( D, RRMAT, D, DIST )  
      DIST = SQRT( DIST )   
  260 RETURN
C        END OF SUBROUTINE LOCKIN   
      END   
CSUBROUTINE HKLSTL (HKL, STL, STL2) 
C-----------------------------------------------------------------------
C Calculates SIN(TH)/LAMBDA 
C Input  : HKL: REFL. INDICES   
C Output : STL: SIN(TH)/LAMBDA  
C        : STL2: (SIN(TH)/LAMBDA)**2
C+----------------------------------------------------------------------
      SUBROUTINE HKLSTL (HKL, STL, STL2)
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION HKL(3)  
      STL2 = 0.0
      DO 100 I =1,3 
      DO 100 J =1,3 
  100 STL2 = STL2 + HKL(I) * SSMAT(I,J) * HKL(J)
      STL2 = STL2 / 4.0 
      STL = SQRT(STL2)  
      RETURN
C        END OF SUBROUTINE HKLSTL   
      END   
CSUBROUTINE HKLEXS (SWITCH, HKL, HCODE) 
C-----------------------------------------------------------------------
C HKL-EXPAND to find standard indices   
C Input :  SWITCH: = .TRUE. if centrosymmetric  
C                     or FRIEDEL to be applied  
C          HKL(3)  = Input indices  
C Output:  HCODE   = HKL CODE based on 256  
C General: HKLEX+ are various subroutines involving 
C          EXpansion of HKL data:   
C?HKLEXM = EXPAND REFL. Data to find multiplicity and EPSILON   
C?HKLEXP = EXPAND REFL. Data to symmetry P1, remove identical   
C          reflections (incl. FRIEDEL); 
C          if (FCALC) modify phase. 
C HKLEXS = EXpand refl. data to find Standard indices (HCODE)   
C HKLEXT = EXpand refl. data to find space group EXTinctions.   
C HKLEX1 = EXpand refl. data , no further action.   
C HKLEX2 = identify EXpanded refl. data 
C HKLEX3 = find phase shift for EXpanded refl. data 
C+----------------------------------------------------------------------
      SUBROUTINE HKLEXS (SWITCH, HKL, HCODE)
      LOGICAL SWITCH
      DIMENSION HKL(3)  
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION RSYMM(3,3,24), HHH(3)   
      LOGICAL IRSW  
      DATA IRSW / .FALSE. / 
      IF (IRSW) GOTO 110
      IRSW = .TRUE. 
C        PREPARE FLOATING SYMMETRY RELATIONS
      CALL KERI2F (IRSYMM, RSYMM, 9*NSYMM)  
  110 DO 200 J = 1,NSYMM
C        APPLY SYMMETRY TO HKL (INTERCHANGE ROW AND COLOMNS)
C EG. symm: h.new = h.old x RR(1,1) + k.old x RR(2,1) + l.old x RR(3,1) 
      DO 120 K = 1,3
      HHH(K) = HKL(1) * RSYMM(1,K,J)
     *       + HKL(2) * RSYMM(2,K,J)
     *       + HKL(3) * RSYMM(3,K,J)
  120 CONTINUE  
      CALL HKLC1 (HHH, HC)  
      IF (SWITCH) HC = ABS(HC)  
      IF (J.EQ.1) HCODE = HC
      HCODE = AMAX1 (HC, HCODE) 
  200 CONTINUE  
      RETURN
C        END OF SUBR HKLEXS 
      END   
CSUBROUTINE HKLEXT (HKL, KEND)  
C-----------------------------------------------------------------------
C HKL-EXPAND to find systematic EXTINCT recfl.  
C Input:  HKL(3)  = Input indices   
C Output: KEND    =0 TRUE / =-1 EXTINCT by symmetry 
C+----------------------------------------------------------------------
C LOCAL VARIABLES: RSYMM FOR SYMM. WITHOUT TRANSLATIONS 
C                  TT    FOR TRANSLATIONAL PART 
C                  IRSW  FOR FIRST ENTRY
C                  SKIP  TO BYPASS THIS ROUTINE 
      SUBROUTINE HKLEXT (HKL, KEND) 
      DIMENSION HKL(3)  
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION KSYMM(3,3,24), TT(3,24), III(3), KKK(3) 
      LOGICAL IRSW, SKIP
      DATA IRSW , SKIP / .FALSE. , .FALSE. /
C        Dummy DATA statement to avoid useless compiler warnings
      DATA NST / 0 /
      IF (SKIP) GOTO 102
      IF (IRSW) GOTO 110
C        CHECK NSYMM
      IF (NSYMM.GT.1) GOTO 103  
  101 SKIP = .TRUE. 
  102 KEND = 0  
      RETURN
  103 IRSW = .TRUE. 
C        PREPARE TABLE WITH INTEGER SYMMETRY RELATIONS  
C        ONLY WITH TRANSLATIONS 
      NST = 0   
      DO 104 J = 2,NSYMM
      IF (ABS(TSYMM(1,J)) .LT. 0.01 .AND.   
     *    ABS(TSYMM(2,J)) .LT. 0.01 .AND.   
     *    ABS(TSYMM(3,J)) .LT. 0.01) GOTO 104   
      NST = NST + 1 
      CALL KERNAI (IRSYMM(1,1,J), KSYMM(1,1,NST), 9)
      CALL KERNAB (TSYMM(1,J), TT(1,NST), 3)
  104 CONTINUE  
      IF (NST.EQ.0) GOTO 101
C        NOW CHECK REFLECTION   
  110 CALL KERF2I (HKL, III, 3) 
      DO 200 J = 1,NST  
      TEST = 0. 
C        APPLY SYMMETRY TO HKL  
      DO 120 K = 1,3
      KKK(K) = III(1) * KSYMM(1,K,J)
     *       + III(2) * KSYMM(2,K,J)
     *       + III(3) * KSYMM(3,K,J)
  120 CONTINUE  
C        COMPARE INDEX: IF NOT IDENTICAL: GO
      IF (III(1).EQ.KKK(1) .AND. III(2).EQ.KKK(2) .AND. 
     *    III(3).EQ.KKK(3) ) GOTO 130   
      IF (ICENT.EQ.1) GOTO 200  
      IF (III(1).NE.-KKK(1) .OR. III(2).NE.-KKK(2) .OR. 
     *    III(3).NE.-KKK(3) ) GOTO 200  
  130 TEST = TT(1,J) * HKL(1) + TT(2,J) * HKL(2) + TT(3,J) * HKL(3) 
      IF (AMOD (ABS(TEST)+0.01, 1.0) .LT. 0.02) GOTO 200
C        SYST. EXT. REFL.   
      KEND = -1 
      RETURN
  200 CONTINUE  
      KEND = 0  
      RETURN
C        END OF SUBR HKLEXT 
      END   
CSUBROUTINE HKLEX1 (HKL, HKLX)  
C-----------------------------------------------------------------------
C HKL-EXPAND into array HKLX (no further action)
C Input:  HKL(3)  =Input indices
C Output: HKLX(3,24) for expanded reflexion indices 
C            (HKL(i) = HKLX(i,3) is allowed)
C General: HKLEX+ are various subroutines involving 
C          See subr. HKLEXS 
C+----------------------------------------------------------------------
      SUBROUTINE HKLEX1 (HKL, HKLX) 
      DIMENSION HKL(3), HKLX(3,24)  
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION RSYMM(3,3,24)   
      LOGICAL IRSW  
      DATA IRSW / .FALSE. / 
      IF (IRSW) GOTO 110
      IRSW = .TRUE. 
C        PREPARE FLOATING SYMMETRY RELATIONS
      CALL KERI2F (IRSYMM, RSYMM, 9*NSYMM)  
  110 CALL KERNAB (HKL, HKLX, 3)
      IF (NSYMM.EQ.1) RETURN
      DO 120 J = 2,NSYMM
C        APPLY SYMMETRY TO HKL (INTERCHANGE ROW AND COLOMNS)
      DO 120 K = 1,3
  120 HKLX(K,J) = HKL(1) * RSYMM(1,K,J) 
     *          + HKL(2) * RSYMM(2,K,J) 
     *          + HKL(3) * RSYMM(3,K,J) 
      RETURN
C        END OF SUBR HKLEX1 
      END   
CSUBROUTINE HKLEX2 (HKL, IDHKL, IEPS, IEPS2)
C-----------------------------------------------------------------------
C Fill IDHKL with 0 (new) OR K (identical)  or -K (Friedel) 
C      where K = address of original HKL = no. of symm.relation 
C Use: LAUE independet refl.: skip HKL( ,I)  if: IDHKL(I) .NE. 0
C See: FCALC2 (EPSIL2 = IEPS2, needed for BINFC2) and   
C      WILSIN and DIFOUR (EPSIL = IEPS = true epsilon)  
C      TRACOR needs IEPS and IEPS2 (=EPSIL2)
C Input : HKL(3,24) = INPUT INDICES, expanded by symmetry (NSYMM)   
C Output: IDHKL(24) to signal new (0) or identical (+) or Friedel (-)   
C         IEPS = EPSILON = NSYMM / (NSYMM - Number of times that an 
C                identical reflection is generated by symmetry REL.)
C         IEPS2= EPSILON including FRIEDELS. (IEPS = IEPS2 in case the  
C                 structure is centrosymmetric) 
C Examples: Space group    Space group    Space group    Space group
C               P2             Pm             P2/m           P222   
C            -----------    -----------    -----------    -----------   
C Reflect.   h0l  |  0k0    h0l  |  0k0    h0l  |  0k0    h0l  |  0k0   
C IEPS        1       2      2       1      2       2      1       2
C IEPS2       2       2      2       2      2       2      2       4
C NOTE: - Prior to this, HKLEX1 is to be called, to fill array HKL  
C       - if (NSYMM.EQ.1) there is no expansion ... 
C General: HKLEX+ are various subroutines involving EXPANSION   
C          SEE SUBR. HKLEXS 
C+----------------------------------------------------------------------
      SUBROUTINE HKLEX2 (HKL, IDHKL, IEPS, IEPS2)   
      DIMENSION HKL(3,24), IDHKL(24)
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      IDHKL(1) = 0  
      IF (NSYMM.EQ.1) THEN  
         IEPS  = 1  
         IEPS2 = 1  
         RETURN 
         ENDIF  
      IEPS  = 0 
      IEPS2 = 0 
      DO 300 J=2,NSYMM  
      IDHKL(J) = 0  
      DO 180 K=1,J-1
      IF (ABS(HKL(1,K)-HKL(1,J)) .GT. 0.1) GOTO 180 
      IF (ABS(HKL(2,K)-HKL(2,J)) .GT. 0.1) GOTO 180 
      IF (ABS(HKL(3,K)-HKL(3,J)) .GT. 0.1) GOTO 180 
C        IDENTICAL  
      IDHKL(J) = K  
      IEPS = IEPS + 1   
      GOTO 300  
  180 CONTINUE  
      DO 200 K=1,J-1
C       check FRIEDEL   
      IF (ABS(HKL(1,K)+HKL(1,J)) .GT. 0.1) GOTO 200 
      IF (ABS(HKL(2,K)+HKL(2,J)) .GT. 0.1) GOTO 200 
      IF (ABS(HKL(3,K)+HKL(3,J)) .GT. 0.1) GOTO 200 
C        FRIEDEL
      IDHKL(J) = - K
      IEPS2 = IEPS2 + 1 
      GOTO 300  
  200 CONTINUE  
  300 CONTINUE  
      IEPS2 = NSYMM / (NSYMM - IEPS - IEPS2)
      IF (ICENT .EQ. 1) THEN
         IEPS  = NSYMM / (NSYMM - IEPS) 
      ELSE  
         IEPS = IEPS2   
         ENDIF  
      RETURN
C        END OF SUBR HKLEX2 
      END   
CSUBROUTINE HKLEX3 (HKL, IDHKL, PSHIFT) 
C-----------------------------------------------------------------------
C Fill PSHIFT with phase shift  
C Input : HKL(3) = input indices
C         IDHKL(24) = ID for expanded refl., generated by HKLEX2 .  
C     Use IDHKL (I) to find new (0), identical (K) or Friedel (-K) refl.
C     shift for identical or Friedel refl. is filled up with shift of   
C     original refl (K < I).
C Output: PSHIFT(24) with phase shifts (in degrees) 
C Note: Before calling this subroutine, HKLEX1 and HKLEX2 must have been
C       called. 
C General: HKLEX+ are various subroutines involving EXPANSION   
C          see subr. HKLEXS 
C   
C+----------------------------------------------------------------------
      SUBROUTINE HKLEX3 (HKL, IDHKL, PSHIFT)
      DIMENSION HKL(3), IDHKL(24), PSHIFT(24)   
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     *               WAVE,     CELALL(10),  AMOLW,      ZET,
     *               NELEC,    F000,        ABSMU,      ICENT,  
     *               ILATT,    ISYST,       ILAUE,      IMULT,  
     *               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     *         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     *         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
CSold      DIMENSION PCODSH(13) 
CSold      DATA PCODSH / 0., 0., 60., 90., 120., 0., 180., 0., 240.,
CSold     *              270., 300., 0., 0 /
      CALL KERNZA (0., PSHIFT, NSYMM)   
      IF (NSYMM .EQ. 1) RETURN  
      DO 220 I=1,NSYMM  
      IF (IDHKL(I) .NE. 0) GOTO 210 
      XTEST = 0.0   
      DO 200 J=1,3  
  200 XTEST  = XTEST - HKL(J) * TSYMM(J,I)  
      XTEST  = AMOD(XTEST,1.0)  
      IF (XTEST .LT. -0.01) XTEST = XTEST + 1.  
      PSHIFT(I) = XTEST * 360.  
      GOTO 220  
C        shift for identical or Friedel refl. is filled up with shift of
C        original refl. 
  210 ITEST = IABS(IDHKL(I))
      PSHIFT(I) = PSHIFT(ITEST) 
  220 CONTINUE  
      RETURN
C        END OF SUBROUTINE HKLEX3   
      END   
CSUBROUTINE HKLAXT (HKL, KEND)  
C-----------------------------------------------------------------------
C HKL- LATTICE EXTICTIONS   
C Input:  HKL(3) = Input indices
C Output: KEND   = 0 TRUE / =-1 EXTINCT by LATTICE TRANSLAT.
C+----------------------------------------------------------------------
      SUBROUTINE HKLAXT (HKL, KEND) 
      DIMENSION HKL(3)  
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION IH(3)   
C        CONVERT TO INTEGER 
      CALL KERF2I (HKL, IH, 3)  
C        CHECK LATTICE EXT. 
      GOTO (200, 2, 3, 4, 5, 6, 7), ILATT   
C             P  A  B  C  I  F  R(HEXA) 
  2   I = IH(2) + IH(3) 
      GOTO 100  
  3   I = IH(1) + IH(3) 
      GOTO 100  
  4   I = IH(1) + IH(2) 
      GOTO 100  
  5   I = IH(1) + IH(2) + IH(3) 
  100 IF (MOD(I,2) .EQ. 0) GOTO 200 
      GOTO 150  
  6   IF (MOD (IH(1)+IH(2),2) .EQ. 0 .AND.  
     *    MOD (IH(1)+IH(3),2) .EQ. 0) GOTO 200  
      GOTO 150  
  7   IF (MOD (-IH(1)+IH(2)+IH(3),3) .EQ. 0) GOTO 200   
C        EXTINCTION 
CBOS     ER WORDEN ER MAAR VIJF UITGEPRINT  
CBOS     IS DIT VOLDOENDE ?    PTB: JA,  MAAR DAN IN CALLING ROUTINE
  150 KEND = -1 
      RETURN
  200 CONTINUE  
      KEND = 0  
      RETURN
C        END OF SUBR HKLAXT 
      END   
CSUBROUTINE HKLC1 (HKL, HCODE)  
C-----------------------------------------------------------------------
C General comments on HKLCi coding and uncoding routines         Oct. 96
C i=1 : the simplest coding form, as used on a standard 
C       BINFO file. It is based on 100. Denoted: HCODE  
C       old:        It is based on 256.              Error for HP ??
C       corrected Oct. 96: largest absulute value of h, k and l is: 99  
C*    * Note: in case reflection indices may excede these maxima, then  
C*    * all calls to HKLC1 and HKLC1U should be preceded by one call to 
C*    * HKLC2I, and then replaced by HKLC2 and HKLC2U, respectively,
C*    * where the user may provide minimum and maximum values for h,k,l.
C i=2 : the compact coding form, as used for adressing and  
C       sorting etc. It is based on HKLMAX. Denoted: ACODE  
C i=3 : the more compact coding form, taking lattice
C       centering into account. See PHASEX adressing table. 
C SUBROUTINE  for coding:         HKLCi    i=1,2,3  
C ENTRY       for uncoding:       HKLCiU   i=1,2,3  
C ENTRY       for initiation      HKLCiI   i=  2,3  
C CALL   HKLC1  (HKL, HCODE)
C        HKLC2  (HKL, ACODE)
C        HKLC1U (HCODE, HKL)
C        HKLC2U (ACODE, HKL)
C        HKLC2I (HMIN, HMAX)
C - all calculations are in FLOATING point  
C - the program MERBIN prepares the primary BINFO file which
C   contains reflections in increasing order of HCODE   
C - MERBIN usumes LAUE-symmetry (FRIEDEL applicable) but the
C   coding routines are also valid for non-centrosymm. data.
C - the program NUTS/BIJVOET prepares a similar tempry BINFO file.  
C - the decoding of HCODE occurs in many programs.  
C=======================================================================
C This subroutine:   SUBROUTINE HKLC1    with: ENTRY HKL1U  
C-----------------------------------------------------------------------
C The simple coding form, as used on a standard BINFO file  
C Corrected Oct. 96:          largest absulute value of h k l is 99   !!
C                             old base max=256: Compiler Error for HP ??
C CALL  HKLC1  (HKL, HCODE)   for coding       input HKL    output HCODE
C CALL  HKLC1U (HCODE, HKL)   for uncoding     input HCODE  output HKL  
C                             Input/output  HKL(3) = refl. indices h k l
C                             Output/input  HCODE  = reflection code
C+----------------------------------------------------------------------
      SUBROUTINE HKLC1 (HKL, HCODE) 
      DIMENSION HKL(3), HKL1(3) 
Corr     PARAMETERS FOR HMIN=-255, HMAX=256 :   
Corr  PARAMETER (ADD   = -255.,  SPANL = 512.,  SPANKL = 512. * 512.,   
Corr *                           LSPAN = 512 ,  KLSPAN = 512  * 512,
Corr *          IDDHKL =  255 * (KLSPAN + LSPAN + 1) )  
Cnew:    PARAMETERS FOR HMIN=-99, HMAX=100 (test validity on HMAX=99)   
      PARAMETER (ADD   = -99.,  SPANL = 200., SPANKL = 200. * 200., 
     *                          LSPAN = 200 , KLSPAN = 200  * 200,  
     *          IDDHKL =  99 * (KLSPAN + LSPAN + 1) )   
Ctest!   Note: if k, k or l are outside the limits (-99 ... 100)
C        then the HCODE is undecodable. 
C        We assume now that this test is performed in the primary input 
C        procedure, i.e. programs  MERBIN  and   NUTS/BIJVOET   
      HCODE = HKL(1) * SPANKL + HKL(2) * SPANL + HKL(3) 
C error IF largest HCODE > 99 * ( 40000+200+1 ) : test > 4 00 00 00 ??  
      RETURN
      ENTRY HKLC1U (HCODE1, HKL1)   
      KCODE  =  NINT (HCODE1) + IDDHKL  
      I = KCODE / KLSPAN
      HKL1(1) = FLOAT (I) + ADD 
      M = MOD(KCODE,KLSPAN) 
      I = M / LSPAN 
      HKL1(2) = FLOAT (I) + ADD 
      M = MOD(KCODE, LSPAN) 
      HKL1(3) = FLOAT (M) + ADD 
      RETURN
C        END OF SUBR. HKLC1 (+ ENTRY: HKLC1U)   
      END   
CSUBROUTINE HKLC2 (HKL, ACODE)  
C-----------------------------------------------------------------------
C SUBROUTINR HKLC2  (HKL, ACODE) for coding 
C ENTRY      HKLC2U (ACODE, HKL) for uncoding   
C ENTRY      HKLC2I (HMIN, HMAX) for initiation 
C Input  |   HKL(3)   refl. indices 
C or     |   HMIN(3), HMAX(3) for initiation (actual values)
C Output |   ACODE    reflection code   
C+----------------------------------------------------------------------
      SUBROUTINE HKLC2 (HKL, ACODE) 
      DIMENSION HKL(3), HKL1(3), HMIN(3), HMAX(3)   
      DIMENSION ADD(3)  
C        Dummy DATA statement to avoid useless compiler warnings
      DATA SPANL, SPANKL, LSPAN, KLSPAN, IDDHKL  / 0.0, 0.0, 0, 0, 0 /  
      ACODE = HKL(1) * SPANKL + HKL(2) * SPANL + HKL(3) 
      RETURN
      ENTRY HKLC2U (ACODE1, HKL1)   
      KCODE   = IFIX  (ACODE1) + IDDHKL 
      HKL1(1) = FLOAT (     KCODE         /KLSPAN) + ADD(1) 
      HKL1(2) = FLOAT ( MOD(KCODE,KLSPAN) / LSPAN) + ADD(2) 
      HKL1(3) = FLOAT ( MOD(KCODE, LSPAN)        ) + ADD(3) 
      RETURN
      ENTRY HKLC2I (HMIN, HMAX) 
      CALL KERNAB (HMIN, ADD, 3)
      SPANL  = HMAX(3) - HMIN(3) + 1.   
      SPANKL = SPANL * (HMAX(2) - HMIN(2) + 1.) 
      LSPAN  = IFIX (SPANL  + 0.1)  
      KLSPAN = IFIX (SPANKL + 0.1)  
      ADDHKL = - HMIN(1) * SPANKL   
     *         - HMIN(2) * SPANL - HMIN(3)  
      IDDHKL = NINT (ADDHKL)
      RETURN
C        END OF SUBR. HKLC2 (+ ENTRY: HKLC2U, HKLC2I)   
      END   
CSUBROUTINE FCALCI (KEYT, ATXYZ, IZAT, ITAT, NAT)   
C-----------------------------------------------------------------------
C Note: anisotropic temp.factors are transformed to beta's, 
C       and "disorder" occupancy factors are multiplied by MSELF
C            i.e. the symmetry multiplicity of the atomic site. 
C Subroutine to prepare tables for the  
C structure factor calculation subroutines FCALC1 and FCALC2
C It reads the number of atom types,
C The number of atoms for each atom type in the whole unit cell,
C The number of electrons for each atom type
C The scattering factor coefficients from the CRYSDA file   
C It prepares the symmetry information in a format suitable for FCALC1  
C It finds the pointers to the scattering factor tables for each atom   
C in the input model, and gives messages if a partial model is given
C It transforms the temperature factors, suitable for FCALC1:   
C It transforms the occupancy   factors, suitable for FCALC1:   
C It prepares the table for SINE/COSINE values  
C It prepares the scattering factor curves  
C It sets up the SUMF2 and SUMF2P tables for the whole  
C structure and the partial structure (= MODEL) 
C and calcultes PSQ = p**2 = SUM Z**2 (PART) / SUM Z**2 (TOT)   
C P1SQ = PSQ / (ICENT*NSYMM)
C Note for 'EXPAND' : struc.factor routine for P1 - expanded data.  
C If 'EXPAND' (SWITCH(23)) is .TRUE. then all symmetry is ignored:  
C MSELF=1, CELPAR contains input atoms only, P1SQ = correct P**2.   
C PSQ = AMIN1 (0.999 , P1SQ * ICENT * NSYMM) .  
C ITAT   - POINTERS TO ATOMIC SCATTERING FACTOR TABLES  
C Calls: KERNZI, RDCRYB, RDCRYX 
C+----------------------------------------------------------------------
C ITAT   - POINTERS TO ATOMIC SCATTERING FACTOR TABLES  
C HKLX   - REFLECTION INDICES EXPANDED WITH SYMMETRY ELEMENTS   
C ITS    - INDICATOR, = 0 IF TRANSLATIONAL PART IS ZERO 
C ASYMCL - multiplication factor, = NLATT * ICENT   
C NTYPE  - NUMBER OF TYPES OF ATOMS 
C IZTYPE - ATOMIC NUMBERS = NUMBERS OF ELECTRONS FOR THE ATOM TYPES 
C CELALL - NUMBER OF ATOMS FOR EACH ATOM TYPE IN CRYSDA FILE
C CELPAR - NUMBER OF ATOMS FOR EACH ATOM TYPE IN (PARTIAL) MODEL
C SICO   - TABLE OF SINES/COSINES IN STEPS OF 0.0025 SIN(THETA)/LAMBDA  
CX? STEPSIZE?? SICO ??  
C FF     - TABLES OF SCATTERING FACTOR CURVES IN STEPS OF 0.0025
C EXPBP  - EXPONENTIAL TEMPERATURE FACTOR CURVE FOR B-OVERALL   
C EXPBR  - EXPONENTIAL TEMPERATURE FACTOR CURVE FOR B-OVERALL (REST)
C SUMF2  - ((SCATT.FACTOR)**2)*CELALL FOR COMPLETE STRUCTURE
C SUMF2P - ((SCATT.FACTOR)**2)*CELPAR FOR PARTIAL STRUCTURE 
C TEMPF  - (ANISOTROPIC) TEMPERATURE FACTORS, SUITABLE FOR FCALC1   
C SFAC   - SCATTERING FACTOR CURVES COEFFICIENTS
C BP     - DEFAULT VALUE FOR OVERALL TEMPERATURE FACTOR 
C BR     - DEFAULT VALUE FOR OVERALL TEMPERATURE FACTOR FOR REST
C STL    - SIN(THETA)/LAMBDA
C STL2   - (SIN(THETA)/LAMBDA)**2   
C-----------------------------------------------------------------------
      SUBROUTINE FCALCI (KEYT, ATXYZ, IZAT, ITAT, NAT)  
      DIMENSION ATXYZ(10,NAT), IZAT(NAT), ITAT(NAT) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      COMMON /SYSTB/ PROGNM,    PROSNM,     CCODE,      TITLE,  
     *               CHIN,      LIT(32),    CHOUT   
      CHARACTER      PROGNM *8, PROSNM *6,  CCODE *6,   TITLE *64,  
     *               CHIN *80,  LIT *6,     CHOUT *72   
      EQUIVALENCE (ICRYS, IFILE(3)) 
      LOGICAL EXPAND
      EQUIVALENCE (EXPAND, SWITCH(23))  
C Note for 'EXPAND' : struc.factor routine for P1 - expanded data.  
C If 'EXPAND' (SWITCH(23)) is .TRUE. then all symmetry is ignored:  
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
C     ------ /FCALCA/ for various control parameters and reflection data
      COMMON /FCALCA/ BP,       BR,       SCALE,    HKLMAX(3), STLMAX,  
     *                IZTYPE(10), CELPAR(10), PSQ,  P1SQ,     ITRS(24), 
     *        AMULT,  ASYMM,    ALATT,    ASYMCL,   NSYMC,    ASYMC,
     *                HKLX(3,24), IDHKL(24), HCODE, FOBS,     SIG,  
     *                STL,      STL2,     ISS,      ENORM,  
     *                FP,       PHIP,     FAP,      FBP,      EPSIL,
     *                EPSIL2,   SF2,      SF2P,     FPEXP(2,24) 
C        IZTYPE(NTYPE) = atomic number (IZ) for the atom types  
C        CELPAR(NTYPE) = number of input atoms of this type 
C        ITRS(NSYMM)   = indicates translational part of a symm.rel.
C        AMULT=FLOAT(IMULT), ASYM..=FLOAT(NSYM..), ASYMCL=ICENT*NLATT   
C        NSYMC=NSYMM*ICENT . ENORM defined by: E = F / ENORM .  
C     ------ /  / blank common for various data for FCALCI, FCALC1, ..  
C                 = 19630 words*4 (excluding atomic parameters),
C                 only to be used in connection with FCALC etc. 
      COMMON /  / SICO(12500), FF(500,10),  EXPBP(500),   EXPBR(500),   
     *            SUMF2(500),  SUMF2P(500), SFAC(13,10) 
C        ASSUME STANDARD COMMONS TO BE FILLED, EXCEPT ARRAY ITAT(513)   
C        WHICH CONTAINS POINTERS FOR EACH ATOM TO THE ATOM TYPE;
C        GET MISSING INFORMATION FROM THE CRYSDA FILE   
C        CELALL(NTYPE) = THE NUMBER OF ATOMS FOR EACH ATOM TYPE 
C        IN THE WHOLE UNIT CELL FROM THE FORMUL RECORD, MULTIPLIED  
C        BY FLOAT(Z), THE NUMBER OF FORMULA UNITS.  
C        GET IZTYPE(NTYPE) = ATOMIC NUMBER FOR THE ATOM TYPES;  
C        GET THE SCATTERING FACTOR COEFFICIENTS FOR THE ATOM TYPES  
      DO 130 I=1,NTYPE  
      CALL RDCRYB (ICRYS, 'ELEM' , KEND)
      IF (KEND.LE.0) THEN   
        WRITE (CHOUT, 110) I
  110   FORMAT (' CRYSDA file: ELEM for atom TYPE no. ',I2,' not found')
        CALL KERROR (CHOUT, 0, 'FCALCI')
        ENDIF   
      READ (CHIN, 120) IZTYPE(I)
  120 FORMAT (10X, 2X, I8)  
  130 CALL RDCRYX (ICRYS, 'SFAC' , SFAC(1,I), 13)   
      DO 150 I=1,NSYMM  
      IF (ABS(TSYMM(1,I)).GT.0.001 .OR. 
     *    ABS(TSYMM(2,I)).GT.0.001 .OR. 
     *    ABS(TSYMM(3,I)).GT.0.001 ) THEN   
         ITRS(I) = 1
         ELSE   
         ITRS(I) = 0
         ENDIF  
  150 CONTINUE  
      AMULT = FLOAT (IMULT) 
      ASYMM = FLOAT (NSYMM) 
      ALATT = FLOAT (NLATT) 
      ASYMCL= FLOAT (ICENT*NLATT)   
      NSYMC = NSYMM * ICENT 
      ASYMC = FLOAT (NSYMC) 
C        NOTE: ATXYZ(4,...) INCLUDES SYMMETRY REDUCTION FACTOR  
C              (IN SHELX ATXYZ(4,...) = SITE OCCUPANCY FACTOR)  
C        set up occ.factor for individual atoms (NOT if EXPAND) 
      IF (.NOT. EXPAND) CALL ATOMOC (1, ATXYZ, ITAT, NAT)   
C           in this call, ITAT is used as dummy: not changed
C        FILL TABLE ITAT(NAT) WITH POINTERS TO SCATTERING FACTORS.  
C        FILL ARRAY CELPAR(NTYPE) WITH TOTAL NUMBER OF ATOMS FOR
C           EACH ATOM TYPE IN THE WHOLE UNIT CELL AS FOUND FROM THE 
C           ATOMS SUPPLIED: THIS IS THE PARTIAL STRUCTURE (=MODEL)  
C        NOTE: THESE NUMBERS SHOULD BE EQUAL TO CELALL(NTYPE) IN
C           CASE THE COMPLETE STRUCTURE IS SUPPLIED.
      CALL KERNZA (0.0, CELPAR, NTYPE)  
      AAMULT = AMULT
      IF (EXPAND) AAMULT = ALATT
      DO 161 I=1,NAT
      DO 160 J=1,NTYPE  
      IF (IZAT(I).NE.IZTYPE(J)) GOTO 160
      ITAT(I) = J   
C        EXPAND: CELPAR contains input atoms only: multiplicity = NLATT 
      CELPAR(J) = CELPAR(J) + ATXYZ(4,I) * AAMULT   
  160 CONTINUE  
  161 CONTINUE  
C        TEMPERATURE FACTORS TO BE USED ARE B (Input by ATOMIN) 
C        IF ATXYZ(5,...) .LE. 0.0: OVERALL TEMPERATURE FACTOR BP
C        IF ATXYZ(6,...) .LT. 0.0: ATXYZ(5,...) = B(ISOTR)  
C        IF ANISOTROPIC, MULTIPLY WITH THE APPROPRIATE RECIPROCAL AXES  
C           VALUES AS NEEDED BY THE ANISOTROPIC TEMPERATURE FACTOR  
C           EXPRESSION / WARNING: ATXYZ(6,..) ARE NOT TEMP.FACT. NOMORE 
      IF (KEYT.EQ.3) CALL ATBETA (ATXYZ, NAT)   
C        SET UP SINE/COSINE TABLES IN STEPS OF 0.0001 CYCLES
C        SICO ELEMENTS 1-10000 ARE VALUES FOR SINE OF I.
C        SICO ELEMENTS 2501-12500 ARE VALUES FOR COSINE OF I.   
      CALL SICOT (SICO, 12500)  
C        SET UP SCATTERING FACTORS TABLES   
C        SET UP EXPONENTIAL CURVES FOR OVERALL TEMPERATURE FACTORS  
C        (BR IS THE OVERALL TEMPERATURE FACTOR FOR THE REST STRUCTURE)  
C        AS FUNCTION OF SIN(T/L), IN STEPS OF 0.0025
C        NOTE: FOR A=100 ANGSTROM, SIN(T/L)=0.005 FOR REFL. 100 
C        NOTE DEFINITION: IS = IFIX (STL * 400.) + 1
C        THUS: ARRAY(1) = VALUE FOR STL=0.  
C        MAXIMUM ELEMENT USED: CALC FROM STLMAX 
Corr  ISMAX = IFIX (STLMAX * 400. +0.0001) + 2  
      ISMAX = IFIX (STLMAX * 400. +0.04  ) + 2  
      IF (ISMAX.LE.500) GOTO 200
      WRITE (CHOUT, 198) STLMAX 
  198 FORMAT (' Found max. sin(th/lam) = STLMAX =', F7.3,   
     *        ' Max = 1.249 . ??DATA ERROR?? ') 
      CALL KERROR (CHOUT, 0, 'FCALCI')  
  200 DO 260 IS=1,ISMAX 
      STL = FLOAT(IS-1) * 0.0025
      STL2 = STL * STL  
      EXPBP(IS) = EXP(-BP * STL2)   
      EXPBR(IS) = EXP(-BR * STL2)   
      SUMF2(IS)  = 0.0  
      SUMF2P(IS) = 0.0  
C        NTYPE, NUMBER OF ATOM TYPES
      DO 260 I=1,NTYPE  
*     FF(IS,I) = SFAC(9,I) + SFAC(10,I) 
*     DO 250 J=1,7,2
* 250 FF(IS,I) = FF(IS,I) + SFAC(J,I) * EXP (-SFAC(J+1,I) * STL2)   
*** PTB / Wil .... max for K atoms at high stl  
C        USING SCATTERING FACTORS,  SFAC(J,..) (B3 and B4 may be large) 
      SFAC6 = AMIN1 (SFAC(6,I) * STL2, 99.99)   
      SFAC8 = AMIN1 (SFAC(8,I) * STL2, 99.99)   
      FF(IS,I) = SFAC(9,I) + SFAC(10,I) 
     * + SFAC(1,I) * EXP (-SFAC(2,I) * STL2)
     * + SFAC(3,I) * EXP (-SFAC(4,I) * STL2)
     * + SFAC(5,I) * EXP (-SFAC6)    + SFAC(7,I) * EXP (-SFAC8) 
C        SFAC(J,.), J= 1  2  3  4  5  6  7  8  9  10  11
C        CONTENTS:    A1 B1 A2 B2 A3 B3 A4 B4  C  F'  F"
      SUMF2(IS)  = SUMF2(IS) + FF(IS,I) * FF(IS,I) * CELALL(I)  
  260 SUMF2P(IS) = SUMF2P(IS)+ FF(IS,I) * FF(IS,I) * CELPAR(I)  
C        for EXPAND: P1SQ = correct P**2 from SUMF2P
C        PSQ = AMIN1 (0.999 , P1SQ * ICENT * NSYMM) .   
C        calculate  PSQ = p**2 = SUM Z**2 (PART) / SUM Z**2 (TOT)   
      PSQ = SUMF2P(2)/SUMF2(2)  
      P1SQ = PSQ / ASYMC
      IF (.NOT. EXPAND) RETURN  
C        for EXPAND: P1SQ = correct P**2 from SUMF2P
      P1SQ = PSQ
C        PSQ = P1SQ * ICENT * NSYMM , aan te passen voor special atoms  
C        test if number of heavy atoms are limited ... PSQMAX   
C        later: if necessary: contral card PSQMAX in CONDA file 
      PSQ = AMIN1 (0.999 , P1SQ * ASYMC)
      RETURN
C        END OF SUBROUTINE FCALCI   
      END   
CSUBROUTINE FCALC1 (KEYT, ATXYZ, ITAT, NAT) 
C-----------------------------------------------------------------------
C Structure factor calculation only 
C Input : KEYT 1=OVERALL, 2=ISOTROPIC, 3=MIXED T.F. 
C Warning:                an atom is isotropic if ATXYZ(6,I) .LT. 0.0 !!
C Output: FP   Structure-factor modulus 
C              PHIP   Phase angle in degrees, always between 0 and 360  
C             FAP     A-term of calculated structure factor 
C             FBP     B-term of calculated structure factor 
CSOLD          KEND   = 0, if O.K.  
CSOLD          KEND   =-1, if SIN(THETA/LAMBDA) .GT. 0.70   
CPTB later: test op STLMAX  
CPTB later: als dan fout, dan ook absolute stop 
C              KEND   > 0, Reflection is systematically absent, KEND is 
C                          set to the number of the symmetry operation  
C                          that causes this condition.  
C-----------------------------------------------------------------------
C FP = Fcalc(h) = A + i.B   
C   
C A =  SIGMA n(j).f(j) SIGMA exp(-hT.B(js).h).cos(2pi.hT.x(js)) 
C      j=1,N           s=1,m
C   
C    - SIGMA n(j).f''(j) SIGMA exp(-hT.B(js).h).sin(2pi.hT.x(js))   
C      j=1,N             s=1,m  
C   
C B =  SIGMA n(j).f(j) SIGMA exp(-hT.B(js).h).sin(2pi.hT.x(js)) 
C      j=1,N           s=1,m
C   
C    + SIGMA n(j).f''(j) SIGMA exp(-hT.B(js).h).cos(2pi.hT.x(js))   
C      j=1,N             s=1,m  
C n(j)     : occupancy factor of atom j 
C f(j)     : form factor f + f' of atom j for reflection h  
C f''(j)   : anomalous form factor of atom j for reflection h   
C hT       : transposed vector h,k,l for reflection h   
C B(js)    : 3x3 temp factor matrix for atom j in position s
C            (6 unique elements only)   
C x(js)    : coordinate vector for atom j in position s 
C N        : number of independent atoms
C m        : number of symmetry-related positions.  
C For computational reasons, replace
C hT.B(js).h        by       h(s)T.B(j).h(s)      and   
C hT.x(js)          by       h(s)T.x(j) + hT.t(s)   
C B(j)     : temp factor matrix for atom j  
C x(j)     : coordinate vector for atom j   
C h(s)T    : transposed symmetry equivalent set of indices  
C t(s)     : translational part of symmetry position s  
C The expression for the anisotropic temperature factor, using B's: 
C exp -1/4 (B11.h**2.astar**2 + B22.k**2.bstar**2 + B33.l**2.cstar**2   
C + 2.B23.k.l.bstar.cstar + 2.B13.h.l.astar.bstar + 
C 2.B12.h.k.astar.bstar )   
C The factors B11.astar**2, ....   2.B13.astar.bstar
C are independent of the symmetry and the reflection indices and are
C therefore evaluated only once in subroutine FCALCI, by subroutine 
C ATBETA. By incorporating the factor 2 in the cross terms, 
C    the matrix * vector multiplication is symplified.  
C    n(j).f(j,h)           is evaluated in AFF(j)   
C    n(j).f''(f,h)         is evaluated in AFFX(j)  
C    h(s,T).B(j).h(s)      is evaluated in TF(j,s)  
C    h(s,T).x(j)+h(T).t(s) is evaluated in TRIG(j,s)
C    So, the following sums should be calculated:   
C    A = SIGMA AFF (j) SIGMA TF(j,s).cos(TRIG(j,s)) 
C      - SIGMA AFFX(j) SIGMA TF(j,s).sin(TRIG(j,s)) 
C    B = SIGMA AFF (j) SIGMA TF(j,s).sin(TRIG(j.s)) 
C      + SIGMA AFFX(j) SIGMA TF(j,s).cos(TRIG(j,s)) 
C    The symmetry elements, we leave out those for a possible lattice   
C    centering is a multiplication factor, which is incorporated in 
C    the factor ASYMCL, set in FCALCI (NLATT = 1,2,3 or 4). 
C    A possible centre of symmetry is also a multiplication factor  
C    incorporated in ASYMCL (ICENT = 1 or 2). If centrosymmetric, the   
C    center of symmetry must be in the origin, and the sine terms are   
C    left out of the summations.
C    During the actual summations, the following products are used: 
C    FFRF(j,s) = AFF(j) . TF(j,s) and FFRFX(j,s) = AFFX(j) . TF(j,s) :  
C    A = SIGMA FFRF(j,s).cos(TRIG) - SIGMA FFRFX(j,s).sin(TRIG) 
C    B = SIGMA FFRF(j,s).sin(TRIG) + SIGMA FFRFX(j,s).cos(TRIG).
C    Finally, the structure factor modulus and phase are calculated as  
C    FP = SQRT( A*A + B*B ) * ASYMCL
C    PHIP = ATAN(B/A)   
C The anomalous scattering does not cancel out in the   
C    centrosymmetric case: B need not be zero, and the phase angle  
C    is not restricted to 0 or 180 degrees, albeit that the deviations  
C    will generally be small.   
C+----------------------------------------------------------------------
C ITAT   - POINTERS TO ATOMIC SCATTERING FACTOR TABLES  
C HKLX   - REFLECTION INDICES EXPANDED WITH SYMMETRY ELEMENTS   
C ITRS   - INDICATOR, = 0 IF TRANSLATIONAL PART IS ZERO 
C ASYMCL - multiplication factor, = ICENT * NLATT   
C NTYPE  - NUMBER OF TYPES OF ATOMS 
C IZTYPE - ATOMIC NUMBERS = NUMBERS OF ELECTRONS FOR THE ATOM TYPES 
C CELALL - NUMBER OF ATOMS FOR EACH ATOM TYPE IN CRYSDA FILE
C CELPAR - NUMBER OF ATOMS FOR EACH ATOM TYPE IN (PARTIAL) MODEL
C SICO   - TABLE OF SINES/COSINES IN STEPS OF 0.0025 SIN(THETA)/LAMBDA  
C FF     - TABLES OF SCATTERING FACTOR CURVES IN STEPS OF 0.0025
C EXPBP  - EXPONENTIAL TEMPERATURE FACTOR CURVE FOR B-OVERALL   
C EXPBR  - EXPONENTIAL TEMPERATURE FACTOR CURVE FOR B-OVERALL (REST)
C SUMF2  - ((SCATT.FACTOR)**2)*CELALL FOR COMPLETE STRUCTURE
C SUMF2P - ((SCATT.FACTOR)**2)*CELPAR FOR PARTIAL STRUCTURE 
C TEMPF  - (ANISOTROPIC) TEMPERATURE FACTORS, SUITABLE FOR FCALC1   
C SFAC   - SCATTERING FACTOR CURVES COEFFICIENTS
C STL    - SIN(THETA)/LAMBDA
C STL2   - (SIN(THETA)/LAMBDA)**2   
C STLDEL - THE DIFFENCE BETWEEN CALCULATED THETA AND NEAREST STEP   
C STLMAX - MAXIMUM VALUE FOR SIN(THETA/LAMBDA)  
C ADTRIG - TRANSLATIONAL PARTS OF COORDINATE VECTORS FOR THIS H,K,L 
C FFF    - SCATTERING FACTORS FOR THE THETA VALUE OF THIS H,K,L 
C  FAP     - A-term OF CALCULATED STRUCTURE FACTOR  
C  FBP     - B-term OF CALCULATED STRUCTURE FACTOR  
C AFF    - )
C AFFX   - )
C FFRF   - ) USED, DURING SUMMATION, SEE EXPLANATION ABOVE  
C FFRFX  - )
C TF     - )
C ITRIG  - POINTER IN SINES/COSINES TABLE   
C FP     - STRUCTURE FACTOR MODULUS 
C PHIP   - CALCULATED PHASE ANGLE   
C-----------------------------------------------------------------------
      SUBROUTINE FCALC1  (KEYT, ATXYZ, ITAT, NAT)   
      DIMENSION ATXYZ(10,NAT), ITAT(NAT)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
C     ------ /FCALCA/ for various control parameters and reflection data
      COMMON /FCALCA/ BP,       BR,       SCALE,    HKLMAX(3), STLMAX,  
     *                IZTYPE(10), CELPAR(10), PSQ,  P1SQ,     ITRS(24), 
     *        AMULT,  ASYMM,    ALATT,    ASYMCL,   NSYMC,    ASYMC,
     *                HKLX(3,24), IDHKL(24), HCODE, FOBS,     SIG,  
     *                STL,      STL2,     ISS,      ENORM,  
     *                FP,       PHIP,     FAP,      FBP,      EPSIL,
     *                EPSIL2,   SF2,      SF2P,     FPEXP(2,24) 
C        IZTYPE(NTYPE) = atomic number (IZ) for the atom types  
C        CELPAR(NTYPE) = number of input atoms of this type 
C        ITRS(NSYMM)   = indicates translational part of a symm.rel.
C        AMULT=FLOAT(IMULT), ASYM..=FLOAT(NSYM..), ASYMCL=ICENT*NLATT   
C        NSYMC=NSYMM*ICENT . ENORM defined by: E = F / ENORM .  
C     ------ /  / blank common for various data for FCALCI, FCALC1, ..  
C                 = 19630 words*4 (excluding atomic parameters),
C                 only to be used in connection with FCALC etc. 
      COMMON /  / SICO(12500), FF(500,10),  EXPBP(500),   EXPBR(500),   
     *            SUMF2(500),  SUMF2P(500), SFAC(13,10) 
      DIMENSION FFF(10), ADTRIG(24) 
      DATA  FFF, ADTRIG / 34*0.0 /  
      S = STL * 400. + 1.   
      IS = IFIX(S)  
      STLDEL = S - FLOAT(IS)
      ISS = NINT(S) 
C        GET F (=SCATT.FACT.) FOR ATOMS OF PART.STRUCT. 
      DO 110 J=1,NTYPE  
      IF (CELPAR(J).LE.0.0) GOTO 110
      FFF(J) = FF(IS,J) + (FF(IS+1,J)-FF(IS,J)) * STLDEL
  110 CONTINUE  
C        EXPAND HKL 
      CALL HKLEX1 (HKLX, HKLX)  
C        FILL ADTRIG ARRAY WITH TRANSLATIONAL PARTS OF SYMMETRY 
C        THESE ARE INDEPENDENT OF THE ATOMS, SO GET THEM OUTSIDE THE
C        MAIN DO-LOOP   
      IF (NSYMM.EQ.1) GOTO 150  
      DO 140 J=2,NSYMM  
      IF (ITRS(J).EQ.0) GOTO 140
      ADTRIG(J) = HKLX(1,1)*TSYMM(1,J) + HKLX(2,1)*TSYMM(2,J) + 
     *            HKLX(3,1)*TSYMM(3,J)  
  140 CONTINUE  
C        CLEAR SUMS 
  150 FAP = 0.0 
      FBP = 0.0 
C        IF KEYT=1 GOTO FAST ROUTINE
      IF (KEYT.EQ.1) GOTO 300   
C        NAT, NUMBER OF INPUT ATOMS (INDIVIDUAL TEMP.FACTORS)   
      DO 250 I=1,NAT
C          A1 - B2 ARE SUB-SUMS OVER TRIG. / NSYMM  
      A1 = 0.   
      B1 = 0.   
      A2 = 0.   
      B2 = 0.   
C        ISO + ANISO,   NSYMM  LOOP,   SUM TRIGONOMETRICS   
      DO 200 J=1,NSYMM  
C        GET TRIGONOMETRICS 
      TRIG = HKLX(1,J)*ATXYZ(1,I) + HKLX(2,J)*ATXYZ(2,I) +  
     *       HKLX(3,J)*ATXYZ(3,I) + ADTRIG(J)   
      IF (TRIG.LT.0.0) TRIG = TRIG - 0.00010
      ITRIG = MOD ( IFIX(TRIG * 10000. + 0.5), 10000)   
      IF (ITRIG.LE.0) ITRIG = ITRIG + 10000 
C          ISO: TEMP. FACT. OUTSIDE NSYMM LOOP  
C        ANISO: TEMP. FACT.  INSIDE NSYMM LOOP  
      IF (ATXYZ(6,I) .GT. 0.0) GOTO 180 
C        GET SUMS FOR ISOTROPIC ATOM
C        SUM:  F COS + I F SIN - F" SIN + I F" COS  
C        =     A.... + I B.... - A".... + I B"  
      A1 = A1 + SICO(ITRIG + 2500)  
      B1 = B1 + SICO(ITRIG + 2500)  
      IF (ICENT.EQ.2) GOTO 200  
      A2 = A2 - SICO(ITRIG) 
      B2 = B2 + SICO(ITRIG) 
      GOTO 200  
C       ANISOTROPIC TEMP. FACTORS:  
C  TEMP.FACTOR: J.S.ROLLET, IN: COMPUTING METHODS IN CRYSTALLOGRAPHY,   
C          ED. J.S.ROLLET. PERGAMON PRESS, PP. 43-45 (1965).
  180 X1 = HKLX(1,J) * ATXYZ (5,I)  
     *   + HKLX(2,J) * ATXYZ(10,I)  
     *   + HKLX(3,J) * ATXYZ (9,I)  
      X2 = HKLX(2,J) * ATXYZ (6,I)  
     *   + HKLX(3,J) * ATXYZ (8,I)  
      X3 = HKLX(3,J) * ATXYZ (7,I)  
      TF = EXP(-0.25 * ( X1*HKLX(1,J) + X2*HKLX(2,J) + X3*HKLX(3,J) ))  
C        GET SUMS FOR ANISOTROPIC ATOM  
C        SUM:  F COS + I F SIN - F" SIN + I F" COS  
C        =     A.... + I B.... - A".... + I B"  
      A1 = A1 + SICO(ITRIG + 2500) * TF 
      B1 = B1 + SICO(ITRIG + 2500) * TF 
      IF (ICENT.EQ.2) GOTO 200  
      A2 = A2 - SICO(ITRIG) * TF
      B2 = B2 + SICO(ITRIG) * TF
  200 CONTINUE  
      IJ = ITAT(I)  
      IF (ATXYZ(6,I).LT.0.0) THEN   
C        COMPLETE ISOTROPIC:  TF = OCCUP. * TEMPF.  
         TF = ATXYZ(4,I) * EXP (-STL2 * ATXYZ(5,I)) 
         ELSE   
C        COMPLETE ANISOTROPIC:  TF = OCCUP.FACTOR   
         TF = ATXYZ(4,I)
         ENDIF  
      FAP = FAP + A1 * FFF(IJ)     * TF 
      FBP = FBP + B1 * SFAC(11,IJ) * TF 
      IF (ICENT .EQ. 2) GOTO 250
      FAP = FAP + A2 * SFAC(11,IJ) * TF 
      FBP = FBP + B2 * FFF(IJ)     * TF 
  250 CONTINUE  
      FP = ASYMCL * SQRT (FAP*FAP + FBP*FBP)
      GOTO 500  
C        NAT, NUMBER OF INPUT ATOMS: OVERALL TEMP.FACTORS   
C        ANOMALOUS SCATT. IGNORED   
  300 DO 450 I=1,NAT
C          A1 AND B2 ARE SUB-SUMS OVER TRIG. / NSYMM
      A1 = 0.   
      B2 = 0.   
C        NSYMM  LOOP,   SUM TRIGONOMETRICS  
      DO 400 J=1,NSYMM  
C        GET TRIGONOMETRICS 
      TRIG = HKLX(1,J)*ATXYZ(1,I) + HKLX(2,J)*ATXYZ(2,I) +  
     *       HKLX(3,J)*ATXYZ(3,I) + ADTRIG(J)   
      IF (TRIG.LT.0.0) TRIG = TRIG - 0.00010
      ITRIG = MOD ( IFIX(TRIG * 10000. + 0.5), 10000)   
      IF (ITRIG.LE.0) ITRIG = ITRIG + 10000 
      A1 = A1 + SICO(ITRIG + 2500)  
      IF (ICENT.EQ.2) GOTO 400  
      B2 = B2 + SICO(ITRIG) 
  400 CONTINUE  
      IJ = ITAT(I)  
      FAP = FAP + A1 * FFF(IJ) * ATXYZ(4,I) 
      IF (ICENT .EQ. 2) GOTO 450
      FBP = FBP + B2 * FFF(IJ) * ATXYZ(4,I) 
  450 CONTINUE  
C        OVERALL B = Bp used if KEYT=1  
      FP = ASYMCL * SQRT (FAP*FAP + FBP*FBP) * EXPBP(ISS)   
C        ENTER HERE FROM MIXED TEMP.FACTORS, KEYT = 2 or 3  
  500 PHIP = 0.0
      IF (FP.GT.0.001) PHIP = ATAN2(FBP,FAP) / 0.0174532925 
      IF (PHIP.LT.0.0) PHIP = PHIP + 360.   
      RETURN
C         END OF SUBROUTINE FCALC1  
      END   
CSUBROUTINE FCALC2 (KEYT, ATXYZ, ITAT, NAT) 
C-----------------------------------------------------------------------
C Structure factor calculation for P1 with EXPAND   
C Input :  KEYT   1=OVERALL, 2=ISOTROPIC (not ANISO-)   
C See subroutine FCALC1 for details:
C FCALC2 is Fcalc for all expanded reflections  
C    KEYT = 3 is not permitted: no test here ....   
C    (FCALC2 could be used with NSLOT=3 or NSLOT=4  
C       for proteins to save a lot of storage.......)   
C Note: Atom-multiplicity is ignored (EXPAND) except NLATT  
C+----------------------------------------------------------------------
      SUBROUTINE FCALC2  (KEYT, ATXYZ, ITAT, NAT)   
      DIMENSION ATXYZ(10,NAT), ITAT(NAT)
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
C     ------ /CRYSA/ and /CRYSB/ storage of important crystal data  
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     +               WAVE,     CELALL(10),  AMOLW,      ZET,
     +               NELEC,    F000,        ABSMU,      ICENT,  
     +               ILATT,    ISYST,       ILAUE,      IMULT,  
     +               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     +         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     +         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
C     ------ /FCALCA/ for various control parameters and reflection data
      COMMON /FCALCA/ BP,       BR,       SCALE,    HKLMAX(3), STLMAX,  
     *                IZTYPE(10), CELPAR(10), PSQ,  P1SQ,     ITRS(24), 
     *        AMULT,  ASYMM,    ALATT,    ASYMCL,   NSYMC,    ASYMC,
     *                HKLX(3,24), IDHKL(24), HCODE, FOBS,     SIG,  
     *                STL,      STL2,     ISS,      ENORM,  
     *                FP,       PHIP,     FAP,      FBP,      EPSIL,
     *                EPSIL2,   SF2,      SF2P,     FPEXP(2,24) 
C        IZTYPE(NTYPE) = atomic number (IZ) for the atom types  
C        CELPAR(NTYPE) = number of input atoms of this type 
C        ITRS(NSYMM)   = indicates translational part of a symm.rel.
C        AMULT=FLOAT(IMULT), ASYM..=FLOAT(NSYM..), ASYMCL=ICENT*NLATT   
C        NSYMC=NSYMM*ICENT . ENORM defined by: E = F / ENORM .  
C     ------ /  / blank common for various data for FCALCI, FCALC1, ..  
C                 = 19630 words*4 (excluding atomic parameters),
C                 only to be used in connection with FCALC etc. 
      COMMON /  / SICO(12500), FF(500,10),  EXPBP(500),   EXPBR(500),   
     *            SUMF2(500),  SUMF2P(500), SFAC(13,10) 
      DIMENSION FFF(10) 
C         CALL HKLSTL BEFOR CALL FCALC2 
      S = STL * 400. + 1.   
      IS = IFIX(S)  
      STLDEL = S - FLOAT(IS)
      ISS = NINT(S) 
C        GET F (=SCATT.FACT.) FOR ATOMS OF PART.STRUCT. 
      DO 110 J=1,NTYPE  
      IF (CELPAR(J).LE.0.0) GOTO 110
      FFF(J) = FF(IS,J) + (FF(IS+1,J)-FF(IS,J)) * STLDEL
  110 CONTINUE  
C        EXPAND HKL 
      CALL HKLEX1 (HKLX, HKLX)  
C        FILL IDHKL WITH 0 (NEW) OR 1 (IDENTICAL) OR -1 (FRIEDEL)   
C        IEPS2 IS EPSILON INCLUDING FRIEDELS = EPSIL2   
      CALL HKLEX2 (HKLX, IDHKL, IEPS, IEPS2)
      EPSIL = IEPS  
      EPSIL2 = IEPS2
C        SKIP HKL( ,I)  IF: IDHKL(I) .NE. 0 
C        IF (NSYMM.EQ.1) THERE IS NO EXPANSION ...  
      DO 600 J=1,NSYMM  
      IF (IDHKL(J).EQ.0) GOTO 200   
      K = IABS(IDHKL(J))
      FPEXP(1,J) = -K   
      FPEXP(2,J) = FPEXP(2,K)   
      IF (FPEXP(2,J).LT.0.001) FPEXP(2,J)=0.001 
      IF (IDHKL(J).LT.0)     FPEXP(2,J)=-FPEXP(2,J) 
C        USE IN TRACOR: IF FP.LT.0: IF PHIP.LT.0: PHIP=360.+PHIP
C        TO INDICATE:      NOT-NEW     FRIEDEL  
      GOTO 600  
C        CLEAR SUMS 
  200 FAP = 0.0 
      FBP = 0.0 
      DO 400 I=1,NAT
C        GET TRIGONOMETRICS 
      TRIG = HKLX(1,J)*ATXYZ(1,I) + HKLX(2,J)*ATXYZ(2,I) +  
     *       HKLX(3,J)*ATXYZ(3,I)   
      IF (TRIG.LT.0.0) TRIG = TRIG - 0.00010
      ITRIG = MOD ( IFIX(TRIG * 10000. + 0.5), 10000)   
      IF (ITRIG.LE.0) ITRIG = ITRIG + 10000 
      IJ = ITAT(I)  
C        IF KEYT=1 GOTO FAST ROUTINE (BOV)  
      IF (KEYT.EQ.1) GOTO 300   
C        NAT, NUMBER OF INPUT ATOMS (INDIVIDUAL TEMP.FACTORS)   
C        GET SUMS FOR ISOTROPIC ATOM
C        SUM:  F COS + I F SIN - F" SIN + I F" COS  
C        =     A.... + I B.... - A".... + I B"  
C        INDIVIDUAL ISOTROPIC:  TF = TEMPF. (NO OCC.FACTOR) 
      TF = EXP (-STL2 * ATXYZ(5,I)) 
      FAP = FAP + SICO(ITRIG + 2500) * FFF(IJ)     * TF 
     *      - SICO(ITRIG)        * SFAC(11,IJ) * TF 
      FBP = FBP + SICO(ITRIG + 2500) * SFAC(11,IJ) * TF 
     *      + SICO(ITRIG)        * FFF(IJ)     * TF 
      GOTO 400  
C        NAT, NUMBER OF INPUT ATOMS: OVERALL TEMP.FACTORS   
C        ANOMALOUS SCATT. IGNORED / OCC.FACT. IGNORED ALSO  
  300 CONTINUE  
      FAP = FAP + SICO(ITRIG + 2500) * FFF(IJ)  
      FBP = FBP + SICO(ITRIG)        * FFF(IJ)  
  400 CONTINUE  
C           NOTE: FOR FCALC WITH EXPAND: do not mult. by ICENT  
      IF (KEYT.EQ.1) THEN   
C           if KEYT=1 use fast routine i.e. using overall B 
         FP = ALATT * SQRT (FAP*FAP + FBP*FBP) * EXPBP(ISS) 
      ELSE  
C           else use individual temp. factors   
         FP = ALATT * SQRT (FAP*FAP + FBP*FBP)  
         ENDIF  
      PHIP = 0.0
      IF (FP.GT.0.001) PHIP = ATAN2(FBP,FAP) / 0.0174532925 
CPTB liever * D2R ???  als parameter
      IF (PHIP.LT.0.0) PHIP = PHIP + 360.   
C        FPEXP: STORE FP AND PHIP   
      FPEXP(1,J) = FP   
      FPEXP(2,J) = PHIP 
  600 CONTINUE  
      RETURN
C         END OF SUBROUTINE FCALC2  
      END   
CSUBROUTINE SICOT (SICO, M) 
C-----------------------------------------------------------------------
C Needed : M = ARRAY size (must be multiple of 5) !!!!!!!!  
C Output : SICO 
C For M=12500 : 
C Set up SINE/COSINE tables in steps of 0.0001 cycles   
C SICO ELEMENTS 1-10000 are values for SINE of I,   
C SICO ELEMENTS 2501-12500 are values for COSINE of I   
C Similar for any other step size as defined by M.  
C+----------------------------------------------------------------------
      SUBROUTINE SICOT (SICO, M)
      DIMENSION SICO(M) 
      PARAMETER (PI2 = 2.0 * 3.14159265 )   
C OLD DO 240 I=1,2500      USE M1 = 2500
C     AI = SIN(...) 
C     SICO(I)       = AI
C     SICO(5000-I)  = AI   USE M2 = 5000
C     SICO(5000+I)  =-AI
C     SICO(10000-I) =-AI   USE M4 =10000
C 240 SICO(10000+I) = AI
      M1 = M  / 5   
      M2 = M1 * 2   
      M4 = M2 * 2   
      F = PI2 / FLOAT(M4)   
      DO 240 I=1,M1 
      AI = SIN (FLOAT(I) * F)   
      SICO(I)    = AI   
      SICO(M2-I) = AI   
      SICO(M2+I) =-AI   
      SICO(M4-I) =-AI   
  240 SICO(M4+I) = AI   
      SICO(M2)   = 0.0  
      SICO(M4)   = 0.0  
      RETURN
C        END OF SUBR  SICOT / END of subfile NIJX3  
      END   
CSUB : fourth part of the NIJX subroutines  
C ??
C ??
C+----------------------------------------------------------------------
CSUBROUTINE MACOL (A)   
C-----------------------------------------------------------------------
C Transpose matrix A(3*3)   
C Input : A = The input  matrix A of dimension 3*3  
C Output: A = The output matrix A of dimension 3*3  
C    ===> The input matrix is replaced by its transposed matrix <===
C+----------------------------------------------------------------------
      SUBROUTINE MACOL(A)   
      DIMENSION A(3,3)  
      N=1   
  105 K=2   
  110 T=A(K,N)  
      A(K,N)=A(N,K) 
      A(N,K)=T  
      IF (N.EQ.3) RETURN
      K=K+1 
      IF (K.LE.3) GOTO 110  
      N=3   
      GOTO 105  
C        END OF SUBROUTINE MACOL
      END   
CSUBROUTINE MATINV (A,B,D,KEND) 
C-----------------------------------------------------------------------
C Calculate the inverse matrix B(3*3) from matrix A(3*3)
C Input : A    = The input  matrix A of dimension 3*3   
C Output: B    = The output matrix B of dimension 3*3, if D.NE.0.0  
C         D    = The determinant of matrix A
C         KEND =   0: if D < 10.E-15 : B is the inverse of A
C              = -99, If D < ......  : B is meaningless 
C Calls: VECAXB MACOL   
C+----------------------------------------------------------------------
      SUBROUTINE MATINV(A,B,D,KEND) 
      DIMENSION A(3,3),B(3,3)   
      PARAMETER (DETMAX = 10.E-15)  
      KEND=0
      CALL VECAXB (A(1,2),A(1,3),B(1,1))
      CALL VECAXB (A(1,3),A(1,1),B(1,2))
      CALL VECAXB (A(1,1),A(1,2),B(1,3))
      D=A(1,1)*B(1,1)+A(2,1)*B(2,1)+A(3,1)*B(3,1)   
      IF (D.LT.DETMAX .AND. D.GT.-DETMAX) KEND = -99
      IF (KEND.EQ.-99) RETURN   
      DO 15 N=1,3   
      DO 15 K=1,3   
   15 B(K,N)=B(K,N)/D   
      CALL MACOL(B) 
      RETURN
C        END OF SUBROUTINE MATINV   
      END   
CSUBROUTINE WILPAR (IWILP)  
C-----------------------------------------------------------------------
C Calculation of WILSON and WILSON-PARTHASARATHY plot   
C    ln (Fobs**2 / (FP**2+SUMF2R)) = -2 ln(K) - 2*Bov*STL2  
C Return key: IWILP = 0 if success: SC, BP, BR changed! BOV not changed.
C             IWILP = 1 if no success: nothing changed  
C Input from common WILS :  
C    KEYWIL = option key (given by user or set by programs) 
C           = -2 only WILSON-PARTH. plot for FCALC  
C           = -1 only WILSON plot for MERBIN
C           =  0 all parameters free in 2D scaling procedure
C           =  1 Bp fixed                =  2 Br fixed  
C           =  3 Bp and Br fixed         =  4 Bp, Br and Sc fixed   
C    BPINP, BRINP = input temperature factors (old: user, or MERBIN)
C    BRMAX, BRMIN, BPMAX, BPMIN: limitations for Bp and Br  
C    NOW = number of observed (plus unobserved) reflections(*)  
C    NUW = number of unobserved reflections 
C    AW  = sum FO**2 / (SUMF2*EPSIL)
C    AAW = sum (FP**2 + SUMF2R*EPSIL) / (SUMF2*EPSIL)   
C    BW  = sum STL2)
C Output to common FCALCA : only done if 'success' (i.e. IWILP = 0) :   
C    BP = BR = new overall temp. factor 
C    SCALE  = new scale factor  
C (*) NRS = 9 for NNOW gt 1000 (NNOW = number of refl.) 
C (*) PTB Jan.95: NNOW gt  399 (NNOW = number of refl.) 
C           ranges with lt 25 refl. are skipped 
C     NRS = 4 for NNOW lt 1000 (range 9 is add to range 8 and 7)
C (*) PTB Jan.95: NNOW gt  399 (NNOW = number of refl.) 
C           ranges with lt 25 refl. are skipped, if NNOW gt 400 
C           ranges with lt NNOW/20  are skipped, if NNOW lt 400 
C Used by MERBIN and DDMAIN 
C Call WILDUP for printing  
CPTB5854 print WILPAR en WILPUD naar LIS1 .. moet ook naar LIS2 ??  
C+----------------------------------------------------------------------
      SUBROUTINE WILPAR (IWILP) 
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH 
      LOGICAL SWIPRI
      EQUIVALENCE (SWIPRI, SWITCH(10))  
      EQUIVALENCE (LIS1, IFILE(7)), (LIS2, IFILE(8))
C     ------ /FCALCA/ for various control parameters and reflection data
      COMMON /FCALCA/ BP,       BR,       SCALE,    HKLMAX(3), STLMAX,  
     *                IZTYPE(10), CELPAR(10), PSQ,  P1SQ,     ITRS(24), 
     *        AMULT,  ASYMM,    ALATT,    ASYMCL,   NSYMC,    ASYMC,
     *                HKLX(3,24), IDHKL(24), HCODE, FOBS,     SIG,  
     *                STL,      STL2,     ISS,      ENORM,  
     *                FP,       PHIP,     FAP,      FBP,      EPSIL,
     *                EPSIL2,   SF2,      SF2P,     FPEXP(2,24) 
C        IZTYPE(NTYPE) = atomic number (IZ) for the atom types  
C        CELPAR(NTYPE) = number of input atoms of this type 
C        ITRS(NSYMM)   = indicates translational part of a symm.rel.
C        AMULT=FLOAT(IMULT), ASYM..=FLOAT(NSYM..), ASYMCL=ICENT*NLATT   
C        NSYMC=NSYMM*ICENT . ENORM defined by: E = F / ENORM .  
C        Items for BIN-file buffers: BUFFO, BUFFC, BUFFC2 : 
C     common / WILS / used in WILSIN, WILSIX, WIL2DI, WILPAR, WIL2DC
      COMMON / WILS / NOW(9),   NUW(9),   AW(9),   AAW(9),  BW(9),  
     *                NOV(7,7), NUV(7,7), VA(7,7), VB(7,7), VC(7,7),
     *                VS(7,7) , FHMN,     BPMAX,   BPMIN,   BRMAX,  
     *                BRMIN,    BPINP,    BRINP,   KEYWIL,  PSQM,   
     *                EPMAX,    EPMIN   
      PARAMETER (BDMAX = 1.0)   
      IWILP = 1 
      IF (KEYWIL.EQ.4) RETURN   
      IF (.NOT. SWIPRI) GOTO 220
      IF (KEYWIL.GE.0) THEN 
         WRITE (LIS2, 200)  
  200    FORMAT(/ ' Data for WILSON-PARTHASARATHY plot:', /,
     *          ' Range  NOBS NUNOBS  <FO2/F2>  <(FP2+F2R)/F2>  STL2 ', 
     *          ' ln<FO2/(FP2+F2R)>')   
      ELSE  
C           MERBIN  
         WRITE (LIS2, 210)  
  210    FORMAT(/ ' Data for WILSON plot:', /,  
     *          ' Range  NOBS NUNOBS  <FO2/F2>  STL2  ln<FO2/F2>')  
         ENDIF  
  220 NRS = 9   
      NNOW = 0  
      DO 230 I=1,NRS
  230 NNOW = NNOW + NOW(I)  
C (*) PTB Jan.95: NNOW gt  399 (NNOW = number of refl.) 
C     IF (NNOW.GT.1000) GOTO 250
      IF (NNOW.GT. 399) GOTO 250
      J = 0 
      DO 240 I=1,(NRS-1),2  
      J = J + 1 
      NOW(J) = NOW(I) + NOW(I+1)
      NUW(J) = NUW(I) + NUW(I+1)
      AW(J)  = AW(I)  + AW(I+1) 
      AAW(J) = AAW(I) + AAW(I+1)
  240 BW(J)  = BW(I)  + BW(I+1) 
C        add last 'old' range (= number 9) to last 'new' range (= no. 4)
      NOW(J) = NOW(J) + NOW(NRS)
      NUW(J) = NUW(J) + NUW(NRS)
      AW(J)  = AW(J)  + AW(NRS) 
      AAW(J) = AAW(J) + AAW(NRS)
      BW(J)  = BW(J)  + BW(NRS) 
      NRS = J   
  250 I = 1 
  260 IF (NNOW.GT.399 .AND. NOW(I).GT.25) GOTO 280  
      IF (NNOW.LE.399 .AND. NOW(I).GT.NNOW/20) GOTO 280 
      NRS = NRS - 1 
      IF (I.GT.NRS) GOTO 320
      DO 270 J=I,NRS
      NOW(J) = NOW(J+1) 
      NUW(J) = NUW(J+1) 
      AW(J)  = AW(J+1)  
      AAW(J) = AAW(J+1) 
  270 BW(J)  = BW(J+1)  
      GOTO 260  
  280 AW(I)  = AW(I)  / NOW(I)  
      AAW(I) = AAW(I) / NOW(I)  
      BW(I)  = BW(I)  / NOW(I)  
C        MERBIN 
      IF (AAW(I).LT.0.001 .OR. KEYWIL.EQ.-1) AAW(I) = 1.0   
      X1 = ALOG(AW(I) / AAW(I)) 
      IF (.NOT. SWIPRI) GOTO 310
      IF (KEYWIL.GE.0) THEN 
          WRITE (LIS2, 290) I, NOW(I), NUW(I), AW(I), AAW(I), BW(I), X1 
  290     FORMAT (1X, I3, I8, I5, F11.4, F13.4, F11.4, F13.4)   
      ELSE  
C            MERBIN 
          WRITE (LIS2, 300) I, NOW(I), NUW(I), AW(I), BW(I), X1 
  300     FORMAT (1X, I3, I8, I5, F11.4, F8.4, F10.4)   
          ENDIF 
  310 AW(I) = X1
      I = I + 1 
      IF (I.LE.NRS)  GOTO 260   
  320 IF (NRS.LE.1)  THEN   
          WRITE (LIS1, 330) NRS 
          WRITE (LIS2, 330) NRS 
  330     FORMAT (' WILSON-PARTHASARATHY plot not possible, number of', 
     *            ' ranges: ', I3)  
          RETURN
          ENDIF 
      IF (KEYWIL .NE. -1) THEN  
         WRITE (LIS2, FMT='('' Input values for WILSON-PARTHASARATHY'', 
     *          '' plot: Bp ='', F7.3, '' Br ='', F7.3)') BP, BR
         WRITE (LIS2, 340)  
  340    FORMAT (' WILSON-PARTHASARATHY plot '/ 
     *            ' LN <FO**2/(FP**2+F2R)>')
         WRITE (LIS1, FMT='(A)') ' WILSON-PARTHASARATHY plot '  
      ELSE  
C           MERBIN  
         WRITE (LIS2, FMT='('' Input values for WILSON plot:  '',   
     *     '' Overall B ='', F7.3,''  Scale SC ='', F9.5)') BP, SCALE   
         WRITE (LIS2, 350)  
  350    FORMAT (' WILSON plot' / ' LN <FO**2/F2>') 
         WRITE (LIS1, FMT='(A)') ' WILSON plot results' 
         ENDIF  
C           call WILDUP and accept results  
C95   CALL WILDUP (AW, BW, NRS, C, S, R)
      CALL WILDUP (AW, BW, NOW, NUW, NRS, C, S, R)  
CPTB :   R not used ?   
      IWILP = 0 
C SWITCH(1) is set .TRUE. only for NIJMEGEN: used here for TEMPRY prints
      IF (SWITCH(1)) WRITE (LIS2, 3511) SCALE, BPINP, BRINP, BP, BR 
 3511 FORMAT (' PTB: TEMP: SCALE BpINP BrINP BP BR:', 2(3F9.5, 3X) )
      SCALE = EXP(-0.5 * C) 
      BD = -0.5 * S 
      BP = BP + BD  
      BR = BR + BD  
***?  BP = BPINP + BD   
***?  BR = BRINP + BD   
C SWITCH(1) is set .TRUE. only for NIJMEGEN: used here for TEMPRY prints
      IF (SWITCH(1)) WRITE (LIS2, 3512) SCALE, BP, BR   
 3512 FORMAT (' PTB: TEMP: WILSON SCALE Bp Br: new:', 2(3F9.5, 3X) )
      WRITE (LIS2, 356) 
  356 FORMAT ( ' Results are applied (as shifts)',  
     *         ' to the input values. New values are:') 
      IF (ABS(BP-BR).LT.0.001) THEN 
          WRITE (LIS1, 360) SCALE, BP   
          WRITE (LIS2, 360) SCALE, BP   
  360 FORMAT (' Scale and overall temperature factor: Scale =', 
     *          F9.5, ' Bov:', F6.3)
      ELSE  
          WRITE (LIS1, 370) SCALE, BP, BR   
          WRITE (LIS2, 370) SCALE, BP, BR   
  370 FORMAT (' Scale and B-values to be used: Scale =',
     *          F9.5, ' Bp =', F6.3, ' Br =', F6.3) 
          ENDIF 
      IF (KEYWIL.LE.0) GOTO 390 
      IF (KEYWIL.EQ.1 .OR. KEYWIL.EQ.3) BP = BP - BD
      IF (KEYWIL.EQ.2 .OR. KEYWIL.EQ.3) BR = BR - BD
      WRITE (LIS2, 380) KEYWIL, SCALE, BP, BR   
      WRITE (LIS1, 380) KEYWIL, SCALE, BP, BR   
  380 FORMAT (' (KEYWIL = ', I2, ') Reset: Scale =', F9.5,  
     * ' Bp =', F6.3, ' Br =')  
  390 CONTINUE  
C           MERBIN  
      IF (KEYWIL.EQ.-1) BD = 0.0
      IF (BP.GT.0.001 .AND. BR.GT.0.001 .AND. ABS(BD).LT.1. .AND.   
     *    SCALE.GT.0.001) RETURN
C        apply max. shift (BDMAX = 1.0) 
      SIGNBD = SIGN(BDMAX,BD)   
      IF (KEYWIL.LE.0) BP = BPINP + SIGNBD  
      IF (KEYWIL.LE.1) BR = BRINP + SIGNBD  
      IF (KEYWIL.EQ.2) BP = BPINP + SIGNBD  
      SCALE = 0.0   
C        If wrong: reduce STL range 
      KRSTL = 8 * NRS / 10  
      IF (NRS.LE.5)  KRSTL = 4  
      IF (NRS.LT.4)  KRSTL = NRS
      DO 400 I=1,KRSTL  
  400 SCALE = SCALE - AW(I) - 2.0*BW(I)*(BP-BPINP)  
      SCALE = EXP (0.5 * SCALE / KRSTL) 
      WRITE (LIS1, 410) 
      WRITE (LIS2, 410) 
  410 FORMAT (' Resetting of temperature factors and scale required:')  
      WRITE (LIS1, 370)  SCALE, BP, BR  
      WRITE (LIS2, 370)  SCALE, BP, BR  
      RETURN
C        END OF SUBROUTINE WILPAR   
      END   
CSUBROUTINE WILDUP (Y, X, NOW, NUW, N, C, S, R) 
C95 ROUTINE WILDUP (Y, X, N, C, S, R)   
C-----------------------------------------------------------------------
C Calculation and printing of a line based on the points (X, Y) 
C Input:  X = BW  = (SINTHETA/LAMBDA)**2
C         Y = AW  = ln <Fobs**2/(FP**2(B=BP)+SUMF2R(B=BR))> 
C         N = NRS = number of points
C Output: C = intercept 
C         S = slope 
C         R = error of fit  
C Called by WILPAR  
C+----------------------------------------------------------------------
      SUBROUTINE WILDUP (Y, X, NOW, NUW, N, C, S, R)
C95   SUBROUTINE WILDUP (Y, X, N, C, S, R)  
C     ------ /SYSTA/ and /SYSTB/ interface with supervisor. 
      COMMON /SYSTA/ IFILE(20), IFSTAT(20), ITIME(4),   KEYS(28),   
     *               NFNUM,     NLIT,       NCOLN(32),  NCOLL(32),  
     *               NFDOT(32), NFDOL(32),  NLUSER(32), FNUM(32),   
     *               SWITCH(28) 
      LOGICAL        SWITCH, SWIPRI 
      EQUIVALENCE (SWIPRI, SWITCH(10))  
      EQUIVALENCE (LIS2, IFILE(8))  
CPTB93 output to LIS2 only !!   
      DIMENSION X(N), Y(N)  
C95 
      DIMENSION NOW(N), NUW(N)  
      DIMENSION YAXIS(6), XAXIS(6)  
      CHARACTER * 1  BLANK, STAR, CH(78)
      DATA BLANK, STAR / ' ', '*' / 
      KTEST = 0 
      SY  = 0.0 
      SYY = 0.0 
      SX  = 0.0 
      SXX = 0.0 
      SXY = 0.0 
      YMIN = Y(1)   
      YMAX = YMIN   
      XMAX = X(N) * 1.125   
      W = FLOAT(N)  
C95 WWW 
      WWW = 0.  
      DO 150  I=1,N 
C95 WW  
      WW = MAX0 (1, NOW(I) - NUW(I) )   
      WWW = WWW + WW
      IF (Y(I).LT.YMIN)  YMIN = Y(I)
      IF (YMAX.LT.Y(I))  YMAX = Y(I)
      SY  = SY  + WW * Y(I) 
      SYY = SYY + WW * Y(I)**2  
      SX  = SX  + WW * X(I) 
      SXX = SXX + WW * X(I)**2  
  150 SXY = SXY + WW * X(I)*Y(I)
      S = (SY*SX - WWW*SXY) / (SX*SX - WWW*SXX) 
      C = (SY - S*SX) / WWW 
C95   R = SQRT((SYY+S*S*SXX+C*C*W-2.*(S*SXY+C*SY-S*C*SX))/(W-1.))   
Cerr: R = SQRT((SYY+S*S*SXX+C*C*WWW - 2.*(S*SXY+C*SY-S*C*SX))/(WWW-1.)) 
C        Calc. finished; print (20 grids down, 78 grids horizontal) 
C         (CS4078 is for greater print: 40 grids down, 78 grids horiz.) 
      YSCAL = 0.2 * (YMAX-YMIN) 
      YMAX = YMAX + YSCAL   
      YMIN = YMIN - YSCAL   
      YSCAL = YMAX - YMIN   
      YFAC = 20./YSCAL  
      XFAC = 80./XMAX   
      YAXIS(1) = YMAX   
      XAXIS(1) = 0.00001
      DO 210  I=2,6 
      FI1 = FLOAT(I-1)  
      XAXIS(I) = XMAX/5.0*FI1   
  210 YAXIS(I) = YMAX - (YSCAL/5.*FI1)  
C        print upper line   
      CALL KERNZ1 (STAR, CH, 78)
      WRITE (LIS2, 220)  STAR, YAXIS(1), (CH(II),II=7,78)   
  220 FORMAT (' ', A1, F5.2, ' ', 72A1) 
      M = 2 
      DO 260  I=2,19
      FI20 = FLOAT(20 - I)  
      CALL KERNZ1 (BLANK, CH, 78)   
      CH(1) = '*'   
      L  = ((YMIN + (YSCAL*  FI20)     /20.) -C)/S*XFAC + 0.5   
      L1 = ((YMIN + (YSCAL* (FI20-1.)) /20.) -C)/S*XFAC + 0.5   
      IF (L.GT.0 .AND. L.LE.78) CH(L) = '.' 
C        print rest of the line (if small slope, not enough points) 
      IF (ABS(L1-L).LE.5) GOTO 229  
      IF (S.LT.0.00001) THEN
          I1 = L + 3
          I2 = L1 - 3   
      ELSE  
          I1 = L1 + 3   
          I2 = L - 3
          ENDIF 
      IF (I1.LE. 1) I1 = 2  
      IF (I2.GT.78) I2 = 78 
      DO 225 I12=I1,I2,3
  225 CH(I12) = '.' 
  229 DO 230  J=1,N 
      K = (Y(J)-YMIN)*YFAC + 0.5 + FLOAT(I) 
      L = X(J)*XFAC + 0.5   
      IF (K.EQ.20 .AND. L.LE.78)  CH(L) = 'X'   
      IF (K.EQ.20 .AND. L.GT.78)  CH(78)= '+'   
  230 CONTINUE  
      IF (I/4*4.EQ.I)  GOTO 250 
      WRITE (LIS2, 240)  CH 
  240 FORMAT (1H , 78A1)
      GOTO 260  
  250 WRITE (LIS2, 220)  STAR, YAXIS(M), (CH(II), II=7,78)  
      M = M + 1 
  260 CONTINUE  
C        print last line(s) 
      CALL KERNZ1 (STAR, CH, 78)
      WRITE (LIS2, 220)  STAR, YAXIS(6), (CH(II), II=7,78)  
      WRITE (LIS2, 270)  (XAXIS(II), II=2,6)
  270 FORMAT (F15.3, 4F16.3)
      WRITE (LIS2, 280) 
  280 FORMAT (60X, '(sinTHETA/LAMBDA)**2')  
C95   IF (SWIPRI)  WRITE (LIS2, 290) N, S, C, R 
      IF (SWIPRI)  WRITE (LIS2, 290) N, S, C
  290 FORMAT (/' Line based on', I10, ' points,    slope is ', F10.4, / 
     *        ' intercept is ', F10.4)  
C95  *        ' intercept is ', F10.4, ' and error of fit is ', F10.4)  
      RETURN
C        END OF SUBR. WILDUP
      END   
CSUBROUTINE ERFU (X)
C-----------------------------------------------------------------------
C ERFU (X)  a fast but simple approximation of the error function erf(x)
C For   X =  0.   0.1      0.2     .....    3.0           .. and linear 
C ERFU(X) =  0.   0.11246  0.22270 .....    0.99998       interpolation 
C Argument X must be positive   
C+----------------------------------------------------------------------
      FUNCTION ERFU (X) 
      DIMENSION E(31)   
      DATA E / .00000, .11246, .22270, .32863, .42839,  
     *         .52050, .60386, .67780, .74210, .79691,  
     *         .84270, .88021, .91031, .93401, .95229,  
     *         .96611, .97635, .98379, .98909, .99279,  
     *         .99532, .99702, .99814, .99886, .99931,  
     *         .99959, .99976, .99987, .99992, .99996, .99998 / 
      X10 = X*10. + 1.00001 
C ERFU(X) =       0.00000   0.11246  0.22270 .....    0.99998   
C = E(IX) for IX  = 1       = 2      = 3 ....        = 31   
      IX = X10  
      IF (IX.GT.30) GOTO 100
      ERFU = E(IX) + (X10-IX) * (E(IX+1)-E(IX)) 
      RETURN
  100 ERFU = 1. 
      RETURN
C        END OF SUBROUTINE FUNCTION ERFU  ==ERROR FUNCTION== APPR.  
      END   
CSUBFUNCTION IPHFIX (HKL)   
C-----------------------------------------------------------------------
C Type of reflection
C Type = 1, 2, 3, 4 .. for: general, 0(+180), 30(+180), 45(+180), ..
C IPHFIX = -1 reflection gives impossible phase restriction 
C ---- used in PHASEX and DDMAIN
C+----------------------------------------------------------------------
      FUNCTION IPHFIX (HKL) 
C     ------ /CRYSA/ and /CRYSB/ stores most important crystal data 
      COMMON /CRYSA/ CELL(6),  CELLSD(6),   RCELL(6),   VOLUM,  
     *               WAVE,     CELALL(10),  AMOLW,      ZET,
     *               NELEC,    F000,        ABSMU,      ICENT,  
     *               ILATT,    ISYST,       ILAUE,      IMULT,  
     *               IUNIQ,    IPOLA,       NTYPE,      NSYMM,  
     *         IRSYMM(3,3,24), TSYMM(3,24), NLATT,      TLATT(3,4), 
     *         FRAC2C(3,3),    CART2F(3,3), RRMAT(3,3), SSMAT(3,3)  
      DIMENSION  HKL(3), ICODE(13), LTEST(3), IHKL(3)   
      DATA ICODE / 2, -1, 9, 8, 7, -1, 6, -1, 5, 4, 3, -1, 2 /  
C         integer form of HKL   
      CALL KERF2I (HKL, IHKL, 3)
      IF(ICENT.EQ.1) GOTO 150   
C         centric, restriction 0 or 180 
      IPHFIX = 2
      RETURN
C        non-centric
  150 IPHFIX = 1
      IOLD = -1 
      DO 180 I=2,NSYMM  
      XTEST = 0.0   
      KTEST = 0 
C        test if HKL = -HKLEX   
      DO 170 J=1,3  
      LTEST(J) = 0  
      DO 160 L=1,3  
  160 LTEST(J) = LTEST(J) + IHKL(L)*IRSYMM(L,J,I)   
      KTEST = KTEST + IHKL(J) + LTEST(J)
      IF (KTEST.NE.0) GOTO 180  
C        apply phase shift  
  170 XTEST = XTEST - (HKL(J) * TSYMM(J,I)) 
      XTEST = XTEST - IFIX(XTEST)   
      IF (XTEST.LT.-0.01) XTEST = XTEST + 1.0   
      IPHS = IFIX(12.*XTEST+0.1) + 1
      IPHFIX = ICODE(IPHS)  
      IF (IOLD.EQ.-1) IOLD = IPHFIX 
      IF (IPHFIX.NE.IOLD) GOTO 190  
  180 CONTINUE  
      IF (IPHFIX.GE.1) RETURN   
C        error  
  190 IPHFIX = -1   
      RETURN
C        end of FUNCTION IPHFIX 
      END   
CSUBFUNCTION E2EXP (ITYP, E1, E2)   
C-----------------------------------------------------------------------
C FUNCTION  E2EXP   
C ITYP = 0 for general refl., no phase restriction  
C ITYP = 1, 2, 3 ...  for special refl. (centric: all refl.)
C Input:  E1 and E2   (E2 MAX = 6.) 
C Output: a priori expectation value for E**2   
C Used in prgrams PHASEX and DDMAIN 
C Subroutine used:  SIMW
C+----------------------------------------------------------------------
      FUNCTION E2EXP (ITYP, E1, E2) 
      EX1 = E1 * E1 
      EX2 = E2 * E2 
      IF (ITYP.NE.0) GOTO 100   
      Q = (EX2-EX1) / 2.0   
      E2EXP = EX1 + Q * (1. - SIMW(Q))  
      RETURN
  100 EXX1 = EXP(-EX1*.5)   
      EX3 = EXX1 / (EXX1 + EXP(-EX2*.5) )   
      E2EXP = EX1*EX3 + (1.0 - EX3)*EX2 
      RETURN
C        END OF FUNCTION E2EXP  
      END   
CSUBFUNCTION SIMW (Q)   
C-----------------------------------------------------------------------
C Function SIMW (Q) :  Calculate  I1(Q)/I0(Q)    =Bessel functions= 
C      Germain, Main + Woolfson, A.C. (1970)  B26,  274 - 285   
C Q must be positive
C formula for SIMW is valid up to Q = 5 with max. error of 4 prec.  
C for Q = 5 this formula gives SIMW(5) = 0.894  
C for larger Q: use linear extrapolation:   
C    in SFANDB Q is calculated as Q=(E2**2 - E1**2)/2   
C    E2 MAX = 6, and therefor Q MAX = 18.   
C    the present extrapolation gives SIMW(18) = 0.9915  
C Used in E2EXP (PHASEX, DDMAIN)
C+----------------------------------------------------------------------
      FUNCTION  SIMW (Q)
      SIMW = ((0.0106 * Q - 0.1304) * Q + 0.5658) * Q   
      IF (Q.GT.5.) SIMW=0.8565 + 0.0075*Q   
      RETURN
C        END OF FUNCTION  SIMW  
      END   
CSUBROUTINE MATC2F (CELL, CX)   
C-----------------------------------------------------------------------
C Generate transformation matrix CX = CART2F(3,3)   
C for conversion of Cartesian coordinates into fractional   
C Input: CELL(6) = A, B, C (ANGSTROM), Alpha, Beta, Gamma (degree's)
C Note:  the matrix CX = CART2F can be applied by subroutine MAT6XV 
C+----------------------------------------------------------------------
      SUBROUTINE MATC2F (CELL, CX)  
      DIMENSION CELL(6), CX(3,3)
      DIMENSION CELLT(6)
      EQUIVALENCE (A   ,CELLT(1)),  (B   ,CELLT(2)) 
      EQUIVALENCE (C   ,CELLT(3)),  (ALPH,CELLT(4)) 
      EQUIVALENCE (BET ,CELLT(5)),  (GAMM,CELLT(6)) 
      CALL KERNAB (CELL, CELLT, 6)  
C        D2R=DTOR=0.01745329252=1/RAD   
      D2R = ATAN(1.0) / 45.0
      ALPHA = ALPH * D2R
      BETA = BET * D2R  
      GAMMA = GAMM * D2R
      COSA = COS(ALPHA) 
      SINA = SIN(ALPHA) 
      COSB = COS(BETA)  
      SINB = SIN(BETA)  
      COSC = COS(GAMMA) 
      SINC = SIN(GAMMA) 
      S = 0.5*(ALPHA+BETA+GAMMA)
      V = A*B*C *2. *SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA)) 
C        CARTESIAN-TO-CRYSTAL TRANSFORMATION MATRIX 
      CX(1,1) = 1./A
      CX(1,2) = -COSC/(A*SINC)  
      CX(1,3) = B*C*(COSC*COSA-COSB)/(V*SINC)   
      CX(2,1) = 0.  
      CX(2,2) = 1./(B*SINC) 
      CX(2,3) = A*C*(COSB*COSC-COSA)/(V*SINC)   
      CX(3,1) = 0.  
      CX(3,2) = 0.  
      CX(3,3) = A*B*SINC/V  
      RETURN
C        END OF SUBROUTINE MATC2F   
      END   
CSUBROUTINE MATF2C (CELL, XC)   
C-----------------------------------------------------------------------
C Generate transformation matrix XC = FRAC2C(3,3)   
C for conversion of fractional coordinates into Cartesian   
C Input: CELL(6) = A, B, C (ANGSTROM), Alpha, Beta, Gamma (degree's)
C Note:  the matrix XC = FRAC2C can be applied by subroutine MAT6XV 
C+----------------------------------------------------------------------
      SUBROUTINE MATF2C (CELL, XC)  
      DIMENSION CELL(6), XC(3,3)
      DIMENSION CELLT(6)
      EQUIVALENCE (A   ,CELLT(1)),  (B   ,CELLT(2)) 
      EQUIVALENCE (C   ,CELLT(3)),  (ALPH,CELLT(4)) 
      EQUIVALENCE (BET ,CELLT(5)),  (GAMM,CELLT(6)) 
      CALL KERNAB (CELL, CELLT, 6)  
C        D2R=DTOR=0.01745329252=1/RAD   
      D2R = ATAN(1.0) / 45.0
      ALPHA = ALPH * D2R
      BETA = BET * D2R  
      GAMMA = GAMM * D2R
      COSA = COS(ALPHA) 
      SINA = SIN(ALPHA) 
      COSB = COS(BETA)  
      SINB = SIN(BETA)  
      COSC = COS(GAMMA) 
      SINC = SIN(GAMMA) 
      S = 0.5*(ALPHA+BETA+GAMMA)
      V = A*B*C *2. *SQRT(SIN(S)*SIN(S-ALPHA)*SIN(S-BETA)*SIN(S-GAMMA)) 
C        CRYSTAL-TO-CARTESIAN TRANSFORMATION MATRIX 
      XC(1,1) = A   
      XC(1,2) = B*COSC  
      XC(1,3) = C*COSB  
      XC(2,1) = 0.  
      XC(2,2) = B*SINC  
      XC(2,3) = -C*(COSB*COSC-COSA)/SINC
      XC(3,1) = 0.  
      XC(3,2) = 0.  
      XC(3,3) = V/(A*B*SINC)
      RETURN
C        END OF SUBROUTINE MATF2C   
      END   
CSUBROUTINE VECAXB (A, B, V)
C-----------------------------------------------------------------------
C Vector cross product: V = A x B                          was: VMULT   
C Input:  vectors A(3) and B(3) 
C Output: vector V(3) = cross product V = A x B 
C Note: V may use the same location as A or B   
C+----------------------------------------------------------------------
      SUBROUTINE VECAXB (A, B, V)   
      DIMENSION A(3), B(3), V(3)
**    V(1) = A(2) * B(3) - A(3) * B(2)  
**    V(2) = A(3) * B(1) - A(1) * B(3)  
      T1   = A(2) * B(3) - A(3) * B(2)  
      T2   = A(3) * B(1) - A(1) * B(3)  
      V(3) = A(1) * B(2) - A(2) * B(1)  
      V(1) = T1 
      V(2) = T2 
      RETURN
C        END OF SUBROUTINE VECAXB   
      END   
CSUBROUTINE MATAXB (A, B, P)
C-----------------------------------------------------------------------
C Matrix multiplication P = A X B   
C Input:  matrices A(3,3) and B(3,3)
C Output: matrix   P(3,3) = matrix product P = A X B
C+----------------------------------------------------------------------
      SUBROUTINE MATAXB (A, B, P)   
      DIMENSION A(3,3), B(3,3), P(3,3)  
      DO 112 K = 1, 3   
      DO 111 L = 1, 3   
      P(K,L) = A(K,1) * B(1,L) + A(K,2) * B(2,L) + A(K,3) * B(3,L)  
  111 CONTINUE  
  112 CONTINUE  
      RETURN
C        END OF SUBROUTINE MATAXB   
      END   
CSUBROUTINE MATAXI (IA, IB, IP) 
C-----------------------------------------------------------------------
C Matrix multiplication IP = IA X IB for integer matrices   
C Input:  matrices IA(3,3) and IB(3,3)  
C Output: matrix   IP(3,3) = matrix product IP = IA X IB
C+----------------------------------------------------------------------
      SUBROUTINE MATAXI (IA, IB, IP)
      DIMENSION IA(3,3), IB(3,3), IP(3,3)   
CJMS 28-1-92 Please keep following explicit CONTINUE statements 
C            to prevent degrading of optimisation by FTN77  
      DO 112 I = 1, 3   
      DO 111 J = 1, 3   
      IP(I,J) = IA(I,1) * IB(1,J) +IA(I,2) * IB(2,J) +IA(I,3) * IB(3,J) 
  111 CONTINUE  
  112 CONTINUE  
      RETURN
C        END OF SUBROUTINE MATAXI   
      END   
CSUBROUTINE MAT6XV (XC, X, C)   
C-----------------------------------------------------------------------
C Transform vector V by matrix XC (only 6 elements used).       Purpose:
C Transform fractional atomic parameters to Cartesian parameters
C or vv. :  Cartesian parameters to fractional atomic parameters.   
C (the other 3 elem. are supposed to be zero, and are not used.)
C Purpose:        Fractional to Cartesian    || Cartesian to fractional 
C Input:  XC(3,3) = FRAC2C matrix            || XC = CART2F matrix  
C         X(3)    = fractional coords x,y,z  || X  = Cartesian coords.  
C Output: C(3)    = Cartesian  coords x,y,z  || C  = fractional coords. 
C Note: XC(2,1), XC(3,1) and XC(3,2),  which must be 0, are not used.   
C Note: vector C may use the same location as vector X. 
C The matrix multiplication for the two tranformations are the same.
C These matrices for the present CCODE are given in COMMON /CRYSA/ .
C-----------------------------------------------------------------------
      SUBROUTINE MAT6XV (XC, X, C)  
      DIMENSION XC(3,3), X(3), C(3) 
      C(1) = X(1)*XC(1,1) + X(2)*XC(1,2) + X(3)*XC(1,3) 
      C(2) =                X(2)*XC(2,2) + X(3)*XC(2,3) 
      C(3) =                               X(3)*XC(3,3) 
      RETURN
C        END OF SUBROUTINE MAT6XV   
      END   
CSUBROUTINE MATXV3 (RR, A, B)   
C-----------------------------------------------------------------------
C Multiplication of matrix and vector:      RR   x   A   ==>   B
C Input : RR(3,3) matrx             | 11 12 13 |   | 1 |     | 1 |  
C         A(3)   vector             | 23 22 23 | x | 2 | ==> | 2 |  
C Output: B(3)   vector             | 31 32 33 |   | 3 |     | 3 |  
C E.G. symm: x.new = RR(1,1) x.old  +  RR(1,2) y.old  +  RR(1,3) z.old  
C The transposed matrix is needed for hkl transformation, see VXMATI
C Note: A and B may use the same location   
C+----------------------------------------------------------------------
      SUBROUTINE MATXV3 (RR, A, B)  
      DIMENSION RR(3,3), A(3), B(3) 
**    B(1) = RR(1,1) * A(1) + RR(1,2) * A(2) + RR(1,3) * A(3)   
**    B(2) = RR(2,1) * A(1) + RR(2,2) * A(2) + RR(2,3) * A(3)   
      T1   = RR(1,1) * A(1) + RR(1,2) * A(2) + RR(1,3) * A(3)   
      T2   = RR(2,1) * A(1) + RR(2,2) * A(2) + RR(2,3) * A(3)   
      B(3) = RR(3,1) * A(1) + RR(3,2) * A(2) + RR(3,3) * A(3)   
      B(1) = T1 
      B(2) = T2 
      RETURN
C       END OF SUBR MATXV3  
      END   
CSUBROUTINE VXMATI (K, IR, L)   
C-----------------------------------------------------------------------
C Multiplication of integer:  vector K   x   matrix IR    ==>  vector L 
C Input : K(3)   vector       (1, 2, 3)  x  | 11 12 13 |  ==>  (1, 2, 3)
C         IR(3,3) matrx                     | 21 22 23 |
C Output: L(3)   vector                     | 31 32 33 |
C EG. symm: h.new = h.old x RR(1,1) + k.old x RR(2,1) + l.old x RR(3,1) 
C The transposed matrix is needed for xyz transformation: see MATXV3
C Note: K and L may use thesame location
C+----------------------------------------------------------------------
      SUBROUTINE VXMATI (K, IR, L)  
      DIMENSION K(3), IR(3,3), L(3) 
**    L(1) = K(1) * IR(1,1)  + K(2) * IR(2,1)  + K(3) * IR(3,1) 
**    L(2) = K(1) * IR(1,2)  + K(2) * IR(2,2)  + K(3) * IR(3,2) 
      L1   = K(1) * IR(1,1)  + K(2) * IR(2,1)  + K(3) * IR(3,1) 
      L2   = K(1) * IR(1,2)  + K(2) * IR(2,2)  + K(3) * IR(3,2) 
      L(3) = K(1) * IR(1,3)  + K(2) * IR(2,3)  + K(3) * IR(3,3) 
      L(1) = L1 
      L(2) = L2 
      RETURN
C       END OF SUBR VXMATI  
      END   
CSUBROUTINE VMATV1 (A, R, B, Q) 
C-----------------------------------------------------------------------
C Perform the vector-matrix-vector multiplication   
C Input:  A = 3-dim. array containing fractional coordinates.   
C         R = 3 * 3 matrix. 
C         B = 3-dim. array containing fractional coordinates.   
C Output: Q = A * R * B = scalar
C+----------------------------------------------------------------------
      SUBROUTINE VMATV1 (A, R, B, Q)
      DIMENSION  A(3), R(3,3), B(3) 
      Q=A(1) * (R(1,1) * B(1) + R(1,2) * B(2) + R(1,3) * B(3)) +
     *  A(2) * (R(2,1) * B(1) + R(2,2) * B(2) + R(2,3) * B(3)) +
     *  A(3) * (R(3,1) * B(1) + R(3,2) * B(2) + R(3,3) * B(3))  
      RETURN
C        END OF SUBROUTINE VMATV1 / END of all NIJX subfiles
      END   
